SystemOrganization addCategory: #Coral!
SystemOrganization addCategory: #'Coral-DeadCode'!

RBParser subclass: #SaphirParser
	instanceVariableNames: 'classParseIn'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Coral'!

!SaphirParser class methodsFor: 'parsing' stamp: 'ms 8/24/2006 15:14'!
parseDoIt: stringOrStream

	| sequence |
	sequence := self
		parseStream: stringOrStream readStream
		startingAt: self startingStateForSequenceScript.
	"^ (RBDoItNode body: sequence)
		source: stringOrStream contents"! !

!SaphirParser class methodsFor: 'parsing' stamp: 'Gwenael.Casaccio 12/9/2008 13:09'!
parseScript: stringOrStream

	^ self parseScript: stringOrStream onError: nil.! !

!SaphirParser class methodsFor: 'parsing' stamp: 'ms 10/28/2006 23:52'!
parseScript: stringOrStream in: class
	
	| aStream |
	aStream := stringOrStream readStream.
	aStream atEnd ifTrue: [^#()].
	^self
		parseStream: aStream
		startingAt: self startingStateForSequenceScript in: class! !

!SaphirParser class methodsFor: 'parsing' stamp: 'Gwenael.Casaccio 12/9/2008 13:18'!
parseScript: stringOrStream onError: aBlock

	| parser |
	parser := self new.
	parser errorBlock: aBlock.
	parser initializeParserWith: stringOrStream type: #on:errorBlock:.
	^ parser parseScript: stringOrStream! !

!SaphirParser class methodsFor: 'parsing' stamp: 'ms 10/28/2006 23:53'!
parseStream: aStream startingAt: anInteger in: class
	| parser |
	parser := self on: aStream.
	parser setStartingState: anInteger.
	parser classParseIn: class.
	^parser parse! !

!SaphirParser class methodsFor: 'generated-comments' stamp: 'ms 11/17/2007 10:44'!
parserDefinitionComment

	"%id <name> <number> <negativeNumber> <binarySymbol> <period>;
%start MethodPattern;

SequenceScript:
	ScriptList									{#first:};
			
Sequence:
	Statements									{#sequence:}
|	Temporaries Statements						{#sequenceWithTemps:};
						

MethodPattern:
	<name>										{#unaryMessage:}
|	<binarySymbol> Variable						{#messagePart:}
|	KeywordMethodPattern						{#first:};

							
KeywordMethodPattern:
	<keyword> Variable							{#messagePart:}
|	KeywordMethodPattern <keyword> Variable	{#addMessagePart:};

Pragmas:
	""<"" PragmaMessage "">""						{#pragma:}
|	Pragmas ""<"" PragmaMessage "">""				{#pragmas:};
							
MethodCore:
	Sequence									{#method:}
|	Pragmas Sequence							{#methodPragma:}
|	Pragmas Temporaries Pragmas Statements	{#methodPragmaTempsPragma:}
|	Temporaries Pragmas Statements				{#methodTempsPragma:};
							
ScriptMethodDeclaration:
	ScriptMethodCalssDeclaration					{#first:}
|	ScriptMethodInstDeclaration					{#first:}
|	ScriptMethod								{#first:};
														
ScriptMethod:
 	MethodPattern ""["" MethodCore ""]""				{#scriptMethod:};
		
ScriptMethodCalssDeclaration:
	Variable ""class"" MethodPattern ""["" MethodCore ""]""	{#declareClassMethod:};
		
ScriptMethodInstDeclaration:
	Variable MethodPattern ""["" MethodCore ""]""	{#declareMethod:};

Temporaries:
	""||""											{#array}
|	""|"" TemporaryVariables ""|""					{#second:};

TemporaryVariables:
												{#array}
|	TemporaryVariables Variable				{#add:};

Statements:
												{#array}
|	StatementList <period>?						{#first:}
|	StatementList <period> ""^"" Expression <period>?	{#returnAdd:}
|	""^"" Expression <period>?						{#return:};
							
StatementList:
	Expression									{#firstIn:}
|	StatementList <period> Expression				{#add3:};
	
ScriptList:
	ScriptMethodDeclaration						{#firstIn:}
|	ScriptList ScriptMethodDeclaration			{#add2:};	

Block:
	""["" BlockArgs ""|"" Sequence ""]""					{#blockWithArgs:}
|	""["" Sequence ""]""								{#blockNoArgs:}
|	""["" BlockArgs ""]""								{#blockArgs:}
|	""["" BlockArgs ""||"" TemporaryVariables ""|"" Statements ""]"" {#blockWithTemps:};

BlockArgs:
	"":"" Variable									{#secondIn:}
|	BlockArgs "":"" Variable						{#add3:};

Expression:
	Assignment									{#first:}
|	Cascade										{#first:}
|	Primary									{#first:};

Primary:
	""("" Expression "")""								{#second:}
|	Array										{#first:}
|	Block										{#first:}
|	Literal										{#first:}
|	Variable									{#first:};

Assignment:
	Variable <assignment> Expression				{#assignment:};

Cascade:
	MessageSend								{#first:}
|	Cascade "";"" Message							{#cascade:};

MessageSend:
	KeywordMessageSend						{#first:}
|	BinaryMessageSend							{#first:}
|	UnaryMessageSend							{#first:};

Message:
	UnaryMessage								{#first:}
|	BinaryMessage								{#first:}
|	KeywordMessage							{#first:};

KeywordMessageSend:
	BinaryMessageSend KeywordMessage			{#messageSend:}
|	UnaryMessageSend KeywordMessage			{#messageSend:}
|	Primary KeywordMessage					{#messageSend:};

KeywordMessage:
	<keyword> KeywordArgument				{#messagePart:}
|	KeywordMessage <keyword> KeywordArgument {#addMessagePart:};

KeywordArgument:
	BinaryMessageSend							{#first:}
|	UnaryMessageSend							{#first:}
|	Primary									{#first:};

BinaryMessageSend:
	BinaryMessageSend BinaryMessage			{#messageSend:}
|	UnaryMessageSend BinaryMessage			{#messageSend:}
|	Primary BinaryMessage						{#messageSend:};

BinaryMessage :
	<binarySymbol> BinaryArgument				{#messagePart:};

BinaryArgument:
	UnaryMessageSend							{#first:}
|	Primary									{#first:};

UnaryMessageSend :
	UnaryMessageSend UnaryMessage			{#messageSend:}
|	Primary UnaryMessage						{#messageSend:};

UnaryMessage :
	<name>										{#unaryMessage:};

Array:
	""{"" Statements ""}""								{#array:};

Variable:
	<name>										{#variable:};

Literal:
	""true""										{#litTrue:}
|	""false""										{#litFalse:}
|	""nil""										{#litNil:}
|	<number>									{#litNumber:}
|	<negativeNumber>							{#litNumber:} 
|	<character>									{#litChar:}
|	<string>										{#litString:}
|	""#"" <string>									{#litStringSymbol:}
|	""#"" <name>									{#litSymbol:}
|	""#"" <binarySymbol>							{#litSymbol:}
|	""#"" <keyword>								{#litSymbol:}
|	""#"" <multikeyword>							{#litSymbol:}
|	""#"" <alternateKeyword>						{#litSymbol:}
|	""#"" ""["" ByteArray ""]""							{#litArray:}
|	""#"" ""("" LiteralArray "")""						{#litArray:}
|	""#:""								{#litString:};

ByteArray:
												{#byteStream}
|	ByteArray <number>							{#byteStreamPut:};

LiteralArray:
												{#stream}
|	LiteralArray ArrayLiteral					{#streamPut:};

ArrayLiteral:
	Literal										{#value:}
|	<name>										{#valueSymbol:}
|	<binarySymbol>								{#valueSymbol:}
|	<keyword>									{#valueSymbol:}
|	<multikeyword>								{#valueSymbol:}
|	<alternateKeyword>							{#valueSymbol:}
|	""("" LiteralArray "")""							{#contents2:}
|	""["" ByteArray ""]""							{#contents2:}
|	<anyChar>									{#valueSymbol:};

PragmaMessage:
	Apicall										{#messagePragma:}
| 	Primitive 									{#messagePragma:} 
|	MessagePragma 								{#messagePragma:};

MessagePragma:
	KeyWordMessagePragma						{#pragmaKeyWordMessage:}
|	UnaryMessage 								{#pragmaUnaryMessage:};
										
KeyWordMessagePragma:
	<keyword> PrimaryPragma					{#messagePart:}
|	KeywordMessage <keyword> PrimaryPragma	{#addMessagePart:};

PrimaryPragma:
	Array										{#first:}
|	Block										{#first:}
|	Literal										{#first:}
|	Variable									{#first:};

Apicall:
	TypeCall ExternalType IndexName ""("" ParameterApicall "")""					{#externalCall:}
|	TypeCall ExternalType IndexName ""("" ParameterApicall "")"" ""module:"" <string>	{#externalModuleCall:};

IndexName:
	<string>										{#externalFunction:}
|	<number>									{#externalIndex:};

TypeCall:
	""apicall:""									{#callConvention:}
|	""cdecl:""										{#callConvention:};

ParameterApicall:
	ExternalType 								{#parameterExtCall:}
|	ParameterApicall ExternalType 				{#parametersExtCall:};

ExternalType:
	<name>										{#externalType:}	
|	<name> ""*""									{#externalTypePointer:};

Primitive:
	""primitive:"" <string>							{#primitiveString:}
|	""primitive:"" <number>						{#primitiveNumber:}
|	""primitive:"" <string> ""module:"" <string>		{#primitiveModule:};"! !

!SaphirParser class methodsFor: 'generated-accessing' stamp: 'ms 11/17/2007 10:44'!
scannerClass
	^SaphirScanner! !

!SaphirParser class methodsFor: 'generated-starting states' stamp: 'ms 11/17/2007 10:44'!
startingStateForMethodPattern
	^2! !

!SaphirParser class methodsFor: 'generated-starting states' stamp: 'ms 11/17/2007 10:44'!
startingStateForSequenceScript
	^1! !

!SaphirParser methodsFor: 'private' stamp: 'ms 8/23/2006 11:19'!
actionForCurrentToken

	| ids action |
	ids := currentToken id.
	1 to: ids size do: [:i | 
		action := self actionFor: (ids at: i).
		(action bitAnd: self actionMask) = self errorAction ifFalse: [^ action].

		"Convert negative number to binarySymbol"
		(self isNegativeNumberId:(ids at: i)) ifTrue: [
			^self negativeNumberToBinaryString].

		"Ignore repeating periods"
		(self isEmptyStatementId: (ids at: i)) ifTrue: [
			^ self ignoreEmptyStatement].

	].
	^ self errorAction! !

!SaphirParser methodsFor: 'reduction actions' stamp: 'ms 8/25/2006 23:02'!
add2: nodes

	^ nodes first copyWith: nodes second! !

!SaphirParser methodsFor: 'reduction actions' stamp: 'ms 8/23/2006 11:19'!
add3: nodes

	^ nodes first copyWith: nodes third! !

!SaphirParser methodsFor: 'reduction actions' stamp: 'ms 8/23/2006 11:19'!
add: nodes

	^ nodes first copyWith: nodes second! !

!SaphirParser methodsFor: 'reduction actions' stamp: 'ms 10/28/2006 12:13'!
addAll2: nodes
	
	^ nodes first, nodes second! !

!SaphirParser methodsFor: 'reduction actions' stamp: 'ms 8/25/2006 23:20'!
addIn2: nodes

	^ nodes first copyWith: nodes second first! !

!SaphirParser methodsFor: 'reduction actions' stamp: 'ms 8/23/2006 11:19'!
addMessagePart: nodes

	^ {nodes first first copyWith: nodes second.
	   nodes first second copyWith: nodes third}! !

!SaphirParser methodsFor: 'reduction actions' stamp: 'ms 8/23/2006 11:19'!
array

	^ #()! !

!SaphirParser methodsFor: 'reduction actions' stamp: 'ms 8/23/2006 11:19'!
array: nodes

	^ RBArrayNode
		leftBrace: nodes first start
		rightBrace: nodes third stop
		statements: nodes second! !

!SaphirParser methodsFor: 'reduction actions' stamp: 'ms 8/23/2006 11:19'!
assignment: nodes

	^ RBAssignmentNode
		variable: nodes first
		value: nodes third! !

!SaphirParser methodsFor: 'reduction actions' stamp: 'ms 8/23/2006 11:19'!
blockArgs: nodes

	^ (RBBlockNode
		arguments: nodes second
		body: (RBSequenceNode statements: #()))
		left: nodes first start;
		right: nodes third stop! !

!SaphirParser methodsFor: 'reduction actions' stamp: 'ms 8/23/2006 11:19'!
blockNoArgs: nodes

	^ (RBBlockNode
		body: nodes second)
		left: nodes first start;
		right: nodes third stop! !

!SaphirParser methodsFor: 'reduction actions' stamp: 'ms 8/23/2006 11:19'!
blockWithArgs: nodes

	^ (RBBlockNode
		arguments: nodes second
		body: nodes fourth)
		left: nodes first start;
		right: nodes fifth stop! !

!SaphirParser methodsFor: 'reduction actions' stamp: 'ms 8/23/2006 11:19'!
blockWithTemps: nodes

	^ (RBBlockNode
		arguments: nodes second
		body: (RBSequenceNode
			temporaries: nodes fourth
			statements: nodes sixth))
		left: nodes first start;
		right: nodes seventh stop! !

!SaphirParser methodsFor: 'reduction actions' stamp: 'ms 8/23/2006 11:19'!
byteStream

	^ ByteArray new writeStream! !

!SaphirParser methodsFor: 'reduction actions' stamp: 'ms 8/23/2006 11:19'!
byteStreamPut: nodes

	^ nodes first
		nextPut: nodes second value asNumber;
		yourself! !

!SaphirParser methodsFor: 'reduction actions' stamp: 'ms 8/23/2006 11:19'!
callConvention: nodes
	| descriptorClass |
	descriptorClass := Smalltalk at: #ExternalFunction ifAbsent:[nil].
	^descriptorClass callingConventionFor: nodes first value.! !

!SaphirParser methodsFor: 'reduction actions' stamp: 'ms 8/23/2006 11:19'!
cascade: nodes

	^ (nodes first isKindOf: RBMessageNode)
		ifTrue: [RBCascadeNode messages:
			{nodes first.
			 RBMessageNode new
				receiver: nodes first receiver
				selectorParts: nodes third first
				arguments: nodes third last}]
		ifFalse: [RBCascadeNode messages:
			(nodes first messages copyWith:
				(RBMessageNode new
					receiver: nodes first messages first receiver
					selectorParts: nodes third first
					arguments: nodes third last))]! !

!SaphirParser methodsFor: 'accessing' stamp: 'ms 10/28/2006 16:16'!
classParseIn
	
	^classParseIn! !

!SaphirParser methodsFor: 'accessing' stamp: 'ms 10/28/2006 16:17'!
classParseIn: aClass
	
	classParseIn := aClass! !

!SaphirParser methodsFor: 'reduction actions' stamp: 'ms 8/23/2006 11:19'!
contents2: nodes

	^ nodes second contents! !

!SaphirParser methodsFor: 'reduction actions' stamp: 'ms 10/27/2006 17:02'!
declareClassMethod: nodes

	| rbDeclare |
	rbDeclare :=  RBMethodDeclarationNode new
		selectorParts: nodes third first
		arguments: nodes third last;
		body: nodes fifth body;
		classSide: true;
		classNodeVar: nodes first.
	nodes fifth pragmas ifNotNil: [rbDeclare pragmas: nodes fifth pragmas ].
	^rbDeclare source: rbDeclare sourceText asString; yourself! !

!SaphirParser methodsFor: 'reduction actions' stamp: 'ms 10/28/2006 16:02'!
declareMethod: nodes

	| rbDeclare |
	rbDeclare :=  RBMethodDeclarationNode new
		selectorParts: nodes second first
		arguments: nodes second last;
		body: nodes fourth body;
		classSide: false;
		classNodeVar: nodes first.
	nodes fourth pragmas ifNotNil: [rbDeclare pragmas: nodes fourth pragmas ].
	^rbDeclare source:  rbDeclare sourceText asString; yourself! !

!SaphirParser methodsFor: 'reduction actions' stamp: 'ms 8/23/2006 11:19'!
externalCall: nodes
	| fn |
	Smalltalk at: #ExternalLibraryFunction ifPresent:[:xfn|
		fn := xfn name: nodes third
				module: nil 
				callType: nodes first
				returnType: nodes second
				argumentTypes: nodes fifth contents.
	].
	^ OrderedCollection with: (Pragma keyword: #primitive: arguments: #(120)) with: fn with: 120! !

!SaphirParser methodsFor: 'reduction actions' stamp: 'ms 8/23/2006 11:19'!
externalFunction: nodes
	^nodes first value withoutQuoting asSymbol.! !

!SaphirParser methodsFor: 'reduction actions' stamp: 'ms 8/23/2006 11:19'!
externalIndex: nodes
	^nodes first value.! !

!SaphirParser methodsFor: 'reduction actions' stamp: 'ms 8/23/2006 11:19'!
externalModuleCall: nodes
	| fn |
	Smalltalk at: #ExternalLibraryFunction ifPresent:[:xfn|
		fn := xfn name: nodes third 
				module: nodes last value withoutQuoting asSymbol
				callType: nodes first
				returnType: nodes second
				argumentTypes: nodes fifth contents.
	].
	^ OrderedCollection with: (Pragma keyword: #primitive: arguments: #(120)) with: fn with: 120! !

!SaphirParser methodsFor: 'reduction actions' stamp: 'ms 8/23/2006 11:19'!
externalType: nodes
	^self externalTypeOn: nodes
	! !

!SaphirParser methodsFor: 'private' stamp: 'ms 9/4/2006 00:19'!
externalTypeOn: aNode
	| xType descriptorClass |
	descriptorClass := Smalltalk at: #ExternalFunction ifAbsent:[^nil].
	xType := descriptorClass atomicTypeNamed: aNode first value.
	xType == nil ifTrue:["Look up from class scope"
		Symbol hasInterned: aNode first value ifTrue:[:sym|
			xType := descriptorClass structTypeNamed: sym]].
	xType == nil ifTrue:[
		"Raise an error if user is there"
		self interactive ifTrue:[^nil].
		"otherwise go over it silently"
		xType := descriptorClass forceTypeNamed: aNode first value].
	^xType.! !

!SaphirParser methodsFor: 'reduction actions' stamp: 'ms 9/4/2006 00:27'!
externalTypePointer: nodes
	| xType |
	xType := self externalTypeOn: nodes.
	xType ifNil:[^nodes].
	^xType asPointerType! !

!SaphirParser methodsFor: 'reduction actions' stamp: 'ms 10/27/2006 17:55'!
first: nodes

	^ nodes first! !

!SaphirParser methodsFor: 'reduction actions' stamp: 'ms 10/28/2006 12:13'!
firstIn: nodes

	^ {nodes first}! !

!SaphirParser methodsFor: 'private' stamp: 'ms 8/23/2006 11:19'!
ignoreEmptyStatement
	
	currentToken _ nil.
	self getNextToken.
	^ self actionForCurrentToken! !

!SaphirParser methodsFor: 'accessing' stamp: 'Gwenael.Casaccio 12/10/2008 11:08'!
initializeParserWith: aStream type: aSymbol

	source := aStream.
	self scanner: (RBScanner
				perform: aSymbol
				with: aStream
				with: self errorBlock)! !

!SaphirParser methodsFor: 'private' stamp: 'ms 8/23/2006 11:19'!
isEmptyStatementId: id

	^ ((id = scanner periodId) and: [nodeStack isEmpty]) 
		or: [(id = scanner periodId) and: [(nodeStack last isKindOf: SmaCCToken) and: [nodeStack last id first = scanner periodId]]] ! !

!SaphirParser methodsFor: 'private' stamp: 'ms 8/23/2006 11:19'!
isNegativeNumberId: id

	^ scanner negativeNumberId = id! !

!SaphirParser methodsFor: 'reduction actions' stamp: 'ms 8/23/2006 11:19'!
litArray: nodes

	^ RBLiteralNode
		literalToken: (SmaCCToken
			value: (String new: (nodes fourth stop - nodes second start + 1))
			start: nodes second start)
		value: nodes third contents! !

!SaphirParser methodsFor: 'reduction actions' stamp: 'ms 8/23/2006 11:19'!
litChar: nodes

	^ RBLiteralNode
		literalToken: nodes first
		value: (nodes first value at: 2)! !

!SaphirParser methodsFor: 'reduction actions' stamp: 'ms 8/23/2006 11:19'!
litFalse: nodes

	^ RBLiteralNode
		literalToken: nodes first
		value: false! !

!SaphirParser methodsFor: 'reduction actions' stamp: 'ms 8/23/2006 11:19'!
litNil: nodes

	^ RBLiteralNode
		literalToken: nodes first
		value: nil! !

!SaphirParser methodsFor: 'reduction actions' stamp: 'ms 8/23/2006 11:19'!
litNumber: nodes

	| str num |
	str _ nodes first value readStream.
	num _ Number readFrom: str.
	str atEnd ifFalse: [
		currentToken _ nil.
		scanner position: scanner position - (str originalContents size - str position) + 1.
		self reportErrorMessage: 'Digit out of range'].
	^ RBLiteralNode
		literalToken: nodes first
		value: num! !

!SaphirParser methodsFor: 'reduction actions' stamp: 'ms 8/23/2006 11:19'!
litString: nodes

	| s |
	s _ nodes first value.
	^ RBLiteralNode
		literalToken: nodes first
		value: ((s copyFrom: 2 to: s size - 1)
				copyReplaceAll: '''''' with: '''')! !

!SaphirParser methodsFor: 'reduction actions' stamp: 'ms 8/23/2006 11:19'!
litStringSymbol: nodes

	| s |
	s _ nodes second value.
	^ RBLiteralNode
		literalToken: nodes second
		value: ((s copyFrom: 2 to: s size - 1)
				copyReplaceAll: '''''' with: '''') asSymbol! !

!SaphirParser methodsFor: 'reduction actions' stamp: 'ms 8/23/2006 11:19'!
litSymbol: nodes

	^ RBLiteralNode
		literalToken: nodes second
		value: nodes second value asSymbol! !

!SaphirParser methodsFor: 'reduction actions' stamp: 'ms 8/23/2006 11:19'!
litTrue: nodes

	^ RBLiteralNode
		literalToken: nodes first
		value: true! !

!SaphirParser methodsFor: 'reduction actions' stamp: 'ms 8/23/2006 11:19'!
messagePart: nodes

	^ {{nodes first}. {nodes second}}! !

!SaphirParser methodsFor: 'reduction actions' stamp: 'ms 8/23/2006 11:19'!
messagePragma: nodes
	"self haltIf: [(nodes first first isKindOf: Pragma) not]."
	^nodes first
! !

!SaphirParser methodsFor: 'reduction actions' stamp: 'ms 8/23/2006 11:19'!
messageSend: nodes

	^ RBMessageNode new
		receiver: nodes first
		selectorParts: nodes second first
		arguments: nodes second last! !

!SaphirParser methodsFor: 'reduction actions' stamp: 'ms 10/27/2006 17:11'!
method: nodes

	^ RBScriptMethodDeclarationNode new
		body: nodes first! !

!SaphirParser methodsFor: 'reduction actions' stamp: 'ms 10/27/2006 17:11'!
methodPragma: nodes

	^RBScriptMethodDeclarationNode new
		body: nodes second;
		pragmas:nodes first! !

!SaphirParser methodsFor: 'reduction actions' stamp: 'ms 10/27/2006 17:11'!
methodPragmaTempsPragma: nodes

	^ RBScriptMethodDeclarationNode new 
		body: (RBSequenceNode
			temporaries: nodes second
			statements: nodes fourth);
		pragmas: (nodes first addAll: nodes third; yourself)! !

!SaphirParser methodsFor: 'reduction actions' stamp: 'ms 10/27/2006 17:11'!
methodTempsPragma: nodes

	^ RBScriptMethodDeclarationNode new
		body: (RBSequenceNode
			temporaries: nodes first
			statements: nodes third);
		pragmas: nodes second! !

!SaphirParser methodsFor: 'private' stamp: 'ms 8/23/2006 11:19'!
negativeNumberToBinaryString
	
	currentToken := SmaCCToken 
		value: '-'
		start: currentToken startPosition
		id: (Array with: scanner binarySymbolId).
	scanner position: currentToken stopPosition.
	^ self actionForCurrentToken! !

!SaphirParser methodsFor: 'private' stamp: 'ms 8/23/2006 11:19'!
nodeStack

	^ nodeStack! !

!SaphirParser methodsFor: 'reduction actions' stamp: 'ms 8/23/2006 11:19'!
parameterExtCall: nodes
	| args |
	args := WriteStream on: Array new.
	args nextPut: nodes first.
	^args! !

!SaphirParser methodsFor: 'reduction actions' stamp: 'ms 8/23/2006 11:19'!
parametersExtCall: nodes
	^nodes first nextPut: (nodes second); yourself! !

!SaphirParser methodsFor: 'private-parsing' stamp: 'Gwenael.Casaccio 12/10/2008 13:04'!
parseClassDefinition: aToken

	| methodNode pragmas |
	methodNode := self parseMessagePattern.
	pragmas := self parseResourceTag.
	currentToken value = $[ ifFalse: [self parserError: '[ expected'].
	self step.
	methodNode body: (self parseStatements: true);
		pragmas: pragmas.
	currentToken value = $] ifFalse: [self parserError: '] expected'].
	self step.
	^ RBMethodScript new 
		rbMethodNode: methodNode;
		homeClass: (RBVariableNode new identifierToken: aToken);
		classSide! !

!SaphirParser methodsFor: 'private-parsing' stamp: 'Gwenael.Casaccio 12/10/2008 10:52'!
parseDefinition

	| className |
	className := currentToken.
	self step.
	^ currentToken value = '>>' 
		ifTrue: [
			self step.
			self parseInstanceDefinition: className]
		ifFalse: [currentToken value = 'class' ifFalse: [self parserError: 'class or >> expected'].
			self step.
			currentToken value = '>>' ifFalse: [self parserError: '>> expected'].
			self step.
			self parseClassDefinition: className].! !

!SaphirParser methodsFor: 'private-parsing' stamp: 'Gwenael.Casaccio 12/10/2008 13:04'!
parseInstanceDefinition: aToken

	| methodNode pragmas |
	methodNode := self parseMessagePattern.
	pragmas := self parseResourceTag.
	currentToken value = $[ ifFalse: [self parserError: '[ expected'].
	self step.
	methodNode body: (self parseStatements: true);
		pragmas: pragmas.
	currentToken value = $] ifFalse: [self parserError: '] expected'].
	self step.
	^ RBMethodScript new 
		rbMethodNode: methodNode;
		homeClass: (RBVariableNode new identifierToken: aToken);
		instanceSide! !

!SaphirParser methodsFor: 'private-parsing' stamp: 'Gwenael.Casaccio 12/10/2008 13:11'!
parseScript

	| node result |
	result := OrderedCollection new.
	[self atEnd] whileFalse: [
	currentToken value = $[
		ifTrue: [
			self step.
			node := RBDoitScript body: (self parseStatements: false).
			currentToken value = $] ifFalse: [self parserError: ''']'' expected'].
			self step.]
		ifFalse: [currentToken isIdentifier ifTrue: [node := self parseDefinition]].
		result add: node].
	^ result! !

!SaphirParser methodsFor: 'accessing' stamp: 'Gwenael.Casaccio 12/9/2008 15:57'!
parseScript: aString

	| node |
	node := self parseScript.
	self atEnd ifFalse: [self parserError: 'Unknown input at end'].
	^ node! !

!SaphirParser methodsFor: 'reduction actions' stamp: 'ms 9/3/2006 23:26'!
pragma: nodes
	"self haltIf: [nodes second first isKindOf: Pragma]."
	"| pragmaNode |
	pragmaNode := RBPragmasNode withPragma: nodes second first spec: nodes second second.
	nodes second third ifNotNil: [pragmaNode primitiveNumber: nodes second third].
	^pragmaNode"
	
	| rbPragma |
	rbPragma := RBPragmaNode pragma: nodes second first spec: nodes second second start: nodes first start stop: nodes third stop.
	nodes second third ifNotNil: [rbPragma primitiveNumber: nodes second third].
	^OrderedCollection with: rbPragma! !

!SaphirParser methodsFor: 'reduction actions' stamp: 'ms 8/23/2006 11:19'!
pragmaKeyWordMessage: nodes
	| arguments keyword |
	keyword := String new.
	arguments := (nodes first second collect: [:each | each value]).
	nodes first first do: [:each | keyword := keyword, each value].
	^OrderedCollection with:(Pragma keyword: keyword asSymbol arguments: arguments)
					  with: nil
					  with: nil
	
	
	! !

!SaphirParser methodsFor: 'reduction actions' stamp: 'ms 8/23/2006 11:19'!
pragmaUnaryMessage: nodes
	^OrderedCollection with:(Pragma keyword: nodes first first first value asSymbol arguments: nodes first second)
					  with: nil
					  with: nil
	
	
	! !

!SaphirParser methodsFor: 'reduction actions' stamp: 'ms 9/3/2006 23:48'!
pragmas: nodes
	"nodes first addPragma: nodes third first withSpec: nodes third second.
	nodes third third ifNotNil: [nodes first primitiveNumber: nodes third third].
	^nodes first"
	
	| rbPragma |
	rbPragma := RBPragmaNode pragma: nodes third first spec: nodes third second start: nodes second start stop: nodes fourth stop.
	nodes third third ifNotNil: [rbPragma primitiveNumber: nodes third third].
	nodes first add: rbPragma.
	^nodes first
	! !

!SaphirParser methodsFor: 'reduction actions' stamp: 'ms 8/23/2006 11:19'!
primitiveModule: nodes
	^OrderedCollection with: (Pragma keyword: #primitive:module: 
									 arguments: (Array with: nodes second value withoutQuoting asSymbol
														with: nodes fourth value withoutQuoting asSymbol)) 
					  with: (Array with: nodes fourth value withoutQuoting asSymbol 
								    with: nodes second value withoutQuoting asSymbol 
								    with: 0 with: 0)
					  with: 117

	! !

!SaphirParser methodsFor: 'reduction actions' stamp: 'ms 8/23/2006 11:19'!
primitiveNumber: nodes
	^OrderedCollection with: (Pragma keyword: #primitive: arguments: (Array with: nodes second value asInteger)) 
					  with: nil
					  with: nodes second value asInteger
	! !

!SaphirParser methodsFor: 'reduction actions' stamp: 'ms 8/23/2006 11:19'!
primitiveString: nodes
	^OrderedCollection with: (Pragma keyword: #primitive: 
									 arguments: (Array with: nodes second value withoutQuoting asSymbol)) 
					   with: (Array with: nil 
									with: nodes second value withoutQuoting asSymbol 
									with: 0 with: 0)
					   with: 117! !

!SaphirParser methodsFor: 'generated-reduction actions' stamp: 'ms 11/17/2007 10:44'!
reduceActionForOptionalXXXperiodX1: nodes 
	^ nil! !

!SaphirParser methodsFor: 'generated-reduction actions' stamp: 'ms 11/17/2007 10:44'!
reduceActionForOptionalXXXperiodX2: nodes 
	^ nodes at: 1! !

!SaphirParser methodsFor: 'generated-tables' stamp: 'ms 11/17/2007 10:44'!
reduceTable
	^#(
#(40 1 #messagePragma:)
#(40 1 #messagePragma:)
#(40 1 #messagePragma:)
#(41 3 #pragma:)
#(41 4 #pragmas:)
#(42 1 #method:)
#(42 2 #methodPragma:)
#(42 4 #methodPragmaTempsPragma:)
#(42 3 #methodTempsPragma:)
#(43 6 #declareClassMethod:)
#(44 5 #declareMethod:)
#(45 0 #array)
#(45 2 #first:)
#(45 5 #returnAdd:)
#(45 3 #return:)
#(46 1 #first:)
#(46 1 #first:)
#(46 1 #first:)
#(47 0 #array)
#(47 2 #add:)
#(48 1 #firstIn:)
#(48 3 #add3:)
#(49 0 #reduceActionForOptionalXXXperiodX1:)
#(49 1 #reduceActionForOptionalXXXperiodX2:)
#(50 1 #first:)
#(50 1 #first:)
#(50 1 #first:)
#(51 2 #secondIn:)
#(51 3 #add3:)
#(52 5 #blockWithArgs:)
#(52 3 #blockNoArgs:)
#(52 3 #blockArgs:)
#(52 7 #blockWithTemps:)
#(53 3 #assignment:)
#(54 1 #first:)
#(54 3 #cascade:)
#(55 3 #second:)
#(55 1 #first:)
#(55 1 #first:)
#(55 1 #first:)
#(55 1 #first:)
#(56 3 #array:)
#(57 1 #litTrue:)
#(57 1 #litFalse:)
#(57 1 #litNil:)
#(57 1 #litNumber:)
#(57 1 #litNumber:)
#(57 1 #litChar:)
#(57 1 #litString:)
#(57 2 #litStringSymbol:)
#(57 2 #litSymbol:)
#(57 2 #litSymbol:)
#(57 2 #litSymbol:)
#(57 2 #litSymbol:)
#(57 2 #litSymbol:)
#(57 4 #litArray:)
#(57 4 #litArray:)
#(57 1 #litString:)
#(58 1 #reduceFor:)
#(59 1 #first:)
#(59 1 #first:)
#(59 1 #first:)
#(60 1 #first:)
#(60 1 #first:)
#(60 1 #first:)
#(61 2 #messageSend:)
#(61 2 #messageSend:)
#(61 2 #messageSend:)
#(62 2 #messagePart:)
#(62 3 #addMessagePart:)
#(63 2 #messageSend:)
#(63 2 #messageSend:)
#(64 1 #unaryMessage:)
#(65 2 #messagePart:)
#(66 2 #messagePart:)
#(66 3 #addMessagePart:)
#(67 1 #first:)
#(67 1 #first:)
#(67 1 #first:)
#(68 1 #first:)
#(68 1 #first:)
#(69 1 #variable:)
#(70 1 #first:)
#(71 1 #firstIn:)
#(71 2 #add2:)
#(72 1 #unaryMessage:)
#(72 2 #messagePart:)
#(72 1 #first:)
#(73 0 #byteStream)
#(73 2 #byteStreamPut:)
#(74 0 #stream)
#(74 2 #streamPut:)
#(75 1 #value:)
#(75 1 #valueSymbol:)
#(75 1 #valueSymbol:)
#(75 1 #valueSymbol:)
#(75 1 #valueSymbol:)
#(75 1 #valueSymbol:)
#(75 3 #contents2:)
#(75 3 #contents2:)
#(75 1 #valueSymbol:)
#(76 1 #array)
#(76 3 #second:)
#(77 6 #externalCall:)
#(77 8 #externalModuleCall:)
#(78 2 #primitiveString:)
#(78 2 #primitiveNumber:)
#(78 4 #primitiveModule:)
#(79 1 #pragmaKeyWordMessage:)
#(79 1 #pragmaUnaryMessage:)
#(80 2 #messagePart:)
#(80 3 #addMessagePart:)
#(81 1 #first:)
#(81 1 #first:)
#(81 1 #first:)
#(81 1 #first:)
#(82 1 #callConvention:)
#(82 1 #callConvention:)
#(83 1 #externalType:)
#(83 2 #externalTypePointer:)
#(84 1 #externalFunction:)
#(84 1 #externalIndex:)
#(85 1 #parameterExtCall:)
#(85 2 #parametersExtCall:)
#(88 2 #messageSend:)
#(88 2 #messageSend:)
#(88 2 #messageSend:)
#(89 1 #sequence:)
#(89 2 #sequenceWithTemps:)
#(90 4 #scriptMethod:)
)! !

!SaphirParser methodsFor: 'reduction actions' stamp: 'ms 8/23/2006 11:19'!
return: nodes

	^ {RBReturnNode
		return: nodes first start
		value: nodes second}! !

!SaphirParser methodsFor: 'reduction actions' stamp: 'ms 8/23/2006 11:19'!
returnAdd: nodes

	^ nodes first copyWith: (RBReturnNode
		return: nodes third start
		value: nodes fourth)! !

!SaphirParser methodsFor: 'private' stamp: 'ms 8/23/2006 11:19'!
scanner

	^ scanner! !

!SaphirParser methodsFor: 'reduction actions' stamp: 'ms 10/29/2006 08:52'!
scriptMethod: nodes
	
	nodes third selectorParts: nodes first first.
	nodes third arguments: nodes first last.
	nodes third classDefineIn: classParseIn.
	nodes third source: nodes third sourceText asString.
	^nodes third! !

!SaphirParser methodsFor: 'reduction actions' stamp: 'ms 8/23/2006 11:19'!
second: nodes

	^ nodes second! !

!SaphirParser methodsFor: 'reduction actions' stamp: 'ms 8/25/2006 23:04'!
secondIn: nodes

	^ {nodes second}! !

!SaphirParser methodsFor: 'reduction actions' stamp: 'ms 8/23/2006 11:19'!
sequence: nodes

	^ RBSequenceNode
		statements: nodes first! !

!SaphirParser methodsFor: 'reduction actions' stamp: 'ms 8/23/2006 11:19'!
sequenceWithTemps: nodes

	^ RBSequenceNode
		temporaries: nodes first
		statements: nodes second! !

!SaphirParser methodsFor: 'reduction actions' stamp: 'ms 8/23/2006 11:19'!
stream

	^ Array new writeStream! !

!SaphirParser methodsFor: 'reduction actions' stamp: 'ms 8/23/2006 11:19'!
streamPut: nodes

	^ nodes first
		nextPut: nodes second;
		yourself! !

!SaphirParser methodsFor: 'generated-tables' stamp: 'ms 11/17/2007 10:44'!
transitionTable
	^#(
#(3 13 28 17 29 21 31 25 43 29 44 33 46 37 62 41 69 45 70 49 71 53 72 57 90)
#(3 61 28 17 29 21 31 37 62 65 72)
#(3 330 5 346 9 330 28 330 29 330 31)
#(3 69 28 73 69)
#(3 69 28 77 69)
#(2 66 28 29 31 86)
#(2 70 28 29 31 86)
#(2 338 28 29 31 86)
#(3 354 9 81 29 354 86)
#(3 85 5 61 28 17 29 21 31 37 62 89 72)
#(2 0 86)
#(3 13 28 17 29 21 31 25 43 29 44 93 46 37 62 41 69 53 72 334 86 57 90)
#(2 97 9)
#(2 74 28 29 31 86)
#(2 346 9 86)
#(2 0 86)
#(2 330 3 6 8 9 10 11 12 13 20 28 29 31 32 37 86)
#(2 278 9 29 86)
#(2 350 9 86)
#(3 69 28 101 69)
#(3 61 28 17 29 21 31 37 62 105 72)
#(2 109 9)
#(2 342 28 29 31 86)
#(3 113 2 117 4 121 6 125 7 129 9 50 10 133 12 137 17 141 19 145 21 149 22 153 23 157 24 161 25 165 26 169 27 69 28 173 36 177 41 181 42 185 45 189 48 193 50 197 52 201 53 205 54 209 55 213 56 217 57 221 59 225 61 229 63 233 69 237 76 241 88 245 89)
#(2 282 9 29 86)
#(2 249 9)
#(3 113 2 117 4 121 6 125 7 129 9 50 10 133 12 137 17 141 19 145 21 149 22 153 23 157 24 161 25 165 26 169 27 69 28 173 36 177 41 253 42 185 45 189 48 193 50 197 52 201 53 205 54 209 55 213 56 217 57 221 59 225 61 229 63 233 69 237 76 241 88 245 89)
#(3 117 4 129 9 137 17 141 19 145 21 149 22 153 23 157 24 161 25 165 26 169 27 69 28 173 36 257 50 197 52 201 53 205 54 209 55 213 56 217 57 221 59 225 61 229 63 233 69 241 88)
#(3 117 4 129 9 137 17 141 19 145 21 149 22 153 23 157 24 161 25 165 26 169 27 69 28 173 36 261 50 197 52 201 53 205 54 209 55 213 56 217 57 221 59 225 61 229 63 233 69 241 88)
#(2 410 2 4 7 9 10 17 19 21 22 23 24 25 26 27 28 36)
#(3 265 1 269 15 273 16 277 28 281 29 285 40 289 64 293 66 297 77 301 78 305 79 309 80 313 82)
#(3 113 2 317 3 117 4 121 6 129 9 50 10 133 12 137 17 141 19 145 21 149 22 153 23 157 24 161 25 165 26 169 27 69 28 173 36 185 45 189 48 193 50 321 51 197 52 201 53 205 54 209 55 213 56 217 57 221 59 225 61 229 63 233 69 325 76 241 88 329 89)
#(3 78 12 78 28 333 47)
#(3 113 2 117 4 129 9 137 17 141 19 50 20 145 21 149 22 153 23 157 24 161 25 165 26 169 27 69 28 173 36 337 45 189 48 193 50 197 52 201 53 205 54 209 55 213 56 217 57 221 59 225 61 229 63 233 69 241 88)
#(2 234 4 8 9 10 11 13 19 20 21 22 23 24 25 26 27 28 29 30 31 33 36 37 39)
#(3 341 4 345 9 349 27 353 28 357 29 361 30 365 31 369 33)
#(2 174 4 8 9 10 11 13 19 20 21 22 23 24 25 26 27 28 29 30 31 33 36 37 39)
#(2 182 4 8 9 10 11 13 19 20 21 22 23 24 25 26 27 28 29 30 31 33 36 37 39)
#(2 178 4 8 9 10 11 13 19 20 21 22 23 24 25 26 27 28 29 30 31 33 36 37 39)
#(2 186 4 8 9 10 11 13 19 20 21 22 23 24 25 26 27 28 29 30 31 33 36 37 39)
#(2 190 4 8 9 10 11 13 19 20 21 22 23 24 25 26 27 28 29 30 31 33 36 37 39)
#(2 198 4 8 9 10 11 13 19 20 21 22 23 24 25 26 27 28 29 30 31 33 36 37 39)
#(2 194 4 8 9 10 11 13 19 20 21 22 23 24 25 26 27 28 29 30 31 33 36 37 39)
#(3 113 2 117 4 121 6 373 7 129 9 50 10 133 12 137 17 141 19 145 21 149 22 153 23 157 24 161 25 165 26 169 27 69 28 173 36 185 45 189 48 193 50 197 52 201 53 205 54 209 55 213 56 217 57 221 59 225 61 229 63 233 69 377 76 241 88 381 89)
#(2 385 10)
#(2 514 10)
#(3 94 10 94 20 389 37 393 49)
#(2 86 10 20 37)
#(2 158 10 11 13 20 28 29 31 37)
#(2 102 10 11 20 37)
#(3 106 10 106 11 397 13 106 20 106 37)
#(3 110 10 110 11 110 20 277 28 401 29 405 31 110 37 409 64 413 65 417 66)
#(2 154 10 11 13 20 28 29 31 37)
#(2 162 10 11 13 20 28 29 31 37)
#(2 142 10 11 13 20 37)
#(2 242 10 11 13 20 37)
#(3 250 10 250 11 250 13 250 20 277 28 401 29 405 31 250 37 421 64 425 65 429 66)
#(3 166 10 166 11 166 20 166 28 166 29 166 31 433 32 166 37)
#(3 113 2 117 4 125 7 129 9 50 10 137 17 141 19 145 21 149 22 153 23 157 24 161 25 165 26 169 27 69 28 173 36 437 41 441 45 189 48 193 50 197 52 201 53 205 54 209 55 213 56 217 57 221 59 225 61 229 63 233 69 241 88)
#(3 246 10 246 11 246 13 246 20 401 29 405 31 246 37 445 65 449 66)
#(2 26 10)
#(3 113 2 117 4 121 6 125 7 129 9 50 10 133 12 137 17 141 19 145 21 149 22 153 23 157 24 161 25 165 26 169 27 69 28 173 36 177 41 453 42 185 45 189 48 193 50 197 52 201 53 205 54 209 55 213 56 217 57 221 59 225 61 229 63 233 69 237 76 241 88 245 89)
#(2 457 10)
#(3 94 10 94 20 461 37 465 49)
#(2 469 11)
#(3 473 25 477 27)
#(2 470 28)
#(2 474 28)
#(2 294 8 10 11 13 20 28 29 31 37)
#(3 117 4 129 9 137 17 141 19 145 21 149 22 153 23 157 24 161 25 165 26 169 27 69 28 173 36 481 52 485 55 489 56 493 57 497 63 501 67 505 69 509 81 513 88)
#(2 517 8)
#(2 442 8)
#(2 521 29)
#(2 6 8)
#(2 10 8)
#(2 14 8)
#(2 438 8)
#(3 525 28 529 83)
#(3 69 28 533 69)
#(3 537 3 541 6 545 10 549 12)
#(3 113 2 117 4 129 9 50 10 137 17 141 19 145 21 149 22 153 23 157 24 161 25 165 26 169 27 69 28 173 36 441 45 189 48 193 50 197 52 201 53 205 54 209 55 213 56 217 57 221 59 225 61 229 63 233 69 241 88)
#(2 553 10)
#(3 557 12 69 28 561 69)
#(2 565 20)
#(3 366 4 366 9 366 11 366 19 366 21 366 22 366 23 366 24 366 25 366 26 366 27 366 28 366 29 366 30 366 31 366 33 366 36 366 39 569 74)
#(3 358 10 358 25 573 73)
#(2 202 4 8 9 10 11 13 19 20 21 22 23 24 25 26 27 28 29 30 31 33 36 37 39)
#(2 206 4 8 9 10 11 13 19 20 21 22 23 24 25 26 27 28 29 30 31 33 36 37 39)
#(2 214 4 8 9 10 11 13 19 20 21 22 23 24 25 26 27 28 29 30 31 33 36 37 39)
#(2 218 4 8 9 10 11 13 19 20 21 22 23 24 25 26 27 28 29 30 31 33 36 37 39)
#(2 210 4 8 9 10 11 13 19 20 21 22 23 24 25 26 27 28 29 30 31 33 36 37 39)
#(2 222 4 8 9 10 11 13 19 20 21 22 23 24 25 26 27 28 29 30 31 33 36 37 39)
#(3 265 1 269 15 273 16 277 28 281 29 577 40 289 64 293 66 297 77 301 78 305 79 309 80 313 82)
#(3 113 2 117 4 125 7 129 9 50 10 137 17 141 19 145 21 149 22 153 23 157 24 161 25 165 26 169 27 69 28 173 36 581 41 441 45 189 48 193 50 197 52 201 53 205 54 209 55 213 56 217 57 221 59 225 61 229 63 233 69 241 88)
#(2 30 10)
#(2 522 28 29 31 86)
#(3 585 2 117 4 129 9 98 10 137 17 141 19 98 20 145 21 149 22 153 23 157 24 161 25 165 26 169 27 69 28 173 36 589 50 197 52 201 53 205 54 209 55 213 56 217 57 221 59 225 61 229 63 233 69 241 88)
#(2 54 10 20)
#(3 277 28 401 29 405 31 593 60 597 64 601 65 605 66)
#(3 117 4 129 9 137 17 141 19 145 21 149 22 153 23 157 24 161 25 165 26 169 27 69 28 173 36 197 52 485 55 213 56 217 57 497 63 501 67 609 69 513 88)
#(3 117 4 129 9 137 17 141 19 145 21 149 22 153 23 157 24 161 25 165 26 169 27 69 28 173 36 197 52 613 55 213 56 217 57 617 63 621 68 609 69)
#(2 290 10 11 13 20 28 29 31 37)
#(2 510 10 11 13 20 29 31 37)
#(3 274 10 274 11 274 13 274 20 625 29 274 37)
#(2 286 10 11 13 20 28 29 31 37)
#(2 506 10 11 13 20 29 31 37)
#(3 270 10 270 11 270 13 270 20 625 29 270 37)
#(3 117 4 129 9 137 17 141 19 145 21 149 22 153 23 157 24 161 25 165 26 169 27 69 28 173 36 629 50 197 52 201 53 205 54 209 55 213 56 217 57 221 59 225 61 229 63 233 69 241 88)
#(3 113 2 117 4 373 7 129 9 50 10 137 17 141 19 145 21 149 22 153 23 157 24 161 25 165 26 169 27 69 28 173 36 633 45 189 48 193 50 197 52 201 53 205 54 209 55 213 56 217 57 221 59 225 61 229 63 233 69 241 88)
#(2 518 10)
#(2 502 10 11 13 20 29 31 37)
#(3 266 10 266 11 266 13 266 20 625 29 266 37)
#(2 637 10)
#(2 46 28 29 31 86)
#(2 98 10 20)
#(2 62 10 20)
#(2 150 10 11 13 20 28 29 31 37)
#(2 430 8)
#(3 426 8 641 14)
#(3 458 8 158 28 158 29 158 31)
#(3 318 10 318 11 318 13 318 20 277 28 318 29 405 31 318 37 409 64 413 65)
#(3 454 8 154 28 154 29 154 31)
#(3 462 8 162 28 162 29 162 31)
#(3 314 10 314 11 314 13 314 20 277 28 314 29 405 31 314 37 421 64 425 65)
#(2 302 10 11 13 20 29 37)
#(3 466 8 166 28 166 29 166 31)
#(2 446 8)
#(3 310 10 310 11 310 13 310 20 310 29 405 31 310 37 445 65)
#(2 18 2 4 6 7 9 10 12 17 19 21 22 23 24 25 26 27 28 36)
#(3 117 4 129 9 137 17 141 19 145 21 149 22 153 23 157 24 161 25 165 26 169 27 69 28 173 36 481 52 485 55 489 56 493 57 497 63 645 67 505 69 649 81 513 88)
#(3 478 11 653 18 478 25 478 27 478 28)
#(3 657 25 661 27 665 84)
#(2 114 3 6 10 12)
#(3 69 28 669 69)
#(3 78 12 78 28 673 47)
#(2 130 8 10 11 13 20 28 29 31 37)
#(3 113 2 117 4 121 6 129 9 50 10 133 12 137 17 141 19 145 21 149 22 153 23 157 24 161 25 165 26 169 27 69 28 173 36 185 45 189 48 193 50 197 52 201 53 205 54 209 55 213 56 217 57 221 59 225 61 229 63 233 69 325 76 241 88 677 89)
#(2 126 8 10 11 13 20 28 29 31 37)
#(2 414 2 4 7 9 10 17 19 21 22 23 24 25 26 27 28 36)
#(2 82 12 28)
#(2 170 8 10 11 13 20 28 29 31 37)
#(3 681 4 685 9 689 11 141 19 145 21 149 22 153 23 157 24 161 25 165 26 169 27 693 28 697 29 701 30 705 31 709 33 173 36 713 39 717 57 721 75)
#(3 725 10 729 25)
#(2 733 8)
#(3 113 2 117 4 373 7 129 9 50 10 137 17 141 19 145 21 149 22 153 23 157 24 161 25 165 26 169 27 69 28 173 36 737 45 189 48 193 50 197 52 201 53 205 54 209 55 213 56 217 57 221 59 225 61 229 63 233 69 241 88)
#(3 117 4 129 9 137 17 141 19 145 21 149 22 153 23 157 24 161 25 165 26 169 27 69 28 173 36 741 50 197 52 201 53 205 54 209 55 213 56 217 57 221 59 225 61 229 63 233 69 241 88)
#(2 90 10 20 37)
#(2 146 10 11 13 20 37)
#(2 254 10 11 13 20 37)
#(2 258 10 11 13 20 37)
#(3 262 10 262 11 262 13 262 20 625 29 262 37)
#(2 166 10 11 13 20 28 29 31 37)
#(3 326 10 326 11 326 13 326 20 277 28 326 29 326 31 326 37 409 64)
#(3 322 10 322 11 322 13 322 20 277 28 322 29 322 31 322 37 421 64)
#(2 298 10 11 13 20 29 31 37)
#(3 117 4 129 9 137 17 141 19 145 21 149 22 153 23 157 24 161 25 165 26 169 27 69 28 173 36 197 52 485 55 213 56 217 57 497 63 645 67 609 69 513 88)
#(2 138 10 11 20 37)
#(2 38 10)
#(2 42 28 29 31 86)
#(2 745 27)
#(2 306 10 11 13 20 29 37)
#(2 450 8)
#(2 482 11 25 27 28)
#(2 490 4)
#(2 486 4)
#(2 749 4)
#(2 118 3 6 10 12)
#(3 753 12 69 28 561 69)
#(2 757 10)
#(3 366 4 366 9 366 11 366 19 366 21 366 22 366 23 366 24 366 25 366 26 366 27 366 28 366 29 366 30 366 31 366 33 366 36 366 39 761 74)
#(3 358 10 358 25 765 73)
#(2 230 4 8 9 10 11 13 19 20 21 22 23 24 25 26 27 28 29 30 31 33 36 37 39)
#(2 378 4 9 11 19 21 22 23 24 25 26 27 28 29 30 31 33 36 39)
#(2 386 4 9 11 19 21 22 23 24 25 26 27 28 29 30 31 33 36 39)
#(2 390 4 9 11 19 21 22 23 24 25 26 27 28 29 30 31 33 36 39)
#(2 382 4 9 11 19 21 22 23 24 25 26 27 28 29 30 31 33 36 39)
#(2 394 4 9 11 19 21 22 23 24 25 26 27 28 29 30 31 33 36 39)
#(2 406 4 9 11 19 21 22 23 24 25 26 27 28 29 30 31 33 36 39)
#(2 374 4 9 11 19 21 22 23 24 25 26 27 28 29 30 31 33 36 39)
#(2 370 4 9 11 19 21 22 23 24 25 26 27 28 29 30 31 33 36 39)
#(2 226 4 8 9 10 11 13 19 20 21 22 23 24 25 26 27 28 29 30 31 33 36 37 39)
#(2 362 10 25)
#(2 22 2 4 6 7 9 10 12 17 19 21 22 23 24 25 26 27 28 36)
#(2 34 10)
#(3 94 10 94 20 461 37 769 49)
#(2 434 8)
#(3 525 28 773 83 777 85)
#(3 113 2 117 4 129 9 50 10 137 17 141 19 145 21 149 22 153 23 157 24 161 25 165 26 169 27 69 28 173 36 781 45 189 48 193 50 197 52 201 53 205 54 209 55 213 56 217 57 221 59 225 61 229 63 233 69 241 88)
#(2 122 8 10 11 13 20 28 29 31 37)
#(3 681 4 685 9 785 11 141 19 145 21 149 22 153 23 157 24 161 25 165 26 169 27 693 28 697 29 701 30 705 31 709 33 173 36 713 39 717 57 721 75)
#(3 789 10 729 25)
#(2 58 10 20)
#(2 494 11 28)
#(3 793 11 525 28 797 83)
#(2 801 10)
#(2 398 4 9 11 19 21 22 23 24 25 26 27 28 29 30 31 33 36 39)
#(2 402 4 9 11 19 21 22 23 24 25 26 27 28 29 30 31 33 36 39)
#(3 418 8 805 14)
#(2 498 11 28)
#(2 134 8 10 11 13 20 28 29 31 37)
#(2 809 27)
#(2 422 8)
)! !

!SaphirParser methodsFor: 'reduction actions' stamp: 'ms 8/23/2006 11:19'!
unaryMessage: nodes

	^ {{nodes first}. #()}! !

!SaphirParser methodsFor: 'reduction actions' stamp: 'ms 8/23/2006 11:19'!
value: nodes

	^ nodes first value! !

!SaphirParser methodsFor: 'reduction actions' stamp: 'ms 8/23/2006 11:19'!
valueSymbol: nodes

	^ nodes first value asSymbol! !

!SaphirParser methodsFor: 'reduction actions' stamp: 'ms 8/23/2006 11:19'!
variable: nodes

	^ RBVariableNode new
		identifierToken: nodes first! !

!ASTTranslator methodsFor: '*coral' stamp: 'ms 1/24/2008 17:11'!
acceptDoitScriptNode: aDoitNode 
	self visitNode: aDoitNode doIt! !

!ASTTranslator methodsFor: '*coral' stamp: 'ms 1/24/2008 17:11'!
acceptMethodScriptNode: aMothodScript

	self visitNode: aMothodScript rbMethodNode! !

!UnixProcess methodsFor: '*coral' stamp: 'ms 10/5/2006 14:15'!
newLineInConsole
	
	^String lf! !

Stream subclass: #SelectSqueakTokenStream
	instanceVariableNames: 'selectBlock nextValue atEnd stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Coral'!

!SelectSqueakTokenStream commentStamp: 'ms 9/17/2006 19:24' prior: 0!
A SelectSqueakTokenStream is Decorator of stream to select token expected.

Instance Variables
	atEnd:		<Object>
	nextValue:		<Object>
	selectBlock:		<Object>
	stream:		<Object>

atEnd
	- xxxxx

nextValue
	- xxxxx

selectBlock
	- xxxxx

stream
	- xxxxx
!

!SelectSqueakTokenStream class methodsFor: 'instance creation' stamp: 'ms 9/19/2006 01:14'!
selectComment: aTokenStream

	^self basicNew initialize; select: [:each | each notEaten and: [each isComment]] on: aTokenStream; yourself
	
	! !

!SelectSqueakTokenStream class methodsFor: 'instance creation' stamp: 'ms 9/17/2006 20:00'!
selectCommentNewLineOn: aTokenStream

	^self basicNew initialize; select: [:each | each notEaten and: [each isComment or: [each isNewLine]]] on: aTokenStream; yourself
	
	! !

!SelectSqueakTokenStream class methodsFor: 'instance creation' stamp: 'ms 5/28/2007 14:01'!
selectCommentNewLineWithPipeOn: aTokenStream

	^self basicNew initialize; select: [:each | each notEaten and: [each isComment or: [each isNewLine] or: [each value = '|']]] on: aTokenStream; yourself
	
	! !

!SelectSqueakTokenStream methodsFor: 'accessing' stamp: 'ms 9/17/2006 19:27'!
atEnd
     ^atEnd! !

!SelectSqueakTokenStream methodsFor: 'accessing' stamp: 'ms 9/19/2006 00:44'!
contents

     | temp tempStream |
     temp := OrderedCollection with: nextValue.
	tempStream := stream contents.
     tempStream do: [:each | (selectBlock value: each) 
               ifTrue: [temp add: each]].
     ^temp! !

!SelectSqueakTokenStream methodsFor: 'accessing' stamp: 'ms 10/14/2006 15:38'!
next
     | temp |
     temp := nextValue.
     stream do: [:each | (selectBlock value: each) 
               ifTrue: [nextValue := each.  ^temp]].
     atEnd := true.
	nextValue := nil.
     ^temp! !

!SelectSqueakTokenStream methodsFor: 'accessing' stamp: 'ms 9/19/2006 15:16'!
peek
   
	^nextValue! !

!SelectSqueakTokenStream methodsFor: 'private' stamp: 'ms 9/19/2006 12:54'!
select: aBlock on: aStream

       selectBlock := aBlock.
       stream := aStream.
       atEnd := false.
       self next! !

Stream subclass: #SqueakTokenStream
	instanceVariableNames: 'token goNext'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Coral'!

!SqueakTokenStream class methodsFor: 'instance creation' stamp: 'ms 9/17/2006 19:05'!
backwardOn: aToken

	^(self basicNew) initialize; backwardOn: aToken; yourself
! !

!SqueakTokenStream class methodsFor: 'instance creation' stamp: 'ms 9/19/2006 14:42'!
forwardOn: aToken

	^(self basicNew) initialize; forwardOn: aToken
! !

!SqueakTokenStream methodsFor: 'accessing' stamp: 'ms 9/17/2006 19:00'!
atEnd
	
	^token isNil! !

!SqueakTokenStream methodsFor: 'initialize' stamp: 'ms 9/19/2006 00:41'!
backwardOn: aToken
	
	token := aToken.
	goNext := #previous! !

!SqueakTokenStream methodsFor: 'accessing' stamp: 'ms 9/19/2006 00:42'!
contents
	
	| cont nextToken |
	cont := OrderedCollection new.
	nextToken := token.
	[nextToken isNil] whileFalse: [cont add: nextToken. nextToken := nextToken perform: goNext].
	^cont asArray! !

!SqueakTokenStream methodsFor: 'initialize' stamp: 'ms 9/19/2006 00:41'!
forwardOn: aToken
	
	token := aToken.
	goNext := #next! !

!SqueakTokenStream methodsFor: 'accessing' stamp: 'ms 9/19/2006 02:09'!
next
	
	| next |
	next := token.
	self atEnd ifFalse:[token :=  token perform: goNext].
	^next! !

!SqueakTokenStream methodsFor: 'accessing' stamp: 'ms 9/19/2006 01:03'!
peek
	
	^token! !

!SqueakTokenStream methodsFor: 'accessing' stamp: 'ms 9/19/2006 13:08'!
selectCommentNewLine

	^SelectSqueakTokenStream selectCommentNewLineOn: self! !

!SqueakTokenStream methodsFor: 'accessing' stamp: 'ms 5/28/2007 14:03'!
selectCommentNewLineWithPipe

	^SelectSqueakTokenStream selectCommentNewLineWithPipeOn:  self! !

RBProgramNode subclass: #RBDoitScript
	instanceVariableNames: 'doIt block'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Coral'!

!RBDoitScript class methodsFor: 'as yet unclassified' stamp: 'ms 1/24/2008 17:13'!
body: aSequence

	^self new doIt: (RBDoItNode body: aSequence); yourself! !

!RBDoitScript methodsFor: 'accessing' stamp: 'ms 1/24/2008 16:55'!
doIt
	^ doIt! !

!RBDoitScript methodsFor: 'accessing' stamp: 'ms 1/24/2008 16:55'!
doIt: anObject
	doIt := anObject! !

!RBDoitScript methodsFor: 'generation' stamp: 'ms 1/24/2008 21:42'!
execute

	| cm |
	[doIt verifyIn: nil doItScope] on: SemanticWarning do: [:ex | "ex correctIn: self"].
	cm := doIt generate.
	cm selector: #DoIt.
	block := BlockClosure new
		env: nil;
		method: cm;
		yourself.
	^block value! !

RBProgramNode subclass: #RBMethodScript
	instanceVariableNames: 'rbMethodNode homeClass isClassSide classDefinedIn'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Coral'!

!RBMethodScript methodsFor: 'accessing' stamp: 'ms 1/24/2008 21:15'!
authorInitials

	^'sa'! !

!RBMethodScript methodsFor: 'accessing' stamp: 'ms 1/24/2008 21:14'!
category

	^((rbMethodNode pragmas collect: [:rbPragma | rbPragma pragma]) 
		detect: [:pragma | pragma keyword = #category:] ifNone: [Pragma default]) arguments first! !

!RBMethodScript methodsFor: 'accessing' stamp: 'ms 1/24/2008 21:18'!
classDefineIn

	^classDefinedIn! !

!RBMethodScript methodsFor: 'accessing' stamp: 'ms 11/17/2007 16:44'!
classSide

	isClassSide := true! !

!RBMethodScript methodsFor: 'generating' stamp: 'ms 1/25/2008 15:26'!
execute

	| method scope |
	ASTChecker new
		scope: nil parseScope;
		visitNode: self homeClass.
	classDefinedIn := self homeClass binding value.
	isClassSide 
		ifTrue: [scope := classDefinedIn class parseScope]
		ifFalse:[scope := classDefinedIn parseScope].

	[rbMethodNode verifyIn: scope] on: SemanticWarning do: [:ex | "ex correctIn: self"].
	rbMethodNode generate.
	method := CompiledMethodWithNode 
			generateMethodFromNode: rbMethodNode 
			trailer: self class defaultMethodTrailer.
	self scopeClass 
			logMethodSource: self source 
			forMethodWithNode: method
			inCategory: self category 
			withStamp: (Utilities changeStampWithInitials: self authorInitials) 
			notifying: [^nil].
	self scopeClass 
			addAndClassifySelector: method selector 
			withMethod: method method 
			inProtocol: self category 
			notifying: [^nil].
	self scopeClass 
			instanceSide noteCompilationOf: method selector 
			meta: self scopeClass isClassSide.
	(isClassSide and:[ method method selector = #initialize])
		ifTrue:[self classDefineIn initialize].
	^method! !

!RBMethodScript methodsFor: 'accessing' stamp: 'ms 11/17/2007 16:39'!
homeClass
	^ homeClass! !

!RBMethodScript methodsFor: 'accessing' stamp: 'ms 11/17/2007 16:39'!
homeClass: anObject
	homeClass := anObject! !

!RBMethodScript methodsFor: 'accessing' stamp: 'ms 11/17/2007 16:45'!
instanceSide

	isClassSide := false! !

!RBMethodScript methodsFor: 'accessing' stamp: 'ms 11/17/2007 16:23'!
rbMethodNode
	^ rbMethodNode! !

!RBMethodScript methodsFor: 'accessing' stamp: 'ms 11/17/2007 16:23'!
rbMethodNode: anObject
	rbMethodNode := anObject! !

!RBMethodScript methodsFor: 'accessing' stamp: 'ms 1/24/2008 21:49'!
scopeClass

	^isClassSide ifTrue: [classDefinedIn class]
		ifFalse: [classDefinedIn]! !

!RBMethodScript methodsFor: 'accessing' stamp: 'ms 1/24/2008 20:58'!
source

	^rbMethodNode sourceText! !

RBMethodNode subclass: #RBScriptDeclarationNode
	instanceVariableNames: 'classSide parserCorrection classDefineIn variableClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Coral'!

RBScriptDeclarationNode subclass: #RBMethodDeclarationNode
	instanceVariableNames: 'classNodeVar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Coral'!

!RBMethodDeclarationNode methodsFor: 'visitor' stamp: 'ms 8/28/2006 17:23'!
acceptVisitor: aProgramNodeVisitor
 	
	"self classVar binding ifNil:[
		aProgramNodeVisitor visitNode: self classVar.
		(self classVar binding value isKindOf: Behavior)
			 ifFalse: [self error: self classVar name, ' is unknown']]."
	super acceptVisitor: aProgramNodeVisitor! !

!RBMethodDeclarationNode methodsFor: 'accessing' stamp: 'ms 10/28/2006 16:07'!
classDefineIn

	ASTChecker new
		scope: Object parseScope;
		visitNode: self classNodeVar.	
	
	^self classNodeVar binding value! !

!RBMethodDeclarationNode methodsFor: 'accessing' stamp: 'ms 10/27/2006 17:00'!
classNodeVar

	^classNodeVar! !

!RBMethodDeclarationNode methodsFor: 'accessing' stamp: 'ms 10/27/2006 17:00'!
classNodeVar: aNode

	classNodeVar := aNode! !

!RBScriptDeclarationNode methodsFor: 'accessing' stamp: 'ms 10/27/2006 16:47'!
authorInitials

	self properties pragmas do:[:each | (each keyword = #authorInitials:) ifTrue: [^each arguments first]].
	^Utilities authorInitialsPerSe ifNil:[^'saphir']! !

!RBScriptDeclarationNode methodsFor: 'accessing' stamp: 'ms 10/27/2006 16:47'!
category

	self properties pragmas do:[:each | (each keyword = #category:) ifTrue: [^each arguments first]].
	^Categorizer default! !

!RBScriptDeclarationNode methodsFor: 'accessing' stamp: 'ms 10/27/2006 16:59'!
classDefineIn
	
	^self subclassResponsibility! !

!RBScriptDeclarationNode methodsFor: 'accessing' stamp: 'ms 10/27/2006 16:59'!
classDefineIn: aClass
	
	^self subclassResponsibility! !

!RBScriptDeclarationNode methodsFor: 'accessing' stamp: 'ms 10/27/2006 17:14'!
classSide

	^classSide! !

!RBScriptDeclarationNode methodsFor: 'accessing' stamp: 'ms 10/27/2006 17:14'!
classSide: aBool

	classSide := aBool! !

!RBScriptDeclarationNode methodsFor: 'accessing' stamp: 'ms 10/27/2006 16:48'!
classVar

	^variableClass! !

!RBScriptDeclarationNode methodsFor: 'accessing' stamp: 'ms 10/27/2006 16:48'!
classVar: aVariableNode

	variableClass := aVariableNode! !

!RBScriptDeclarationNode methodsFor: 'executing' stamp: 'ms 10/27/2006 17:01'!
executeIt

	| method |
	method := CompiledMethodWithNode 
			generateMethodFromNode: self 
			trailer: self class defaultMethodTrailer.
	self scopeClass 
			logMethodSource: self source 
			forMethodWithNode: method
			inCategory: self category 
			withStamp: (Utilities changeStampWithInitials: self authorInitials) 
			notifying: [^nil].
	self scopeClass 
			addAndClassifySelector: method selector 
			withMethod: method method 
			inProtocol: self category 
			notifying: [^nil].
	self scopeClass 
			instanceSide noteCompilationOf: method selector 
			meta: self scopeClass isClassSide.
	(self classSide and:[ method method selector = #initialize])
		ifTrue:[self classDefineIn initialize].
	^method
	! !

!RBScriptDeclarationNode methodsFor: 'generation' stamp: 'ms 10/27/2006 17:12'!
generate: trailer

	scope := self scopeClass parseScope.
	[self verifyIn: self scopeClass]
			 on: SemanticWarning do: [:ex | ex correctIn: self parserCorrection].
	^super generate: trailer! !

!RBScriptDeclarationNode methodsFor: 'accessing' stamp: 'ms 10/27/2006 16:50'!
parserCorrection

	^parserCorrection ifNil: [parserCorrection := ParserCorrection scope: scope]! !

!RBScriptDeclarationNode methodsFor: 'accessing' stamp: 'ms 10/27/2006 16:59'!
scopeClass
	
	self classSide ifFalse:[^self classDefineIn]
				  ifTrue:[^self classDefineIn class]! !

RBScriptDeclarationNode subclass: #RBScriptMethodDeclarationNode
	instanceVariableNames: 'classOfScript'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Coral'!

!RBScriptMethodDeclarationNode methodsFor: 'accessing' stamp: 'ms 10/28/2006 16:23'!
classDefineIn

	^classOfScript
! !

!RBScriptMethodDeclarationNode methodsFor: 'accessing' stamp: 'ms 10/27/2006 17:17'!
classDefineIn: aClass

	classOfScript := aClass
! !

!RBScriptMethodDeclarationNode methodsFor: 'accessing' stamp: 'ms 10/27/2006 17:15'!
classSide

	^false
! !

!MacProcess methodsFor: '*coral' stamp: 'ms 10/5/2006 15:01'!
newLineInConsole
	
	self isUnix 
			ifTrue:[^String lf] 
			ifFalse:[^String cr]! !

TestCase subclass: #SaphirParserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Coral'!

!SaphirParserTest class methodsFor: 'default' stamp: 'Gwenael.Casaccio 12/10/2008 14:05'!
parserForTests
	
	^ SaphirParser! !

!SaphirParserTest methodsFor: 'testing' stamp: 'ms 11/17/2007 12:12'!
parserForTests

	^self class parserForTests! !

!SaphirParserTest methodsFor: 'testing' stamp: 'Gwenael.Casaccio 12/10/2008 13:13'!
testParser

	self shouldnt: [self parserForTests parseScript: (ReadStream on: '[| a |]
	Point >> color: aColor with: aSize
    	[
		self color: aColor.
		self size: aSize
    	]')] raise: Error.

	self shouldnt: [self parserForTests parseScript: (ReadStream on: '
	Point >> color: aColor with: aSize
    	[
		self color: aColor.
		self size: aSize
    	]
	[2 + 9]')] raise: Error.

	self shouldnt: [self parserForTests parseScript: (ReadStream on: '[| a |
	a := 12.]
	Point >> color: aColor with: aSize
    	[
		self color: aColor.
		self size: aSize
    	]')] raise: Error.

	self shouldnt: [self parserForTests parseScript: (ReadStream on: '[| a |]
	Point >> color: aColor with: aSize
    	[
		self color: aColor.
		self size: aSize
    	]
	Point >> color: aColor with: aSize
    	[
		self color: aColor.
		self size: aSize
    	]')] raise: Error.

	self shouldnt: [self parserForTests parseScript: (ReadStream on: '[| a |]
	Point >> color: aColor with: aSize
    	[
		self color: aColor.
		self size: aSize
    	]
	[7 + 9.]
	Point >> color: aColor with: aSize
    	[
		self color: aColor.
		self size: aSize
    	]')] raise: Error.

	self shouldnt: [self parserForTests parseScript: (ReadStream on: '[| a |]
	Point >> color: aColor with: aSize
    	[
		self color: aColor.
		self size: aSize
    	]
	[7 + 9.]
	Point class >> color: aColor with: aSize
    	[
		self color: aColor.
		self size: aSize
    	]')] raise: Error! !

TestCase subclass: #ScriptInterpreterTest
	instanceVariableNames: 'classNameExecutingScript'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Coral'!

!ScriptInterpreterTest methodsFor: 'utilities' stamp: 'Gwenael.Casaccio 12/10/2008 14:04'!
parseAndInterpretString: aString

	^ ScriptInterpreter parseAndInterpret: (ReadStream on: aString)
	! !

!ScriptInterpreterTest methodsFor: 'runing' stamp: 'ms 1/25/2008 15:34'!
tearDown

	Smalltalk at: #SaBox ifPresent:[:class | class removeFromSystem]! !

!ScriptInterpreterTest methodsFor: 'testing' stamp: 'ms 1/25/2008 15:31'!
testScript
	| interpreter |
	self shouldnt: [interpreter := self parseAndInterpretString: '[
	Object subclass: #SaBox
		instanceVariableNames: ''bob''
		classVariableNames: ''''
		poolDictionaries: ''''
		category: ''SandBox''
	]

	SaBox >> initialize
	[
		<category: ''initialize release''>
		<authorInitials: ''him''>
		bob := ''Script test working''.
	]

	SaBox >> printOn: aStream
	[
		"<category: ''printing''>
		<authorInitials: ''him''>"
		aStream nextPutAll: bob
	]

	SaBox class >> dummy
	[
		<authorInitials: ''him''>
		^3
	]

	[
	SaBox new printString.
	]'] raise: Error.

	self assert: (Smalltalk at: #SaBox ifAbsent:[nil]) notNil.
	self assert: interpreter result = 'Script test working'.! !

!ScriptInterpreterTest methodsFor: 'testing' stamp: 'ms 1/25/2008 15:32'!
testScriptBash
	self shouldnt: [self parseAndInterpretString: '#!!/bin/sh', String lf, '[
			Transcript show: ''Scrip shell 1 working'', String cr
			]'] raise: Error.
	
	self shouldnt: [self parseAndInterpretString: '#!!/bin/sh', String cr, '[
			Transcript show: ''Script shell 2 working'', String cr
			]'] raise: Error.
	
	self shouldnt: [self parseAndInterpretString: '#!!/bin/sh'] raise: Error! !

!ScriptInterpreterTest methodsFor: 'testing' stamp: 'ms 1/25/2008 15:34'!
testScriptConsole

	self shouldnt: [self parseAndInterpretString: '#!!/bin/sh', String lf, '[
			Console print: ''Scrip shell 1 working'', String cr
			]'] raise: Error.
	
	self shouldnt: [self parseAndInterpretString: '#!!/bin/sh', String lf, '[
			Console printError: ''Scrip shell error working'', String cr
			]'] raise: Error.
	
	self shouldnt: [self parseAndInterpretString: '#!!/bin/sh', String lf, '[
			Console read
			]'] raise: Error! !

Object subclass: #Console
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Coral'!

!Console class methodsFor: 'console' stamp: 'ms 10/1/2006 16:15'!
closeConsole

	(OSProcess thisOSProcess isKindOf: WindowsProcess) 
		ifTrue: [OSProcess thisOSProcess closeConsole]! !

!Console class methodsFor: 'console' stamp: 'ms 10/5/2006 14:16'!
newLine
	
	^OSProcess thisOSProcess newLineInConsole! !

!Console class methodsFor: 'console' stamp: 'ms 10/1/2006 18:50'!
nextPutAll: aStream

	OSProcess thisOSProcess stdOut nextPutAll: aStream! !

!Console class methodsFor: 'console' stamp: 'ms 10/1/2006 16:15'!
openConsole

	(OSProcess thisOSProcess isKindOf: WindowsProcess) 
		ifTrue: [OSProcess thisOSProcess openConsole]! !

!Console class methodsFor: 'console' stamp: 'ms 10/1/2006 18:10'!
print: aStream

	OSProcess thisOSProcess stdOut nextPutAll: aStream! !

!Console class methodsFor: 'console' stamp: 'ms 10/1/2006 18:10'!
printError: aStream

	OSProcess thisOSProcess stdErr nextPutAll: aStream! !

!Console class methodsFor: 'console' stamp: 'ms 10/27/2006 13:54'!
printNl: aStream

	OSProcess thisOSProcess stdOut nextPutAll: aStream, Console newLine! !

!Console class methodsFor: 'console' stamp: 'ms 10/1/2006 18:34'!
read

	^OSProcess thisOSProcess stdIn readUpToNewLine! !

Object subclass: #CoralREADME
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Coral'!

!CoralREADME commentStamp: 'on 2/24/2009 16:41' prior: 0!
This project lives here:

http://www.squeaksource.com/Coral/

To load Coral, simply evaluate the following in a fresh image:

ScriptLoader new installer ss project: 'Coral'; install: 'LoadCoral'.

For more information (workspace documentation on class side), just evaluate:

self initialize
!

!CoralREADME class methodsFor: 'comment' stamp: 'on 2/25/2009 12:15'!
faq
	^ '"Q How does the image know how to interpret scripts?
A ScriptInterpreter class>>initialize registers itself as a startup class

Q Why can''t SmaCC load in the Coral/Saphir parser?
A Because it is an RBParser, not a SmaCCParser
"'! !

!CoralREADME class methodsFor: 'initialization' stamp: 'on 2/25/2009 12:15'!
initialize
	super initialize.
	
	self openWorkspaceLabeled: 'READ ME' withContents: self readMe.
	self openWorkspaceLabeled: 'TO DO' withContents: self todo.
	self openWorkspaceLabeled: 'FAQ' withContents: self faq.! !

!CoralREADME class methodsFor: 'private' stamp: 'on 2/24/2009 16:33'!
openWorkspaceLabeled: label withContents: contents
	| info |
	info := SHWorkspace new.
	info contents: contents.
	info openLabel: label! !

!CoralREADME class methodsFor: 'comment' stamp: 'on 2/25/2009 14:03'!
readMe
	^ '"INSTRUCTIONS

[We assume you are on a Mac -- you will need to adapt these instructions for other platforms ...]

- Save this image as ''coral.image''

- Install the following Squeak VM in /Applications/Squeak:

http://homepage.mac.com/johnmci/.Public/Squeak%203.8.21beta1U.app.zip

- Save the following script into the file ''hello.st''

[
	Console print: ''Coral is working'', String lf.
	Console print: ''Yahoo!!''
]

Save the following shell script as ''coral.sh'' and make it executable:

#!! /bin/sh
vm=''/Applications/Squeak/Squeak 3.8.21beta1U.app/Contents/MacOS/Squeak VM Opt''
"$vm" -headless coral.image $1

Now you should be able to run the coral script from the command line as follows:

./coral.sh hello.st"
'! !

!CoralREADME class methodsFor: 'comment' stamp: 'on 2/25/2009 14:02'!
todo
	^ '"TO DO ITEMS
- clean up dead code
- support for #!! notation
- installer for #!! script runner
- passing arguments to scripts
- pipes and filters (stdin and stdout)
- redirecting Smalltalk errors to stderr
- evaluating external Unix commands (cf. backtick commands)
- multi-=platform support (installers?)
- debug mode for scripts (escape to image)
- mechanism to specify required packages for scripts
- local cache for required packages
- environment to develop and debug scripts (extend class browser?)
- demo scripts
- tutorial"'! !

Object subclass: #FmFileEntry
	instanceVariableNames: 'drive pathComponents parent name fileSize creationTime modificationTime options'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Coral'!

FmFileEntry subclass: #FmDirectoryEntry
	instanceVariableNames: 'children'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Coral'!

!FmDirectoryEntry class methodsFor: 'instance creation' stamp: 'mu 6/15/2006 23:18'!
default 
	"FmDirectoryEntry default"
	^FmDirectoryEntry on: FileDirectory default
	! !

!FmDirectoryEntry class methodsFor: 'instance creation' stamp: 'mu 6/11/2006 13:55'!
on: aFileDirectry 
	"FmDirectory on: FileDirectory default"
	| inst |
	inst := self new.
	inst pathName: aFileDirectry pathName.
	^ inst! !

!FmDirectoryEntry class methodsFor: 'instance creation' stamp: 'mu 6/11/2006 18:46'!
parent 
	"FmDirectory parent"
	^self default parent
	! !

!FmDirectoryEntry methodsFor: 'enumeration' stamp: 'mu 9/13/2006 19:45'!
allChildrenDo: aBlock
	self childrenDo: 
		[:child | 
		aBlock value: child.
		child allChildrenDo: aBlock]! !

!FmDirectoryEntry methodsFor: 'enumeration' stamp: 'mu 9/13/2006 19:49'!
allDirectoriesDo: aBlock
	self directoriesDo: 
		[:child | 
		aBlock value: child.
		child allDirectoriesDo: aBlock]! !

!FmDirectoryEntry methodsFor: 'enumeration' stamp: 'mu 9/13/2006 19:54'!
allFilesDo: aBlock
	self childrenDo: 
		[:child | 
		child isFile ifTrue: [aBlock value: child] ifFalse: [child allFilesDo: aBlock]]! !

!FmDirectoryEntry methodsFor: 'archive operations' stamp: 'mu 9/21/2006 11:18'!
archive
	^self archiveMatching: [:ent | true]! !

!FmDirectoryEntry methodsFor: 'archive operations' stamp: 'mu 9/21/2006 11:20'!
archiveMatching: aBlock
	"Get a zip archive object filtered with matching block"
	^ZipArchive new addTree: self asFileDirectory assureExistence match: aBlock! !

!FmDirectoryEntry methodsFor: 'converting' stamp: 'mu 9/21/2006 10:21'!
asDirectoryEntry
	^self! !

!FmDirectoryEntry methodsFor: 'converting' stamp: 'mu 6/15/2006 23:25'!
asFileDirectory
	"return lagacy FileDirectory"
	^FileDirectory on: self pathName! !

!FmDirectoryEntry methodsFor: 'actions-directory' stamp: 'mu 6/15/2006 21:54'!
assureExistence
	self asFileDirectory assureExistence.
	^self! !

!FmDirectoryEntry methodsFor: 'dictionary-like' stamp: 'mu 6/18/2006 18:33'!
at: localFileName 
	^self contentsOf: (self asFileDirectory readOnlyFileNamed: localFileName)! !

!FmDirectoryEntry methodsFor: 'dictionary-like' stamp: 'mu 7/27/2006 17:37'!
at: localFileName ifAbsent: block 
	^ [self at: localFileName]
		on: FileDoesNotExistException
		do: [:ex | block value]! !

!FmDirectoryEntry methodsFor: 'dictionary-like' stamp: 'mu 6/18/2006 18:34'!
at: localFileName put: contents 
	self assureExistence.
	self setContentsOf: (self asFileDirectory forceNewFileNamed: localFileName) to: contents.
	^contents! !

!FmDirectoryEntry methodsFor: 'dictionary-like' stamp: 'mu 8/10/2006 18:17'!
binaryAt: localFileName 
	^self contentsOf: (self asFileDirectory readOnlyFileNamed: localFileName) binary! !

!FmDirectoryEntry methodsFor: 'dictionary-like' stamp: 'mu 8/10/2006 18:47'!
binaryAt: localFileName ifAbsent: block 
	^ [self binaryAt: localFileName]
		on: FileDoesNotExistException
		do: [:ex | block value]! !

!FmDirectoryEntry methodsFor: 'dictionary-like' stamp: 'mu 9/21/2006 10:07'!
binaryAt: localFileName put: contents 
	^self at: localFileName put: contents asByteArray! !

!FmDirectoryEntry methodsFor: 'accessing' stamp: 'mu 6/11/2006 17:37'!
children
	children ifNil: [self initChildren].
	^children! !

!FmDirectoryEntry methodsFor: 'enumeration' stamp: 'mu 9/13/2006 19:43'!
childrenDo: aBlock
	^self children do: aBlock! !

!FmDirectoryEntry methodsFor: 'actions-directory' stamp: 'mu 9/21/2006 10:30'!
copyTo: aDirectoryEntryOrString 
	| toDir |
	toDir := aDirectoryEntryOrString asDirectoryEntry assureExistence.

	self
		filesDo: [:file | file copyTo: (toDir / file name)].
	
	self
		directoriesDo: [:dir | 
			toDir := toDir pathName / dir name.
			dir copyTo: toDir]! !

!FmDirectoryEntry methodsFor: 'actions-directory' stamp: 'mu 6/18/2006 18:29'!
delete
	self parent asFileDirectory deleteDirectory: self name! !

!FmDirectoryEntry methodsFor: 'accessing' stamp: 'mu 6/11/2006 17:26'!
directories
	^self children select: [:each | each isFile not]! !

!FmDirectoryEntry methodsFor: 'enumeration' stamp: 'mu 9/13/2006 19:42'!
directoriesDo: aBlock
	^self directories do: aBlock! !

!FmDirectoryEntry methodsFor: 'enumeration' stamp: 'mu 6/18/2006 18:49'!
directoriesMatches: selectionBlock
	^self directories select: selectionBlock! !

!FmDirectoryEntry methodsFor: 'accessing' stamp: 'mu 6/20/2006 00:22'!
directory
	^self directories ifEmpty: [] ifNotEmpty: [:ds | ds first]! !

!FmDirectoryEntry methodsFor: 'testing' stamp: 'mu 8/10/2006 19:36'!
exists
	^FileDirectory default directoryExists: self pathName ! !

!FmDirectoryEntry methodsFor: 'accessing' stamp: 'mu 6/20/2006 00:22'!
file
	^self files ifEmpty: [] ifNotEmpty: [:fs | fs first]! !

!FmDirectoryEntry methodsFor: 'accessing' stamp: 'mu 6/11/2006 17:27'!
files
	^self children select: [:each | each isFile]! !

!FmDirectoryEntry methodsFor: 'enumeration' stamp: 'mu 9/13/2006 19:40'!
filesDo: aBlock
	^self files do: aBlock! !

!FmDirectoryEntry methodsFor: 'enumeration' stamp: 'mu 6/18/2006 18:48'!
filesMatches: selectionBlock
	^self files select: selectionBlock! !

!FmDirectoryEntry methodsFor: 'private' stamp: 'mu 9/13/2006 19:11'!
initChildren
	| dir ents |
	dir := FileDirectory on: self pathName.
	self exists ifFalse: [^children _ #()].
	ents := dir entries collect: [:each | FmFileEntry entry: each].
	ents do: [:each | each parent: self].
	children := ents.
	^children! !

!FmDirectoryEntry methodsFor: 'testing' stamp: 'mu 6/11/2006 13:44'!
isDirectory
	^true! !

!FmDirectoryEntry methodsFor: 'testing' stamp: 'mu 6/11/2006 17:27'!
isFile
	^false! !

!FmDirectoryEntry methodsFor: 'dictionary-like' stamp: 'mu 7/27/2006 17:35'!
keys
	^self files! !

!FmDirectoryEntry methodsFor: 'enumeration' stamp: 'mu 6/18/2006 18:48'!
latestFileMatches: selectionBlock
	| entries |
	entries _ self filesMatches: selectionBlock.
	entries ifEmpty: [^nil].
	^(entries sort: [:a :b | a modificationTime > b modificationTime]) first! !

!FmDirectoryEntry methodsFor: 'enumeration' stamp: 'mu 6/18/2006 18:48'!
oldestFileMatches: selectionBlock
	| entries |
	entries _ self filesMatches: selectionBlock.
	entries ifEmpty: [^nil].
	^(entries sort: [:a :b | a modificationTime > b modificationTime]) last! !

!FmDirectoryEntry methodsFor: 'actions-directory' stamp: 'mu 10/12/2006 20:07'!
recursiveDelete
	self exists ifTrue: [self asFileDirectory recursiveDelete]! !

!FmDirectoryEntry methodsFor: 'initialize-release' stamp: 'mu 9/13/2006 19:37'!
refresh
	super refresh.
	children _ nil! !

!FmDirectoryEntry methodsFor: 'dictionary-like' stamp: 'mu 6/18/2006 18:34'!
removeKey: localFileName 
	^self asFileDirectory deleteFileNamed: localFileName! !

!FmDirectoryEntry methodsFor: 'dictionary-like' stamp: 'mu 9/20/2006 18:10'!
removeKey: localFileName ifAbsent: failBlock
	^self asFileDirectory deleteFileNamed: localFileName ifAbsent: failBlock! !

!FmDirectoryEntry methodsFor: 'archive operations' stamp: 'mu 9/22/2006 10:56'!
writeArchiveTo: aFileEntryOrString 
	Utilities
		informUserDuring: [:bar | 
			bar value: ('Creating archive of {1} to: {2}' translated format: {self pathName. aFileEntryOrString}).
			self archive writeTo: aFileEntryOrString asFileEntry writeStream]! !

!FmFileEntry class methodsFor: 'instance creation' stamp: 'mu 6/15/2006 21:49'!
entry: aFileEntry
	| inst |
	inst := aFileEntry isDirectory ifTrue: [FmDirectoryEntry new] ifFalse: [FmFileEntry new].
	inst name: aFileEntry name.
	inst initValuesFrom: aFileEntry.
	^inst! !

!FmFileEntry class methodsFor: 'examples' stamp: 'mu 6/20/2006 00:24'!
example1
	"FmFileEntry example1"

	"- Create subDirectory named: 'subDir'.
	 - Put a new file named: 'file1'.
	 - Write contents 'Hello!! to that file'"

	"Traditional way"
	| subDir str |
	subDir := FileDirectory default directoryNamed: 'subDir'.
	subDir assureExistence.
	[str := subDir newFileNamed: 'file1'.
	str nextPutAll: 'Hello!!']
		ensure: [str close].

	"FileMan"

	'./subDir' asDirectoryEntry at: 'file2' put: 'Hello!!'! !

!FmFileEntry class methodsFor: 'examples' stamp: 'mu 6/20/2006 00:24'!
example2
	"FmFileEntry example2"

	"FileMan's path representation is portable"
	('./subDir' / 'aaa\bbb' / 'ccc' / 'ddd\eee' / 'fff:ggg') at: 'test1' put: 'Hello2!!'.! !

!FmFileEntry class methodsFor: 'examples' stamp: 'mu 6/20/2006 00:24'!
example3
	"FmFileEntry example3"

	"Remove 'test1' file created exapmle2"
	('./subDir' / 'aaa\bbb' / 'ccc' / 'ddd\eee' / 'fff:ggg') removeKey: 'test1'.

	"Recursive delete"
	'./subDir' asDirectoryEntry recursiveDelete! !

!FmFileEntry class methodsFor: 'examples' stamp: 'mu 6/20/2006 00:24'!
example4
	"FmFileEntry example4"

	"Collect sm directory package names"
	| packageNames |
	packageNames := './sm/cache/packages' asDirectoryEntry directories collect: [:each | each directory file name].
	packageNames inspect! !

!FmFileEntry class methodsFor: 'examples' stamp: 'mu 9/21/2006 09:57'!
example5
	"FmFileEntry example5"
	
	"Write test1 file and copy it to test2 in the parent directory"

	'./test1' fileContents: 'This is a test'.
	'./test1' asFileEntry copyTo: '../test2'.

	'../test2' fileContents inspect! !

!FmFileEntry class methodsFor: 'examples' stamp: 'mu 10/5/2006 19:58'!
example6
	"FmFileEntry example6"
	
	"test1 file contents will be written to test2 using reverse filter.
	 test2 file contents will be written to test3 again using reverse filter."

	| reverseFilter |
	'test1.txt' fileContents: 'This is a test'.
	reverseFilter _ [:in :out | out nextPutAll: (in upToEnd reverse)].

	('test1.txt' asFileEntry pipe: reverseFilter to: 'test2.txt')
		pipe: reverseFilter to: 'test3.txt'.

	(#('test1.txt' 'test2.txt' 'test3.txt') collect: [:each | each fileContents]) inspect

	! !

!FmFileEntry class methodsFor: 'examples' stamp: 'mu 10/26/2006 18:38'!
example7
	"FmFileEntry example7"
	"Useful example: copy latest mcz files to releaseDir (for preparing SAR)"

	| releaseDir dir fileNames |
	releaseDir := './releasePkg' asDirectoryEntry.
	releaseDir keys isEmpty ifFalse: [releaseDir recursiveDelete].
	dir := './package-cache' asDirectoryEntry.
	fileNames := (dir keys collect: [:each | each name upTo: $.] thenSelect: [:each | each notEmpty]).
	(fileNames
		collect: [:eachName | dir
				latestFileMatches: [:each | each name beginsWith: eachName]])
		do: [:eachEnt | eachEnt copyTo: releaseDir]! !

!FmFileEntry class methodsFor: 'class initialization' stamp: 'mu 9/13/2006 19:34'!
initialize
	"FmFileEntry initialize"
	Smalltalk addToStartUpList: self! !

!FmFileEntry class methodsFor: 'instance creation' stamp: 'mu 6/11/2006 17:42'!
pathComponents: comps
	| inst |
	inst := self new.
	inst pathComponents: comps.
	^inst

	! !

!FmFileEntry class methodsFor: 'instance creation' stamp: 'mu 10/26/2006 19:21'!
pathComponents: comps drive: driveString
	| inst |
	inst := self new.
	inst pathComponents: comps detectDrive: false.
	inst drive: driveString.
	^inst

	! !

!FmFileEntry class methodsFor: 'instance creation' stamp: 'mu 6/11/2006 22:21'!
pathName: aString
	| inst |
	inst := self new.
	inst pathName: aString.
	^inst

	! !

!FmFileEntry class methodsFor: 'starting up' stamp: 'mu 9/13/2006 19:35'!
startUp
	self allSubInstancesDo: [:each | each refresh]! !

!FmFileEntry methodsFor: 'actions-path' stamp: 'mu 6/19/2006 23:29'!
, pathString
	^self concat: pathString! !

!FmFileEntry methodsFor: 'actions-path' stamp: 'mu 6/19/2006 23:52'!
/ pathString
	^self, pathString! !

!FmFileEntry methodsFor: 'comparing' stamp: 'mu 6/11/2006 18:01'!
= aFileEntry
	self class = aFileEntry class ifFalse: [^false].
	^self pathComponents = aFileEntry pathComponents! !

!FmFileEntry methodsFor: 'enumeration' stamp: 'mu 9/13/2006 19:47'!
allChildrenDo: aBlock
	"do nothing"! !

!FmFileEntry methodsFor: 'enumeration' stamp: 'mu 9/13/2006 19:50'!
allDirectoriesDo: aBlock
	"do nothing"! !

!FmFileEntry methodsFor: 'enumeration' stamp: 'mu 9/13/2006 19:51'!
allFilesDo: aBlock
	"do nothing"! !

!FmFileEntry methodsFor: 'actions-file' stamp: 'mu 9/27/2006 20:21'!
appendContents: aStringOrBytes 
	self
		appendStreamContents: [:str | 
			aStringOrBytes isString
				ifFalse: [str binary].
			str nextPutAll: aStringOrBytes]! !

!FmFileEntry methodsFor: 'accessing-stream' stamp: 'mu 9/27/2006 20:09'!
appendStream
	self exists
		ifFalse: [^ self writeStream].
	^ (FileStream fileNamed: self pathName) setToEnd! !

!FmFileEntry methodsFor: 'accessing-stream' stamp: 'mu 9/27/2006 20:15'!
appendStreamContents: blockWithArg 
	| stream |
	stream := self appendStream.
	[blockWithArg value: stream]
		ensure: [stream
				ifNotNilDo: [:s | s close]]! !

!FmFileEntry methodsFor: 'archive operations' stamp: 'mu 9/21/2006 12:03'!
archive
	"Get a zip archive object from thic file entry (need to be an existing compressed file)"
	^ZipArchive new readFrom: self pathName! !

!FmFileEntry methodsFor: 'converting' stamp: 'mu 6/19/2006 23:43'!
asDirectoryEntry
	^ FmDirectoryEntry pathComponents: self pathComponents drive: self drive! !

!FmFileEntry methodsFor: 'converting' stamp: 'mu 9/21/2006 10:20'!
asFileEntry
	^self! !

!FmFileEntry methodsFor: 'enumeration' stamp: 'mu 10/12/2006 20:18'!
assureExistence
	self exists ifTrue: [^self].
	self parent assureExistence.
	self writeStream close! !

!FmFileEntry methodsFor: 'dictionary-like' stamp: 'mu 7/30/2006 22:45'!
at: localFileName 
	^self asDirectoryEntry at: localFileName asString ifAbsent:[]! !

!FmFileEntry methodsFor: 'dictionary-like' stamp: 'mu 7/27/2006 17:33'!
at: localFileName ifAbsent: block
	^self asDirectoryEntry at: localFileName asString ifAbsent: block! !

!FmFileEntry methodsFor: 'dictionary-like' stamp: 'mu 7/19/2006 16:59'!
at: localFileName put: contents
	^self asDirectoryEntry at: localFileName asString put: contents! !

!FmFileEntry methodsFor: 'accessing' stamp: 'mu 6/11/2006 17:49'!
basicPathComponents: aCollection
	pathComponents := aCollection! !

!FmFileEntry methodsFor: 'dictionary-like' stamp: 'mu 8/10/2006 18:47'!
binaryAt: localFileName 
	^self asDirectoryEntry binaryAt: localFileName asString ifAbsent:[]! !

!FmFileEntry methodsFor: 'dictionary-like' stamp: 'mu 8/10/2006 18:47'!
binaryAt: localFileName ifAbsent: block
	^self asDirectoryEntry binaryAt: localFileName asString ifAbsent: block! !

!FmFileEntry methodsFor: 'actions-file' stamp: 'mu 8/10/2006 18:13'!
binaryContents
	^self contentsOf: self readStream binary! !

!FmFileEntry methodsFor: 'actions-file' stamp: 'mu 8/10/2006 18:15'!
binaryContents: aByteArray
	self setContentsOf: self writeStream binary to: aByteArray ! !

!FmFileEntry methodsFor: 'accessing' stamp: 'mu 8/1/2006 19:24'!
children
	^self asDirectoryEntry children! !

!FmFileEntry methodsFor: 'enumeration' stamp: 'mu 9/13/2006 19:57'!
childrenDo: aBlock
	^self asDirectoryEntry childrenDo: aBlock! !

!FmFileEntry methodsFor: 'archive operations' stamp: 'mu 9/21/2006 11:14'!
compress
	"simple gzipping"
	self readStream compressFile! !

!FmFileEntry methodsFor: 'actions-path' stamp: 'mu 7/30/2006 14:06'!
concat: pathString
	^self concatPathComponents: pathString asString asPathComponents.! !

!FmFileEntry methodsFor: 'actions-path' stamp: 'mu 6/19/2006 23:40'!
concatPathComponents: components 
	^ FmFileEntry pathComponents: (self pathComponents copy addAll: components;
			 yourself) drive: self drive! !

!FmFileEntry methodsFor: 'private' stamp: 'mu 8/10/2006 18:21'!
contentsOf: aStream
	| str conts |
	[str := aStream. 
	conts := str contents]
		ensure: [str
				ifNotNilDo: [:s | s close]].
	^ conts! !

!FmFileEntry methodsFor: 'actions-file' stamp: 'mu 10/12/2006 20:22'!
copyTo: aFileEntryOrString
	| targetEntry |
	targetEntry := aFileEntryOrString asFileEntry.
	targetEntry isDirectory ifTrue: [targetEntry := targetEntry / self name].
	
	FileDirectory default copyFile: self readStream binary toFile: targetEntry writeStream binary! !

!FmFileEntry methodsFor: 'accessing' stamp: 'mu 6/11/2006 18:19'!
creationTime
	creationTime ifNil: [self initValuesFromParent].
	^creationTime! !

!FmFileEntry methodsFor: 'accessing' stamp: 'mu 6/11/2006 14:03'!
creationTime: value
	creationTime _ value! !

!FmFileEntry methodsFor: 'actions-file' stamp: 'mu 6/18/2006 18:35'!
delete
	self parent asFileDirectory deleteFileNamed: self name! !

!FmFileEntry methodsFor: 'accessing' stamp: 'mu 8/1/2006 19:21'!
directories
	^self asDirectoryEntry directories! !

!FmFileEntry methodsFor: 'enumeration' stamp: 'mu 9/13/2006 19:57'!
directoriesDo: aBlock
	^self asDirectoryEntry directoriesDo: aBlock! !

!FmFileEntry methodsFor: 'enumeration' stamp: 'mu 8/9/2006 13:55'!
directoriesMatches: selectionBlock
	^self asDirectoryEntry directoriesMatches: selectionBlock! !

!FmFileEntry methodsFor: 'accessing' stamp: 'mu 8/1/2006 19:23'!
directory
	^self asDirectoryEntry directory! !

!FmFileEntry methodsFor: 'accessing' stamp: 'mu 10/26/2006 10:08'!
drive
	self onUnix ifTrue: [^drive _ nil].
	drive ifNil: [drive _ self parent ifNotNil: [self parent drive]].
	^drive! !

!FmFileEntry methodsFor: 'accessing' stamp: 'mu 6/11/2006 13:26'!
drive: aString
	drive _ aString! !

!FmFileEntry methodsFor: 'private' stamp: 'mu 6/18/2006 11:29'!
ensureParent
	self pathComponents size <= 1
		ifTrue: [^ nil].
	parent := FmDirectoryEntry
				pathComponents: (self pathComponents copyFrom: 1 to: self pathComponents size - 1)
				drive: self drive.
	^ parent! !

!FmFileEntry methodsFor: 'testing' stamp: 'mu 8/10/2006 19:30'!
exists
	^FileDirectory default fileExists: self pathName ! !

!FmFileEntry methodsFor: 'accessing-file name' stamp: 'mu 6/19/2006 23:27'!
extension
	^self nameVersionExtension last! !

!FmFileEntry methodsFor: 'archive operations' stamp: 'mu 9/22/2006 10:49'!
extractAllTo: aFileEntryOrString 
	| dir |
	dir := aFileEntryOrString asDirectoryEntry asFileDirectory.
	Utilities
		informUserDuring: [:bar | self archive
				extractAllTo: dir
				informing: bar
				overwrite: true]! !

!FmFileEntry methodsFor: 'accessing' stamp: 'mu 8/1/2006 19:23'!
file
	^self asDirectoryEntry file! !

!FmFileEntry methodsFor: 'actions-file' stamp: 'mu 8/10/2006 18:12'!
fileContents
	"Default is text mode"
	^self textContents! !

!FmFileEntry methodsFor: 'actions-file' stamp: 'mu 8/10/2006 18:15'!
fileContents: aStringOrBytes 
	aStringOrBytes isString
		ifTrue: [self textContents: aStringOrBytes]
		ifFalse: [self binaryContents: aStringOrBytes]! !

!FmFileEntry methodsFor: 'accessing' stamp: 'mu 6/11/2006 18:19'!
fileSize
	fileSize ifNil: [self initValuesFromParent].
	^fileSize! !

!FmFileEntry methodsFor: 'accessing' stamp: 'mu 6/11/2006 14:07'!
fileSize: value
	fileSize _ value! !

!FmFileEntry methodsFor: 'accessing' stamp: 'mu 8/1/2006 19:22'!
files
	^self asDirectoryEntry files! !

!FmFileEntry methodsFor: 'enumeration' stamp: 'mu 9/13/2006 19:57'!
filesDo: aBlock
	^self asDirectoryEntry filesDo: aBlock! !

!FmFileEntry methodsFor: 'enumeration' stamp: 'mu 8/9/2006 13:54'!
filesMatches: selectionBlock
	^self asDirectoryEntry filesMatches: selectionBlock! !

!FmFileEntry methodsFor: 'private' stamp: 'mu 6/18/2006 11:45'!
getContentsOf: aStream
	| str conts |
	[str := aStream. 
	conts := str contents]
		ensure: [str
				ifNotNilDo: [:s | s close]].
	^ conts! !

!FmFileEntry methodsFor: 'private' stamp: 'mu 6/11/2006 18:18'!
initValuesFrom: otherEntry
	otherEntry ifNil: [^self].
	self creationTime: otherEntry creationTime.
	self modificationTime: otherEntry modificationTime.
	self fileSize: otherEntry fileSize.
	! !

!FmFileEntry methodsFor: 'private' stamp: 'mu 6/11/2006 18:18'!
initValuesFromParent
	| targets target |
	self ensureParent.
	self parent ifNil: [^self].

	targets := self isDirectory ifTrue: [self parent directories] ifFalse: [self parent files].
	target := targets detect: [:each | each = self] ifNone:[].

	self initValuesFrom: target.
	! !

!FmFileEntry methodsFor: 'testing' stamp: 'mu 6/11/2006 13:45'!
isDirectory
	^false! !

!FmFileEntry methodsFor: 'private' stamp: 'mu 10/26/2006 19:26'!
isDriveName: firstToken 
	self onWindows
		ifTrue: [^ firstToken size = 2
				and: [(firstToken endsWith: ':')
						and: [firstToken first asCharacter isDriveLetter]]].

	self onMac ifTrue: [^FileDirectory root directoryNames includes: firstToken].

	^false! !

!FmFileEntry methodsFor: 'testing' stamp: 'mu 6/11/2006 13:44'!
isFile
	^true! !

!FmFileEntry methodsFor: 'testing' stamp: 'mu 6/11/2006 17:27'!
isFileEntry
	^true! !

!FmFileEntry methodsFor: 'dictionary-like' stamp: 'mu 7/27/2006 17:35'!
keys
	^self asDirectoryEntry keys! !

!FmFileEntry methodsFor: 'enumeration' stamp: 'mu 8/9/2006 13:55'!
latestFileMatches: selectionBlock
	^self asDirectoryEntry latestFileMatches: selectionBlock! !

!FmFileEntry methodsFor: 'accessing' stamp: 'mu 6/11/2006 18:19'!
modificationTime
	modificationTime ifNil: [self initValuesFromParent].
	^modificationTime! !

!FmFileEntry methodsFor: 'accessing' stamp: 'mu 6/11/2006 14:03'!
modificationTime: value
	modificationTime := value! !

!FmFileEntry methodsFor: 'accessing' stamp: 'mu 6/11/2006 13:35'!
name
	^name! !

!FmFileEntry methodsFor: 'accessing' stamp: 'mu 6/18/2006 22:05'!
name: aString 
	name := aString.
	self pathComponents
		ifNotEmpty: [self pathComponents at: self pathComponents size put: name]! !

!FmFileEntry methodsFor: 'accessing-file name' stamp: 'mu 6/19/2006 23:26'!
nameVersionExtension
	^FileDirectory new splitNameVersionExtensionFor: self name! !

!FmFileEntry methodsFor: 'enumeration' stamp: 'mu 8/9/2006 13:55'!
oldestFileMatches: selectionBlock
	^self asDirectoryEntry oldestFileMatches: selectionBlock! !

!FmFileEntry methodsFor: 'testing' stamp: 'mu 10/26/2006 10:07'!
onMac
	^FileDirectory pathNameDelimiter = $:! !

!FmFileEntry methodsFor: 'testing' stamp: 'mu 10/26/2006 10:07'!
onUnix
	^FileDirectory pathNameDelimiter = $/! !

!FmFileEntry methodsFor: 'testing' stamp: 'mu 10/26/2006 10:07'!
onWindows
	^FileDirectory pathNameDelimiter = $\! !

!FmFileEntry methodsFor: 'accessing' stamp: 'mu 6/19/2006 23:21'!
options
	^options! !

!FmFileEntry methodsFor: 'accessing' stamp: 'mu 6/19/2006 23:21'!
options: aCollection
	options _ aCollection! !

!FmFileEntry methodsFor: 'accessing' stamp: 'mu 6/11/2006 17:41'!
parent
	parent ifNil: [parent _ self ensureParent].
	^parent! !

!FmFileEntry methodsFor: 'accessing' stamp: 'mu 6/11/2006 14:16'!
parent: aFmDirectory
	parent := aFmDirectory.

	self pathName: aFmDirectory pathName, FileDirectory slash, self name! !

!FmFileEntry methodsFor: 'accessing' stamp: 'mu 6/11/2006 13:16'!
pathComponents
	pathComponents ifNil: [pathComponents _ OrderedCollection new].
	^pathComponents! !

!FmFileEntry methodsFor: 'initialize-release' stamp: 'mu 10/26/2006 19:20'!
pathComponents: aCollection
	self pathComponents: aCollection detectDrive: true! !

!FmFileEntry methodsFor: 'initialize-release' stamp: 'mu 10/26/2006 19:19'!
pathComponents: aCollection detectDrive: detectDrive
	| tokens firstToken  |
	tokens := aCollection.
	(detectDrive and: [self isDriveName: (firstToken := aCollection first)])
		ifTrue: [self drive: firstToken.
			self
				basicPathComponents: (tokens copyFrom: 2 to: tokens size)]
		ifFalse: [self basicPathComponents: tokens].

	pathComponents ifNotEmpty: [self name: pathComponents last]! !

!FmFileEntry methodsFor: 'accessing' stamp: 'mu 6/11/2006 13:57'!
pathName
	| str |
	str _ '' writeStream.
	self printPathOn: str.
	^str contents! !

!FmFileEntry methodsFor: 'initialize-release' stamp: 'mu 10/28/2006 19:28'!
pathName: aString 
	| path tokens |
	path := aString asAbsolutePathName.
	tokens :=  path findTokens: FileDirectory slash.
	tokens ifEmpty: [^ nil].

	(self onUnix and: [path beginsWith: '/']) ifTrue: [^self pathComponents: tokens].

	(tokens size = 1) ifTrue: [ ^self pathName: (FmDirectoryEntry default concat: aString) pathName].

	self pathComponents: tokens! !

!FmFileEntry methodsFor: 'actions-pipe' stamp: 'mu 10/5/2006 19:47'!
pipe: filterBlock to: aFileEntryOrString 
	| nextEntry inStream outStream |
	nextEntry _ aFileEntryOrString asFileEntry.
	[inStream := self readStream.
	outStream := nextEntry writeStream.
	filterBlock value: inStream value: outStream]
		ensure: [inStream close.
			outStream close].
	^nextEntry
! !

!FmFileEntry methodsFor: 'actions-pipe' stamp: 'mu 10/5/2006 19:41'!
pipeRepeat: filterBlock to: aFileEntryOrString 
	^self pipeRepeat: filterBlock while: [:in :out | in atEnd not] to: aFileEntryOrString ! !

!FmFileEntry methodsFor: 'actions-pipe' stamp: 'mu 10/5/2006 19:48'!
pipeRepeat: filterBlock while: terminateBlock to: aFileEntryOrString 
	| nextEntry inStream outStream |
	nextEntry _ aFileEntryOrString asFileEntry.
	[inStream := self readStream.
	outStream := nextEntry writeStream.
	[terminateBlock value: inStream value: outStream]
		whileTrue: [filterBlock value: inStream value: outStream]]
		ensure: [inStream close.
			outStream close].
	^nextEntry! !

!FmFileEntry methodsFor: 'printing' stamp: 'mu 6/11/2006 13:40'!
printOn: aStream 
	self drive
		ifNotNilDo: [:d | aStream nextPutAll: d].
	aStream nextPutAll: FileDirectory slash.
	self pathComponents
		do: [:each | aStream nextPutAll: each]
		separatedBy: [aStream nextPutAll: FileDirectory slash]! !

!FmFileEntry methodsFor: 'printing' stamp: 'mu 6/11/2006 13:56'!
printPathOn: aStream 
	self drive
		ifNotNilDo: [:d | aStream nextPutAll: d].
	aStream nextPutAll: FileDirectory slash.
	self pathComponents
		do: [:each | aStream nextPutAll: each]
		separatedBy: [aStream nextPutAll: FileDirectory slash]! !

!FmFileEntry methodsFor: 'accessing-stream' stamp: 'mu 6/15/2006 23:23'!
readStream
	^ [FileStream readOnlyFileNamed: self pathName]
		on: FileDoesNotExistException
		do: [:ex | 
			self assureExistence.
			ex retry]! !

!FmFileEntry methodsFor: 'accessing-stream' stamp: 'mu 10/2/2006 23:52'!
readStreamContents: blockWithArg 
	| stream conts |
	stream := self readStream.
	[conts := blockWithArg value: stream]
		ensure: [stream
				ifNotNilDo: [:s | s close]].
	^ conts! !

!FmFileEntry methodsFor: 'initialize-release' stamp: 'mu 9/13/2006 19:36'!
refresh
	fileSize _ creationTime _ modificationTime _ nil! !

!FmFileEntry methodsFor: 'dictionary-like' stamp: 'mu 7/19/2006 17:00'!
removeKey: localFileName 
	^self asDirectoryEntry removeKey: localFileName asString! !

!FmFileEntry methodsFor: 'dictionary-like' stamp: 'mu 9/20/2006 18:10'!
removeKey: localFileName ifAbsent: failBlock
	^self asDirectoryEntry removeKey: localFileName asString ifAbsent: failBlock! !

!FmFileEntry methodsFor: 'actions-file' stamp: 'mu 6/18/2006 21:59'!
rename: newName
	self parent asFileDirectory rename: self name toBe: newName.
	self name: newName! !

!FmFileEntry methodsFor: 'private' stamp: 'mu 9/13/2006 20:54'!
setContentsOf: aStream to: aStringOrBytes 
	| str |
	[str := aStream.
	aStringOrBytes isString ifFalse: [str binary].
	str nextPutAll: aStringOrBytes]
		ensure: [str
				ifNotNilDo: [:s | s close]]! !

!FmFileEntry methodsFor: 'actions-file' stamp: 'mu 8/10/2006 18:12'!
textContents
	^self contentsOf: self readStream! !

!FmFileEntry methodsFor: 'actions-file' stamp: 'mu 8/10/2006 18:13'!
textContents: aString 
	self setContentsOf: self writeStream to: aString ! !

!FmFileEntry methodsFor: 'accessing-file name' stamp: 'mu 6/19/2006 23:28'!
version
	^self nameVersionExtension second! !

!FmFileEntry methodsFor: 'accessing-stream' stamp: 'mu 10/12/2006 20:26'!
writeStream
	self parent exists ifFalse: [self parent assureExistence].
	^FileStream forceNewFileNamed: self pathName! !

!FmFileEntry methodsFor: 'accessing-stream' stamp: 'mu 6/11/2006 22:15'!
writeStreamConfirming
	^FileStream newFileNamed: self pathName! !

!FmFileEntry methodsFor: 'accessing-stream' stamp: 'mu 9/27/2006 20:15'!
writeStreamContents: blockWithArg 
	| stream |
	stream := self writeStream.
	[blockWithArg value: stream]
		ensure: [stream
				ifNotNilDo: [:s | s close]]! !

Object subclass: #ScriptInterpreter
	instanceVariableNames: 'nodes results'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Coral'!

ScriptInterpreter class
	instanceVariableNames: 'fileName'!

ScriptInterpreter class
	instanceVariableNames: 'fileName'!

!ScriptInterpreter class methodsFor: 'private' stamp: 'ms 10/28/2006 23:47'!
creatScriptClass: string
	^ScriptInterpreter subclass: string asSymbol
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: ''
		category: 'Saphir-Interpreting'! !

!ScriptInterpreter class methodsFor: 'services' stamp: 'ms 10/28/2006 23:49'!
fileExecuteScript: fullName

	| fileName fileNameStream class |
	fullName ifNil: [^ Beeper beep].
	fileNameStream := WriteStream on: String new.
	(FmFileEntry pathName: fullName) name 
			detect:[:each | 
				each = $. ifFalse: [fileNameStream nextPut: each].
				each = $.].
	fileName := fileNameStream contents capitalized.
	class := self creatScriptClass: fileName.
	Cursor read showWhile: [
		self parseAndInterpret: (FileStream readOnlyFileNamed: fullName) in: class]! !

!ScriptInterpreter class methodsFor: 'file list services' stamp: 'cdlm 10/3/2006 23:50'!
fileReaderServicesForFile: fullName suffix: suffix
	
	^ (suffix = 'sct') | (suffix = 'sff') | (suffix = 'saphir')
		ifTrue:[{self serviceScriptFile}]
		ifFalse:[#()]! !

!ScriptInterpreter class methodsFor: 'runing' stamp: 'ms 12/21/2006 15:43'!
fullName
	
	^fileName! !

!ScriptInterpreter class methodsFor: 'initialize-release' stamp: 'ms 12/21/2006 15:57'!
initialize
	"self initialize"	
	Smalltalk addToStartUpList: self.
	FileList registerFileReader: self.
	Preferences setPreference: #readDocumentAtStartup toValue: false! !

!ScriptInterpreter class methodsFor: 'private' stamp: 'Gwenael.Casaccio 12/10/2008 14:03'!
interpret: nodes

	^self new nodes: nodes; interpret; yourself! !

!ScriptInterpreter class methodsFor: 'instance creation' stamp: 'ms 10/29/2006 00:15'!
interpret: anCol in: aClass

	^self new interpret: anCol in: aClass; yourself! !

!ScriptInterpreter class methodsFor: 'private' stamp: 'Gwenael.Casaccio 12/10/2008 14:03'!
jumpIfBashScript: aStream
	
	(aStream peek =$#) ifTrue: [
		[| aChar | 
		 aChar := aStream next.
		(aChar = nil) or: [(aChar = Character lf) or: [aChar = Character cr]]] whileFalse].
	^aStream! !

!ScriptInterpreter class methodsFor: 'script interpreter' stamp: 'Gwenael.Casaccio 12/10/2008 14:05'!
parseAndInterpret: aStream

	^self interpret: (SaphirParser parseScript: (self jumpIfBashScript: aStream)) ! !

!ScriptInterpreter class methodsFor: 'services' stamp: 'ms 10/29/2006 00:13'!
parseAndInterpret: aStream in: class

	^self interpret: (SaphirParser parseScript: (self jumpIfBashScript: aStream) in: class) in: class! !

!ScriptInterpreter class methodsFor: 'file list services' stamp: 'ms 8/28/2006 11:02'!
serviceScriptFile
	
	^ SimpleServiceEntry 
		provider: self 
		label: 'execute a script'
		selector: #fileExecuteScript:
		description: 'execute a script'
		buttonLabel: 'Do It'! !

!ScriptInterpreter class methodsFor: 'system startup' stamp: 'GwenaelCasaccio 1/20/2009 13:20'!
startUp

	"Smalltalk addToStartUpList: self"
	| script |
	script := ((SmalltalkImage current getSystemAttribute: 2) ifNil:['']) convertFromSystemString.
	script isEmpty ifFalse:[
		[ScriptInterpreter parseAndInterpret: (FileStream readOnlyFileNamed: script)] 
			on: Exception
			do: [ :ex | 
				Smalltalk
					logError: ex printString
					inContext: thisContext
					to: 'SqueakDebug.log'.
				Console printNl: ex].
		Console printNl: ''.
		Smalltalk quitPrimitive]! !

!ScriptInterpreter methodsFor: 'accessing' stamp: 'ms 8/28/2006 12:20'!
compiledMethods
	^compiledMethods ifNil: [compiledMethods := OrderedCollection new]! !

!ScriptInterpreter methodsFor: 'interpreter' stamp: 'Gwenael.Casaccio 12/10/2008 14:03'!
interpret

	results := nodes collect: [:each | each execute]! !

!ScriptInterpreter methodsFor: 'interpreting' stamp: 'ms 10/29/2006 00:16'!
interpret: aCol
	
	Console openConsole.
	aCol do: [:each | self compiledMethods add: (each executeIt)].
	(class canPerform: #run) ifFalse:[self error:'Script must content a run method'].
	class new perform: #run.
	Console closeConsole! !

!ScriptInterpreter methodsFor: 'interpreting' stamp: 'ms 10/29/2006 00:08'!
interpret: aCol in: aClass
	
	class := aClass.
	self interpret: aCol! !

!ScriptInterpreter methodsFor: 'accessing' stamp: 'Gwenael.Casaccio 12/10/2008 14:03'!
nodes
	^ nodes! !

!ScriptInterpreter methodsFor: 'accessing' stamp: 'Gwenael.Casaccio 12/10/2008 14:03'!
nodes: anObject
	nodes := anObject! !

!ScriptInterpreter methodsFor: 'accessing' stamp: 'Gwenael.Casaccio 12/10/2008 14:03'!
result

	^results last! !

Object subclass: #ScriptInterpreter2
	instanceVariableNames: 'nodes results'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Coral-DeadCode'!

!ScriptInterpreter2 class methodsFor: 'as yet unclassified' stamp: 'ms 1/25/2008 15:29'!
interpret: nodes

	^self new nodes: nodes; interpret; yourself! !

!ScriptInterpreter2 class methodsFor: 'as yet unclassified' stamp: 'ms 1/24/2008 21:33'!
jumpIfBashScript: aStream
	
	(aStream peek =$#) ifTrue: [
		[| aChar | 
		 aChar := aStream next.
		(aChar = nil) or: [(aChar = Character lf) or: [aChar = Character cr]]] whileFalse].
	^aStream! !

!ScriptInterpreter2 class methodsFor: 'as yet unclassified' stamp: 'ms 1/25/2008 15:28'!
parseAndInterpret: aStream

	^self interpret: (SaphirParser2 parseScript: (self jumpIfBashScript: aStream)) ! !

!ScriptInterpreter2 methodsFor: 'as yet unclassified' stamp: 'ms 1/25/2008 15:27'!
interpret

	results := nodes collect: [:each | each execute]! !

!ScriptInterpreter2 methodsFor: 'accessing' stamp: 'ms 1/24/2008 17:33'!
nodes
	^ nodes! !

!ScriptInterpreter2 methodsFor: 'accessing' stamp: 'ms 1/24/2008 17:33'!
nodes: anObject
	nodes := anObject! !

!ScriptInterpreter2 methodsFor: 'accessing' stamp: 'ms 1/25/2008 15:28'!
result

	^results last! !

Object subclass: #ScriptUtility
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Coral'!

!ScriptUtility class methodsFor: 'clean' stamp: 'ms 10/29/2006 01:33'!
reomveScript
	"self reomveScript"
	
	ScriptInterpreter subclasses do: [:each | each removeFromSystem]! !

!ASTChecker methodsFor: '*coral' stamp: 'ms 1/24/2008 17:06'!
acceptDoitScriptNode: aDoitNode 
	self visitNode: aDoitNode doIt! !

!ASTChecker methodsFor: '*coral' stamp: 'ms 1/24/2008 17:09'!
acceptMethodScriptNode: aMothodScript

	self visitNode: aMothodScript homeClass.
	self visitNode: aMothodScript rbMethodNode! !

!Utilities class methodsFor: '*coral' stamp: 'ms 10/2/2006 22:53'!
changeStampWithInitials: aString
	"Answer a string to be pasted into source code to mark who changed it and when."
	^ aString , ' ' , Date today mmddyyyy, ' ',
		((String streamContents: [:s | Time now print24: true on: s]) copyFrom: 1 to: 5)! !

SmaCCParser subclass: #SqueakParser
	instanceVariableNames: 'messageError'
	classVariableNames: 'DicTokens'
	poolDictionaries: ''
	category: 'Coral-DeadCode'!

!SqueakParser commentStamp: 'ajh 3/24/2003 18:24' prior: 0!
I parse Smalltalk text into a Refactory abstract syntax tree, whose root is RBMethodNode or RBDoItNode.  Methods under 'generated-*' categories were automatically generated using SmaCC.!

SqueakParser subclass: #SaphirParser2
	instanceVariableNames: 'classParseIn'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Coral-DeadCode'!

!SaphirParser2 class methodsFor: 'as yet unclassified' stamp: 'ms 11/17/2007 17:12'!
parseScript: stringOrStream
	
	| aStream |
	aStream := stringOrStream readStream.
	aStream atEnd ifTrue: [^#()].
	^self
		parseStream: aStream
		startingAt: self startingStateForScript! !

!SaphirParser2 class methodsFor: 'generated-comments' stamp: 'ms 1/24/2008 16:52'!
parserDefinitionComment

	"%id <name> <number> <negativeNumber> <binarySymbol> <period> <colon> <rightParentheses> <rightCurlyBrackets> <rightBoxBrackets> <string> <keyword> <multikeyword> <assignment> <character>;
%start Sequence MethodPattern Script;

Script:
								{#array}
|	Script ScriptStatement		{#add2:};

ClassMethod:
	<name> ""class"" "">>"" Method 	{#classDefinittionMethod:};

InstanceMethod:
	<name> "">>"" Method 			{#instanceDefinittionMethod:};
	
MethodDefinition:
	InstanceMethod		{#first:}
|	ClassMethod 		{#first:};

ScriptStatement:
	""["" Sequence ""]""	{#doitScript:}
|	MethodDefinition {#first:};

Method:
	MethodPattern ""["" Sequence ""]""						{#method:}
|	MethodPattern ""["" Pragmas Sequence	""]""		{#methodPragma:}
|	MethodPattern ""["" Pragmas Temporaries Pragmas Statements ""]"" {#methodPragmaTempsPragma:}
|	MethodPattern ""["" Temporaries Pragmas Statements ""]"" {#methodTempsPragma:};

MethodPattern:
	<name>										{#unaryMessage:}
|	<binarySymbol> Variable						{#messagePart:}
|	<binarySymbol> error						{#argumentNameMissing:}
|	KeywordMethodPattern						{#first:};

KeywordMethodPattern:
	<keyword> Variable							{#messagePart:}
|	<keyword> error								{#argumentNameMissing:}
|	KeywordMethodPattern <keyword> Variable	{#addMessagePart:}
|	KeywordMethodPattern <keyword> error		{#argumentNameMissing:};

Pragmas:
	""<"" PragmaMessage "">""							{#pragma:}
|	""<"" PragmaMessage error							{#pragmaEndMissing:}
|	""<"" error											{#pragmaMissing:}
|	Pragmas ""<"" PragmaMessage "">""					{#pragmas:}
|	Pragmas ""<"" PragmaMessage error				{#pragmaEndMissing:}
|	Pragmas ""<"" error								{#pragmaMissing:};

Sequence:
	Statements									{#sequence:}
|	Temporaries Statements						{#sequenceWithTemps:};

Temporaries:
	""||""											{#arrayAddToken:}
|	""|"" TemporaryVariables ""|""					{#secondAddToken:}
| 	""|"" TemporaryVariables error					{#verticalBarMissing:};

TemporaryVariables:
												{#array}
|	TemporaryVariables Variable				{#add:};

Statements:
												{#array}
|	StatementList <period>?						{#first:}
|	StatementList <period> ""^"" Expression <period>?	{#returnAdd:}
|	""^"" Expression <period>?						{#return:};

StatementList:
	Expression									{#firstIn:}
|	StatementList <period> Expression				{#add3:};

Block:
	""["" BlockArgs ""|"" Sequence <rightBoxBrackets>	{#blockWithArgs:}
|	""["" Sequence <rightBoxBrackets>				{#blockNoArgs:}
|	""["" BlockArgs <rightBoxBrackets>				{#blockArgs:}
|	""["" BlockArgs ""||"" TemporaryVariables ""|"" Statements <rightBoxBrackets> {#blockWithTemps:};

BlockArgs:
	<colon> Variable									{#secondIn:}
|	<colon>	error									{#argumentNameMissing:}
|	BlockArgs <colon> Variable						{#add3:}
|	BlockArgs <colon> error							{#argumentNameMissing:};

Expression:
	Assignment									{#first:}
|	Cascade										{#first:}
|	Primary									{#first:};

Primary:
	""("" Expression <rightParentheses>				{#secondWithParenthesis:}
|	Array										{#first:}
|	Block										{#first:}
|	Literal										{#first:}
|	Variable									{#first:};

Assignment:
	Variable <assignment> Expression				{#assignment:}
|	Variable <assignment> error					{#expressionMissing:};

Cascade:
	MessageSend								{#first:}
|	Cascade <semicolon> Message					{#cascade:}
|	Cascade <semicolon> error 					{#cascadeMMissing:};

MessageSend:
	KeywordMessageSend						{#first:}
|	BinaryMessageSend							{#first:}
|	UnaryMessageSend							{#first:};

Message:
	UnaryMessage								{#first:}
|	BinaryMessage								{#first:}
|	KeywordMessage							{#first:};

KeywordMessageSend:
	BinaryMessageSend KeywordMessage			{#messageSend:}
|	UnaryMessageSend KeywordMessage			{#messageSend:}
|	Primary KeywordMessage					{#messageSend:};

KeywordMessage:
	<keyword> KeywordArgument				{#messagePart:}
|	<keyword> error 							{#argumentMissing:}
|	KeywordMessage <keyword> KeywordArgument {#addMessagePart:}
|	KeywordMessage <keyword> error 			{#argumentMissing:};

KeywordArgument:
	BinaryMessageSend							{#first:}
|	UnaryMessageSend							{#first:}
|	Primary									{#first:};

BinaryMessageSend:
	BinaryMessageSend BinaryMessage			{#messageSend:}
|	UnaryMessageSend BinaryMessage			{#messageSend:}
|	Primary BinaryMessage						{#messageSend:};

BinaryMessage :
	<binarySymbol> BinaryArgument				{#messagePart:}
|	<binarySymbol> error 						{#argumentMissing:};
 
BinaryArgument:
	UnaryMessageSend							{#first:}
|	Primary									{#first:};

UnaryMessageSend :
	UnaryMessageSend UnaryMessage			{#messageSend:}
|	Primary UnaryMessage						{#messageSend:};

UnaryMessage :
	<name>										{#unaryMessage:};

Array:
	""{"" Statements <rightCurlyBrackets>			{#array:};

Variable:
	<name>										{#variable:};

Literal:
	""true""										{#litTrue:}
|	""false""										{#litFalse:}
|	""nil""										{#litNil:}
|	<number>									{#litNumber:}
|	<negativeNumber>							{#litNumber:} 
|	<character>									{#litChar:}
|	<string>										{#litString:}
|	""#"" <string>									{#litStringSymbol:}
|	""#"" <name>									{#litSymbol:}
|	""#"" <binarySymbol>							{#litSymbol:}
|	""#"" <keyword>								{#litSymbol:}
|	""#"" <multikeyword>							{#litSymbol:}
|	""#"" <alternateKeyword>						{#litSymbol:}
|	""#"" ""["" ByteArray <rightBoxBrackets>			{#litArray:}
|	""#"" ""("" LiteralArray <rightParentheses>		{#litArray:}
|	""#:""											{#litString:};

ByteArray:
												{#byteStream}
|	ByteArray <number>							{#byteStreamPut:};

LiteralArray:
												{#stream}
|	LiteralArray ArrayLiteral					{#streamPut:};

ArrayLiteral:
	Literal										{#value:}
|	<name>										{#valueSymbol:}
|	<binarySymbol>								{#valueSymbol:}
|	<keyword>									{#valueSymbol:}
|	<multikeyword>								{#valueSymbol:}
|	<alternateKeyword>							{#valueSymbol:}
|	""("" LiteralArray <rightParentheses>			{#contents2:}
|	""["" ByteArray <rightBoxBrackets>				{#contents2:}
|	<anyChar>									{#valueSymbol:};

PragmaMessage:
	Apicall										{#messagePragma:}
| 	Primitive 									{#messagePragma:} 
|	MessagePragma 								{#messagePragma:};

MessagePragma:
	KeyWordMessagePragma						{#pragmaMessage:}
|	BinaryMessagePragma						{#pragmaMessage:}
|	UnaryMessage 								{#pragmaUnaryMessage:};
									
BinaryMessagePragma:
	<binarySymbol> PrimaryPragma				{#messagePart:}
|	<binarySymbol> error 						{#argumentMissing:};
										
KeyWordMessagePragma:
	<keyword> PrimaryPragma					{#messagePart:}
|	<keyword> error 							{#literalMissing:}
|	KeywordMessage <keyword> PrimaryPragma	{#addMessagePart:}
|	KeywordMessage <keyword> error 			{#literalMissing:};

PrimaryPragma:
	Array										{#first:}
|	Block										{#first:}
|	Literal										{#first:}
|	Variable									{#first:};

Apicall:
	TypeCall ExternalType IndexName ""("" ParameterApicall <rightParentheses>	{#externalCall:}
|	TypeCall ExternalType IndexName ""("" ParameterApicall <rightParentheses> ""module:"" <string>	{#externalModuleCall:};

IndexName:
	<string>										{#externalFunction:}
|	<number>									{#externalIndex:};

TypeCall:
	""apicall:""									{#callConvention:}
|	""cdecl:""										{#callConvention:};

ParameterApicall:
	ExternalType 								{#parameterExtCall:}
|	ParameterApicall ExternalType 				{#parametersExtCall:};

ExternalType:
	<name>										{#externalType:}	
|	<name> ""*""									{#externalTypePointer:};

Primitive:
	""primitive:"" <string>							{#primitiveString:}
|	""primitive:"" <number>						{#primitiveNumber:}
|	""primitive:"" error 							{#primitiveArgMissing:}
|	""primitive:"" <string> ""module:"" <string>		{#primitiveModule:}
|	""primitive:"" <string> ""module:"" error 			{#moduleArgMissing:};"! !

!SaphirParser2 class methodsFor: 'generated-accessing' stamp: 'ms 1/24/2008 16:52'!
scannerClass
	^SaphirScanner2! !

!SaphirParser2 class methodsFor: 'generated-starting states' stamp: 'ms 1/24/2008 16:52'!
startingStateForMethodPattern
	^3! !

!SaphirParser2 class methodsFor: 'generated-starting states' stamp: 'ms 1/24/2008 16:52'!
startingStateForScript
	^4! !

!SaphirParser2 class methodsFor: 'generated-starting states' stamp: 'ms 1/24/2008 16:52'!
startingStateForSequence
	^2! !

!SaphirParser2 methodsFor: 'reduction actions' stamp: 'ms 11/17/2007 16:10'!
add2: nodes
	
	^nodes first copyWith: nodes second! !

!SaphirParser2 methodsFor: 'reduction actions' stamp: 'ms 1/24/2008 21:40'!
classDefinittionMethod: nodes

	^RBMethodScript new 
		rbMethodNode: nodes last;
		homeClass: (RBVariableNode new identifierToken: nodes first);
		classSide! !

!SaphirParser2 methodsFor: 'reduction actions' stamp: 'ms 1/24/2008 16:51'!
doitScript: nodes

	^RBDoitScript body: nodes second! !

!SaphirParser2 methodsFor: 'reduction actions' stamp: 'ms 1/24/2008 18:54'!
instanceDefinittionMethod: nodes

	^RBMethodScript new 
		rbMethodNode: nodes last;
		homeClass: (RBVariableNode new identifierToken: nodes first);
		instanceSide! !

!SaphirParser2 methodsFor: 'reduction actions' stamp: 'ms 11/17/2007 12:44'!
method: nodes

	^ RBMethodNode new
		selectorParts: nodes first first
		arguments: nodes first last;
		body: nodes third! !

!SaphirParser2 methodsFor: 'reduction actions' stamp: 'ms 1/24/2008 21:53'!
methodPragma: nodes
	^RBMethodNode new
		selectorParts: nodes first first
		arguments: nodes first last;
		body: nodes fourth;
		pragmas:nodes third! !

!SaphirParser2 methodsFor: 'generated-reduction actions' stamp: 'ms 1/24/2008 16:52'!
reduceActionForOptionalXXXperiodX1: nodes 
	^ nil! !

!SaphirParser2 methodsFor: 'generated-reduction actions' stamp: 'ms 1/24/2008 16:52'!
reduceActionForOptionalXXXperiodX2: nodes 
	^ nodes at: 1! !

!SaphirParser2 methodsFor: 'generated-tables' stamp: 'ms 1/24/2008 16:52'!
reduceTable
	^#(
#(42 4 #classDefinittionMethod:)
#(43 3 #instanceDefinittionMethod:)
#(44 1 #first:)
#(44 1 #first:)
#(45 3 #pragma:)
#(45 3 #pragmaEndMissing:)
#(45 2 #pragmaMissing:)
#(45 4 #pragmas:)
#(45 4 #pragmaEndMissing:)
#(45 3 #pragmaMissing:)
#(46 1 #reduceFor:)
#(47 0 #array)
#(47 2 #first:)
#(47 5 #returnAdd:)
#(47 3 #return:)
#(48 1 #variable:)
#(49 2 #messagePart:)
#(49 2 #argumentNameMissing:)
#(49 3 #addMessagePart:)
#(49 3 #argumentNameMissing:)
#(50 1 #messagePragma:)
#(50 1 #messagePragma:)
#(50 1 #messagePragma:)
#(51 0 #array)
#(51 2 #add:)
#(52 1 #firstIn:)
#(52 3 #add3:)
#(53 0 #reduceActionForOptionalXXXperiodX1:)
#(53 1 #reduceActionForOptionalXXXperiodX2:)
#(54 1 #first:)
#(54 1 #first:)
#(54 1 #first:)
#(55 2 #secondIn:)
#(55 2 #argumentNameMissing:)
#(55 3 #add3:)
#(55 3 #argumentNameMissing:)
#(56 5 #blockWithArgs:)
#(56 3 #blockNoArgs:)
#(56 3 #blockArgs:)
#(56 7 #blockWithTemps:)
#(57 3 #assignment:)
#(57 3 #expressionMissing:)
#(58 1 #first:)
#(58 3 #cascade:)
#(58 3 #cascadeMMissing:)
#(59 3 #secondWithParenthesis:)
#(59 1 #first:)
#(59 1 #first:)
#(59 1 #first:)
#(59 1 #first:)
#(60 3 #array:)
#(61 1 #litTrue:)
#(61 1 #litFalse:)
#(61 1 #litNil:)
#(61 1 #litNumber:)
#(61 1 #litNumber:)
#(61 1 #litChar:)
#(61 1 #litString:)
#(61 2 #litStringSymbol:)
#(61 2 #litSymbol:)
#(61 2 #litSymbol:)
#(61 2 #litSymbol:)
#(61 2 #litSymbol:)
#(61 2 #litSymbol:)
#(61 4 #litArray:)
#(61 4 #litArray:)
#(61 1 #litString:)
#(62 1 #sequence:)
#(62 2 #sequenceWithTemps:)
#(63 3 #doitScript:)
#(63 1 #first:)
#(64 1 #first:)
#(64 1 #first:)
#(64 1 #first:)
#(65 2 #messageSend:)
#(65 2 #messageSend:)
#(65 2 #messageSend:)
#(66 2 #messageSend:)
#(66 2 #messageSend:)
#(66 2 #messageSend:)
#(67 2 #messageSend:)
#(67 2 #messageSend:)
#(68 1 #unaryMessage:)
#(69 2 #messagePart:)
#(69 2 #argumentMissing:)
#(70 2 #messagePart:)
#(70 2 #argumentMissing:)
#(70 3 #addMessagePart:)
#(70 3 #argumentMissing:)
#(71 1 #first:)
#(71 1 #first:)
#(71 1 #first:)
#(72 1 #first:)
#(72 1 #first:)
#(73 0 #array)
#(73 2 #add2:)
#(74 0 #byteStream)
#(74 2 #byteStreamPut:)
#(75 0 #stream)
#(75 2 #streamPut:)
#(76 1 #value:)
#(76 1 #valueSymbol:)
#(76 1 #valueSymbol:)
#(76 1 #valueSymbol:)
#(76 1 #valueSymbol:)
#(76 1 #valueSymbol:)
#(76 3 #contents2:)
#(76 3 #contents2:)
#(76 1 #valueSymbol:)
#(77 4 #method:)
#(77 5 #methodPragma:)
#(77 7 #methodPragmaTempsPragma:)
#(77 6 #methodTempsPragma:)
#(78 6 #externalCall:)
#(78 8 #externalModuleCall:)
#(79 2 #primitiveString:)
#(79 2 #primitiveNumber:)
#(79 2 #primitiveArgMissing:)
#(79 4 #primitiveModule:)
#(79 4 #moduleArgMissing:)
#(80 1 #pragmaMessage:)
#(80 1 #pragmaMessage:)
#(80 1 #pragmaUnaryMessage:)
#(81 2 #messagePart:)
#(81 2 #literalMissing:)
#(81 3 #addMessagePart:)
#(81 3 #literalMissing:)
#(82 2 #messagePart:)
#(82 2 #argumentMissing:)
#(83 1 #first:)
#(83 1 #first:)
#(83 1 #first:)
#(83 1 #first:)
#(84 1 #callConvention:)
#(84 1 #callConvention:)
#(85 1 #externalType:)
#(85 2 #externalTypePointer:)
#(86 1 #externalFunction:)
#(86 1 #externalIndex:)
#(87 1 #parameterExtCall:)
#(87 2 #parametersExtCall:)
#(90 1 #unaryMessage:)
#(90 2 #messagePart:)
#(90 2 #argumentNameMissing:)
#(90 1 #first:)
#(91 1 #first:)
#(91 1 #first:)
#(91 1 #first:)
#(92 1 #arrayAddToken:)
#(92 3 #secondAddToken:)
#(92 3 #verticalBarMissing:)
)! !

!SaphirParser2 methodsFor: 'generated-tables' stamp: 'ms 1/24/2008 16:52'!
transitionTable
	^#(
#(3 382 11 382 25 21 73 382 88)
#(3 25 1 29 2 33 5 37 6 41 11 45 14 49 17 53 18 57 19 61 20 65 21 69 22 73 23 77 24 81 25 85 33 89 47 93 48 97 52 101 54 105 56 109 57 113 58 117 59 121 60 125 61 129 62 133 65 137 66 141 67 50 88 145 91 149 92)
#(3 153 25 157 26 161 28 165 49 169 90)
#(3 382 11 382 25 173 73 382 88)
#(3 177 11 181 25 185 42 189 43 193 44 197 63 0 88)
#(2 598 4 5 6 10 11 14 17 18 19 20 21 22 23 24 25 33 36 88)
#(3 98 2 98 25 201 51 98 89)
#(3 37 6 41 11 45 14 49 17 53 18 57 19 61 20 65 21 69 22 73 23 77 24 81 25 85 33 93 48 205 54 105 56 109 57 113 58 117 59 121 60 125 61 133 65 137 66 141 67 145 91)
#(3 37 6 41 11 45 14 49 17 53 18 57 19 61 20 65 21 69 22 73 23 77 24 81 25 85 33 93 48 209 54 105 56 109 57 113 58 117 59 121 60 125 61 133 65 137 66 141 67 145 91)
#(3 25 1 29 2 33 5 37 6 41 11 45 14 49 17 53 18 57 19 61 20 65 21 69 22 73 23 77 24 81 25 85 33 50 36 213 39 89 47 93 48 97 52 101 54 217 55 105 56 109 57 113 58 117 59 121 60 125 61 221 62 133 65 137 66 141 67 145 91 149 92)
#(3 33 5 37 6 41 11 45 14 49 17 53 18 57 19 61 20 65 21 69 22 73 23 77 24 81 25 85 33 50 37 225 47 93 48 97 52 101 54 105 56 109 57 113 58 117 59 121 60 125 61 133 65 137 66 141 67 145 91)
#(2 270 6 9 10 11 17 18 19 20 21 22 23 24 25 26 27 28 30 33 34 36 37 38 40 41 88 89)
#(3 229 6 233 11 237 24 241 25 245 26 249 27 253 28 257 30)
#(2 210 6 9 10 11 17 18 19 20 21 22 23 24 25 26 27 28 30 33 34 36 37 38 40 41 88 89)
#(2 214 6 9 10 11 17 18 19 20 21 22 23 24 25 26 27 28 30 33 34 36 37 38 40 41 88 89)
#(2 218 6 9 10 11 17 18 19 20 21 22 23 24 25 26 27 28 30 33 34 36 37 38 40 41 88 89)
#(2 222 6 9 10 11 17 18 19 20 21 22 23 24 25 26 27 28 30 33 34 36 37 38 40 41 88 89)
#(2 226 6 9 10 11 17 18 19 20 21 22 23 24 25 26 27 28 30 33 34 36 37 38 40 41 88 89)
#(2 234 6 9 10 11 17 18 19 20 21 22 23 24 25 26 27 28 30 33 34 36 37 38 40 41 88 89)
#(2 66 1 2 9 10 11 25 26 28 29 34 36 37 38 39 40 88 89)
#(2 230 6 9 10 11 17 18 19 20 21 22 23 24 25 26 27 28 30 33 34 36 37 38 40 41 88 89)
#(2 274 10 36 88)
#(3 202 10 202 25 202 26 202 28 261 29 202 34 202 36 202 37 202 38 202 88)
#(3 114 10 265 34 114 36 114 37 269 53 114 88)
#(2 106 10 34 36 37 88)
#(2 194 10 25 26 28 34 36 37 38 40 88)
#(2 122 10 34 36 37 38 88)
#(3 126 10 126 34 126 36 126 37 126 38 273 40 126 88)
#(3 130 10 277 25 281 26 285 28 130 34 130 36 130 37 130 38 289 68 293 69 297 70 130 88)
#(2 190 10 25 26 28 34 36 37 38 40 88)
#(2 198 10 25 26 28 34 36 37 38 40 88)
#(2 0 88)
#(2 586 10 34 36 37 38 40 88)
#(3 590 10 281 26 285 28 590 34 590 36 590 37 590 38 590 40 301 69 305 70 590 88)
#(3 594 10 277 25 281 26 285 28 594 34 594 36 594 37 594 38 594 40 309 68 313 69 317 70 594 88)
#(2 174 10 34 36 37 38 40 88)
#(3 33 5 37 6 50 10 41 11 45 14 49 17 53 18 57 19 61 20 65 21 69 22 73 23 77 24 81 25 85 33 50 36 321 47 93 48 97 52 101 54 105 56 109 57 113 58 117 59 121 60 125 61 133 65 137 66 141 67 50 88 145 91)
#(2 570 11 88)
#(3 81 25 325 48 329 89)
#(3 81 25 333 48 337 89)
#(3 582 11 341 26 582 88)
#(2 0 88)
#(3 177 11 181 25 185 42 189 43 193 44 197 63 0 88)
#(3 25 1 29 2 33 5 37 6 50 10 41 11 45 14 49 17 53 18 57 19 61 20 65 21 69 22 73 23 77 24 81 25 85 33 89 47 93 48 97 52 101 54 105 56 109 57 113 58 117 59 121 60 125 61 345 62 133 65 137 66 141 67 145 91 149 92)
#(3 349 7 353 8)
#(2 18 11 25 88)
#(2 14 11 25 88)
#(2 286 11 25 88)
#(2 386 11 25 88)
#(3 357 2 81 25 361 48 365 89)
#(3 114 10 369 34 114 36 114 37 373 53 114 88)
#(2 377 38)
#(3 81 25 381 48 385 89)
#(3 389 1 393 2 397 36 401 39)
#(2 405 36)
#(2 409 37)
#(3 398 6 398 11 398 17 398 18 398 19 398 20 398 21 398 22 398 23 398 24 398 25 398 26 398 27 398 28 398 30 398 33 398 38 398 41 413 75)
#(3 390 22 390 36 417 74)
#(2 238 6 9 10 11 17 18 19 20 21 22 23 24 25 26 27 28 30 33 34 36 37 38 40 41 88 89)
#(2 242 6 9 10 11 17 18 19 20 21 22 23 24 25 26 27 28 30 33 34 36 37 38 40 41 88 89)
#(2 250 6 9 10 11 17 18 19 20 21 22 23 24 25 26 27 28 30 33 34 36 37 38 40 41 88 89)
#(2 254 6 9 10 11 17 18 19 20 21 22 23 24 25 26 27 28 30 33 34 36 37 38 40 41 88 89)
#(2 246 6 9 10 11 17 18 19 20 21 22 23 24 25 26 27 28 30 33 34 36 37 38 40 41 88 89)
#(2 258 6 9 10 11 17 18 19 20 21 22 23 24 25 26 27 28 30 33 34 36 37 38 40 41 88 89)
#(3 37 6 41 11 45 14 49 17 53 18 57 19 61 20 65 21 69 22 73 23 77 24 81 25 85 33 93 48 421 54 105 56 109 57 113 58 117 59 121 60 125 61 133 65 137 66 141 67 425 89 145 91)
#(3 429 5 37 6 118 10 41 11 45 14 49 17 53 18 57 19 61 20 65 21 69 22 73 23 77 24 81 25 85 33 118 36 118 37 93 48 433 54 105 56 109 57 113 58 117 59 121 60 125 61 133 65 137 66 141 67 118 88 145 91)
#(2 54 10 36 37 88)
#(3 277 25 281 26 285 28 437 64 441 68 445 69 449 70 453 89)
#(2 334 9 10 25 26 28 34 36 37 38 40 88 89)
#(3 37 6 41 11 45 14 49 17 53 18 57 19 61 20 65 21 69 22 73 23 77 24 81 25 85 33 457 48 105 56 461 59 121 60 125 61 465 66 469 67 473 71 477 89)
#(3 37 6 41 11 45 14 49 17 53 18 57 19 61 20 65 21 69 22 73 23 77 24 81 25 85 33 457 48 105 56 481 59 121 60 125 61 485 67 489 72 493 89)
#(2 330 10 25 26 28 34 36 37 38 40 88)
#(2 322 10 26 28 34 36 37 38 40 88)
#(3 310 10 497 26 310 34 310 36 310 37 310 38 310 40 310 88)
#(2 314 10 26 28 34 36 37 38 40 88)
#(3 302 10 497 26 302 34 302 36 302 37 302 38 302 40 302 88)
#(2 326 10 25 26 28 34 36 37 38 40 88)
#(2 318 10 26 28 34 36 37 38 40 88)
#(3 306 10 497 26 306 34 306 36 306 37 306 38 306 40 306 88)
#(2 278 10 36 88)
#(2 70 11 26 88)
#(2 74 11 26 88)
#(2 574 11 88)
#(2 578 11 88)
#(3 81 25 501 48 505 89)
#(2 509 10)
#(2 513 8)
#(3 153 25 157 26 161 28 165 49 517 77 521 90)
#(2 602 4 5 6 10 11 14 17 18 19 20 21 22 23 24 25 33 36 88)
#(2 102 2 25 89)
#(2 606 4 5 6 10 11 14 17 18 19 20 21 22 23 24 25 33 36 88)
#(2 118 10 36 37 88)
#(2 62 10 36 37 88)
#(2 186 10 25 26 28 34 36 37 38 40 88)
#(2 134 1 2 36 39)
#(2 138 1 2 36 39)
#(3 98 2 98 25 525 51)
#(3 25 1 29 2 33 5 37 6 41 11 45 14 49 17 53 18 57 19 61 20 65 21 69 22 73 23 77 24 81 25 85 33 50 36 89 47 93 48 97 52 101 54 105 56 109 57 113 58 117 59 121 60 125 61 529 62 133 65 137 66 141 67 145 91 149 92)
#(2 158 9 10 25 26 28 34 36 37 38 40 88 89)
#(3 81 25 533 48 537 89)
#(2 154 9 10 25 26 28 34 36 37 38 40 88 89)
#(2 206 9 10 25 26 28 34 36 37 38 40 88 89)
#(3 541 6 545 11 49 17 53 18 57 19 61 20 65 21 69 22 73 23 77 24 549 25 553 26 557 27 561 28 565 30 85 33 569 38 573 41 577 61 581 76)
#(3 585 22 589 36)
#(2 166 10 34 36 37 38 88)
#(2 170 10 34 36 37 38 88)
#(3 37 6 41 11 45 14 49 17 53 18 57 19 61 20 65 21 69 22 73 23 77 24 81 25 85 33 93 48 593 54 105 56 109 57 113 58 117 59 121 60 125 61 133 65 137 66 141 67 145 91)
#(2 110 10 34 36 37 88)
#(2 178 10 34 36 37 38 40 88)
#(2 290 10 34 36 37 38 40 88)
#(2 294 10 34 36 37 38 40 88)
#(3 298 10 497 26 298 34 298 36 298 37 298 38 298 40 298 88)
#(2 182 10 34 36 37 38 40 88)
#(2 202 10 25 26 28 34 36 37 38 40 88)
#(3 370 10 277 25 370 26 285 28 370 34 370 36 370 37 370 38 370 40 289 68 293 69 370 88)
#(3 362 10 362 26 285 28 362 34 362 36 362 37 362 38 362 40 301 69 362 88)
#(3 366 10 277 25 366 26 285 28 366 34 366 36 366 37 366 38 366 40 309 68 313 69 366 88)
#(2 346 10 26 34 36 37 38 40 88)
#(2 350 10 26 34 36 37 38 40 88)
#(3 378 10 277 25 378 26 378 28 378 34 378 36 378 37 378 38 378 40 289 68 378 88)
#(3 374 10 277 25 374 26 374 28 374 34 374 36 374 37 374 38 374 40 309 68 374 88)
#(2 338 10 26 28 34 36 37 38 40 88)
#(2 342 10 26 28 34 36 37 38 40 88)
#(3 37 6 41 11 45 14 49 17 53 18 57 19 61 20 65 21 69 22 73 23 77 24 81 25 85 33 457 48 105 56 461 59 121 60 125 61 465 66 469 67 597 71 601 89)
#(2 78 11 26 88)
#(2 82 11 26 88)
#(2 282 11 25 88)
#(3 153 25 157 26 161 28 165 49 605 77 521 90)
#(2 10 11 25 88)
#(2 609 11)
#(3 613 2 81 25 361 48)
#(2 617 36)
#(2 142 1 2 36 39)
#(2 146 1 2 36 39)
#(3 398 6 398 11 398 17 398 18 398 19 398 20 398 21 398 22 398 23 398 24 398 25 398 26 398 27 398 28 398 30 398 33 398 38 398 41 621 75)
#(3 390 22 390 36 625 74)
#(2 410 6 11 17 18 19 20 21 22 23 24 25 26 27 28 30 33 38 41)
#(2 418 6 11 17 18 19 20 21 22 23 24 25 26 27 28 30 33 38 41)
#(2 422 6 11 17 18 19 20 21 22 23 24 25 26 27 28 30 33 38 41)
#(2 414 6 11 17 18 19 20 21 22 23 24 25 26 27 28 30 33 38 41)
#(2 426 6 11 17 18 19 20 21 22 23 24 25 26 27 28 30 33 38 41)
#(2 266 6 9 10 11 17 18 19 20 21 22 23 24 25 26 27 28 30 33 34 36 37 38 40 41 88 89)
#(2 438 6 11 17 18 19 20 21 22 23 24 25 26 27 28 30 33 38 41)
#(2 406 6 11 17 18 19 20 21 22 23 24 25 26 27 28 30 33 38 41)
#(2 402 6 11 17 18 19 20 21 22 23 24 25 26 27 28 30 33 38 41)
#(2 394 22 36)
#(2 262 6 9 10 11 17 18 19 20 21 22 23 24 25 26 27 28 30 33 34 36 37 38 40 41 88 89)
#(3 114 10 369 34 114 36 114 37 629 53 114 88)
#(2 354 10 26 34 36 37 38 40 88)
#(2 358 10 26 34 36 37 38 40 88)
#(2 6 11 25 88)
#(3 25 1 29 2 633 4 33 5 37 6 50 10 41 11 45 14 49 17 53 18 57 19 61 20 65 21 69 22 73 23 77 24 81 25 85 33 637 45 89 47 93 48 97 52 101 54 105 56 109 57 113 58 117 59 121 60 125 61 641 62 133 65 137 66 141 67 145 91 645 92)
#(3 33 5 37 6 41 11 45 14 49 17 53 18 57 19 61 20 65 21 69 22 73 23 77 24 81 25 85 33 50 36 649 47 93 48 97 52 101 54 105 56 109 57 113 58 117 59 121 60 125 61 133 65 137 66 141 67 145 91)
#(2 150 9 10 25 26 28 34 36 37 38 40 88 89)
#(3 541 6 545 11 49 17 53 18 57 19 61 20 65 21 69 22 73 23 77 24 549 25 553 26 557 27 561 28 565 30 85 33 653 38 573 41 577 61 581 76)
#(3 585 22 657 36)
#(2 58 10 36 37 88)
#(3 661 3 665 12 669 13 277 25 673 26 677 28 681 50 685 68 689 70 693 78 697 79 701 80 705 81 709 82 713 84 717 89)
#(3 25 1 29 2 721 4 33 5 37 6 50 10 41 11 45 14 49 17 53 18 57 19 61 20 65 21 69 22 73 23 77 24 81 25 85 33 89 47 93 48 97 52 101 54 105 56 109 57 113 58 117 59 121 60 125 61 725 62 133 65 137 66 141 67 145 91 729 92)
#(2 733 10)
#(3 633 4 33 5 37 6 50 10 41 11 45 14 49 17 53 18 57 19 61 20 65 21 69 22 73 23 77 24 81 25 85 33 737 45 321 47 93 48 97 52 101 54 105 56 109 57 113 58 117 59 121 60 125 61 133 65 137 66 141 67 145 91)
#(2 741 36)
#(2 430 6 11 17 18 19 20 21 22 23 24 25 26 27 28 30 33 38 41)
#(2 434 6 11 17 18 19 20 21 22 23 24 25 26 27 28 30 33 38 41)
#(3 745 22 749 24 753 89)
#(2 538 25)
#(2 542 25)
#(3 37 6 41 11 45 14 49 17 53 18 57 19 61 20 65 21 69 22 73 23 77 24 81 25 85 33 757 48 761 56 461 59 765 60 769 61 465 66 469 67 473 71 773 83 777 89)
#(3 41 11 45 14 49 17 53 18 57 19 61 20 65 21 69 22 73 23 77 24 81 25 85 33 781 48 785 56 789 60 793 61 797 83 801 89)
#(3 805 9 809 89)
#(2 494 9 89)
#(2 813 26)
#(2 86 9 89)
#(2 90 9 89)
#(2 94 9 89)
#(2 486 9 89)
#(2 490 9 89)
#(3 817 25 821 85)
#(2 30 1 2 4 5 6 10 11 14 17 18 19 20 21 22 23 24 25 33)
#(3 661 3 665 12 669 13 277 25 673 26 677 28 825 50 685 68 689 70 693 78 697 79 701 80 705 81 709 82 713 84 829 89)
#(2 833 10)
#(3 633 4 33 5 37 6 50 10 41 11 45 14 49 17 53 18 57 19 61 20 65 21 69 22 73 23 77 24 81 25 85 33 837 45 321 47 93 48 97 52 101 54 105 56 109 57 113 58 117 59 121 60 125 61 133 65 137 66 141 67 145 91)
#(2 442 11 25 88)
#(3 721 4 33 5 37 6 50 10 41 11 45 14 49 17 53 18 57 19 61 20 65 21 69 22 73 23 77 24 81 25 85 33 841 47 93 48 97 52 101 54 105 56 109 57 113 58 117 59 121 60 125 61 133 65 137 66 141 67 145 91)
#(2 162 9 10 25 26 28 34 36 37 38 40 88 89)
#(2 470 9 89)
#(3 466 9 845 15 466 89)
#(2 474 9 89)
#(3 534 9 202 25 202 26 202 28 534 89)
#(3 526 9 194 25 194 26 194 28 526 89)
#(3 522 9 190 25 190 26 190 28 522 89)
#(3 530 9 198 25 198 26 198 28 530 89)
#(2 498 9 89)
#(3 502 9 350 26 502 89)
#(2 534 9 89)
#(2 526 9 89)
#(2 522 9 89)
#(2 530 9 89)
#(2 514 9 89)
#(2 518 9 89)
#(2 22 1 2 4 5 6 10 11 14 17 18 19 20 21 22 23 24 25 33)
#(2 26 1 2 4 5 6 10 11 14 17 18 19 20 21 22 23 24 25 33)
#(3 37 6 41 11 45 14 49 17 53 18 57 19 61 20 65 21 69 22 73 23 77 24 81 25 85 33 757 48 761 56 461 59 765 60 769 61 465 66 469 67 597 71 849 83 853 89)
#(3 857 16 546 22 546 24 546 25 546 38)
#(3 861 22 865 24 869 86)
#(3 873 9 877 89)
#(2 42 1 2 4 5 6 10 11 14 17 18 19 20 21 22 23 24 25 33)
#(2 446 11 25 88)
#(3 721 4 33 5 37 6 50 10 41 11 45 14 49 17 53 18 57 19 61 20 65 21 69 22 73 23 77 24 81 25 85 33 881 47 93 48 97 52 101 54 105 56 109 57 113 58 117 59 121 60 125 61 133 65 137 66 141 67 145 91)
#(2 885 10)
#(3 889 24 893 89)
#(2 506 9 89)
#(3 510 9 358 26 510 89)
#(2 550 22 24 25 38)
#(2 558 6)
#(2 554 6)
#(2 897 6)
#(2 34 1 2 4 5 6 10 11 14 17 18 19 20 21 22 23 24 25 33)
#(2 38 1 2 4 5 6 10 11 14 17 18 19 20 21 22 23 24 25 33)
#(2 901 10)
#(2 454 11 25 88)
#(2 478 9 89)
#(2 482 9 89)
#(3 817 25 905 85 909 87)
#(2 450 11 25 88)
#(2 562 25 38)
#(3 817 25 913 38 917 85)
#(3 458 9 921 15 458 89)
#(2 566 25 38)
#(2 925 24)
#(2 462 9 89)
)! !

SqueakParser subclass: #SqueakMethodPatternParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Coral'!

!SqueakMethodPatternParser class methodsFor: 'generated-comments' stamp: 'ms 11/19/2006 17:05'!
parserDefinitionComment

	"%id <name> <number> <negativeNumber> <binarySymbol> <period> <colon> <rightParentheses> <rightCurlyBrackets> <rightBoxBrackets> <string> <keyword> <multikeyword> <assignment> <character>;
%start MethodPattern;

Method:
	MethodPattern Body 						{#method:};

MethodPattern:
	<name>										{#unaryMessage:}
|	<binarySymbol> Variable						{#messagePart:}
|	<binarySymbol> error						{#argumentNameMissing:}
|	KeywordMethodPattern						{#first:};

KeywordMethodPattern:
	<keyword> Variable							{#messagePart:}
|	<keyword> error								{#argumentNameMissing:}
|	KeywordMethodPattern <keyword> Variable	{#addMessagePart:}
|	KeywordMethodPattern <keyword> error		{#argumentNameMissing:};
		
Variable: 
	<name>										{#variable:};
												
Body:
|	Body <decimalNumber>
|	Body <radixNumber>
|	Body <scaledNumber>
|	Body <exponentNumber>
|	Body <number>
|	Body <negativeNumber>
|	Body <string>
|	Body <name>
|	Body <keyword>
|	Body <multikeyword>
|	Body <binarySymbol>
|	Body <assignment>
|	Body <alternateKeyword>
|	Body <whitespace>
|	Body <comment>
|	Body <character>
|	Body <period>
|	Body <variableAssignment>
|	Body <rightBoxBrackets>
|	Body <rightCurlyBrackets>
|	Body <rightParentheses>
|	Body <colon>
|	Body <semicolon>
|	Body <anyChar>
|	Body ""[""
|	Body ""{""
|	Body ""(""
|	Body ""|"";"! !

!SqueakMethodPatternParser class methodsFor: 'generated-accessing' stamp: 'ms 11/19/2006 17:05'!
scannerClass
	^SqueakMethodPatternScanner! !

!SqueakMethodPatternParser class methodsFor: 'generated-starting states' stamp: 'ms 11/19/2006 17:05'!
startingStateForMethod
	^1! !

!SqueakMethodPatternParser class methodsFor: 'generated-starting states' stamp: 'ms 11/19/2006 17:05'!
startingStateForMethodPattern
	^2! !

!SqueakMethodPatternParser methodsFor: 'reduction actions' stamp: 'ms 11/19/2006 17:14'!
method: nodes

	^RBMethodNode new
		selectorParts: nodes first first arguments: nodes first second; body: (RBSequenceNode statements: #())
	
	! !

!SqueakMethodPatternParser methodsFor: 'generated-tables' stamp: 'ms 11/21/2006 08:27'!
reduceTable
	^#(
#(29 0 #reduceFor:)
#(29 2 #reduceFor:)
#(29 2 #reduceFor:)
#(29 2 #reduceFor:)
#(29 2 #reduceFor:)
#(29 2 #reduceFor:)
#(29 2 #reduceFor:)
#(29 2 #reduceFor:)
#(29 2 #reduceFor:)
#(29 2 #reduceFor:)
#(29 2 #reduceFor:)
#(29 2 #reduceFor:)
#(29 2 #reduceFor:)
#(29 2 #reduceFor:)
#(29 2 #reduceFor:)
#(29 2 #reduceFor:)
#(29 2 #reduceFor:)
#(29 2 #reduceFor:)
#(29 2 #reduceFor:)
#(29 2 #reduceFor:)
#(29 2 #reduceFor:)
#(29 2 #reduceFor:)
#(29 2 #reduceFor:)
#(29 2 #reduceFor:)
#(29 2 #reduceFor:)
#(29 2 #reduceFor:)
#(29 2 #reduceFor:)
#(29 2 #reduceFor:)
#(29 2 #reduceFor:)
#(30 1 #variable:)
#(31 1 #reduceFor:)
#(32 2 #method:)
#(33 2 #messagePart:)
#(33 2 #argumentNameMissing:)
#(33 3 #addMessagePart:)
#(33 3 #argumentNameMissing:)
#(34 1 #unaryMessage:)
#(34 2 #messagePart:)
#(34 2 #argumentNameMissing:)
#(34 1 #first:)
)! !

!SqueakMethodPatternParser methodsFor: 'generated-tables' stamp: 'ms 11/19/2006 17:05'!
transitionTable
	^#(
#(3 13 12 17 13 21 15 25 32 29 33 33 34)
#(3 13 12 17 13 21 15 29 33 37 34)
#(2 150 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 35)
#(3 41 12 45 30 49 36)
#(3 41 12 53 30 57 36)
#(2 0 35)
#(3 162 1 162 2 162 3 162 4 162 5 162 6 162 7 162 8 162 9 162 10 162 11 162 12 61 13 162 14 162 15 162 16 162 17 162 18 162 19 162 20 162 21 162 22 162 23 162 24 162 25 162 26 162 27 162 28 162 35)
#(3 6 1 6 2 6 3 6 4 6 5 6 6 6 7 6 8 6 9 6 10 6 11 6 12 6 13 6 14 6 15 6 16 6 17 6 18 6 19 6 20 6 21 6 22 6 23 6 24 6 25 6 26 6 27 6 28 65 29 6 35)
#(2 0 35)
#(2 122 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 35)
#(2 134 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 35)
#(2 138 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 35)
#(2 154 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 35)
#(2 158 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 35)
#(3 41 12 69 30 73 36)
#(3 77 1 81 2 85 3 89 4 93 5 97 6 101 7 105 8 109 9 113 10 117 11 121 12 125 13 129 14 133 15 137 16 141 17 145 18 149 19 153 20 157 21 161 22 165 23 169 24 173 25 177 26 181 27 185 28 130 35)
#(2 142 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 35)
#(2 146 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 35)
#(2 106 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 35)
#(2 110 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 35)
#(2 118 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 35)
#(2 114 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 35)
#(2 10 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 35)
#(2 14 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 35)
#(2 18 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 35)
#(2 22 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 35)
#(2 26 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 35)
#(2 30 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 35)
#(2 34 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 35)
#(2 38 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 35)
#(2 42 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 35)
#(2 46 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 35)
#(2 50 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 35)
#(2 54 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 35)
#(2 58 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 35)
#(2 62 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 35)
#(2 66 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 35)
#(2 70 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 35)
#(2 74 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 35)
#(2 78 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 35)
#(2 82 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 35)
#(2 86 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 35)
#(2 90 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 35)
#(2 94 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 35)
#(2 98 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 35)
#(2 102 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 35)
)! !

!SqueakParser class methodsFor: 'initialize' stamp: 'ms 10/10/2006 23:28'!
initialize
	"self initialize"
	
	| scanner |
	super initialize.
	scanner := SqueakScanner new.
	DicTokens := Dictionary new.
	DicTokens at: scanner colonId put: 'colon'.
	DicTokens at: scanner binarySymbolId put: 'binary symbol'.
	DicTokens at: scanner nameId put: 'variable'.
	DicTokens at: scanner negativeNumberId put: 'negative number'.
	DicTokens at: scanner periodId put: 'period'.
	DicTokens at: scanner rightBoxBracketsId put: 'right box bracket'.
	DicTokens at: scanner rightCurlyBracketsId put: 'right curly brackets'.
	DicTokens at: scanner rightParenthesesId put: 'right parentheses'.
	DicTokens at: scanner stringId put: 'string'.
	DicTokens at: scanner multikeywordId put: 'multi keyword'.
	DicTokens at: scanner keywordId put: 'keyword'.
	DicTokens at: scanner characterId put: 'character'.
	DicTokens at: scanner assignmentId put: 'assignment'! !

!SqueakParser class methodsFor: 'parsing' stamp: 'ajh 2/27/2003 16:40'!
parseDoIt: stringOrStream

	| sequence |
	sequence _ self
		parseStream: stringOrStream readStream
		startingAt: self startingStateForSequence.
	^ (RBDoItNode body: sequence)
		source: stringOrStream contents! !

!SqueakParser class methodsFor: 'parsing' stamp: 'ms 12/13/2007 01:35'!
parseExpression: stringOrStream 
	
	^ self parseStream: stringOrStream readStream startingAt: self startingStateForSequence.! !

!SqueakParser class methodsFor: 'parsing' stamp: 'ms 12/2/2006 22:27'!
parseMethod: stringOrStream 
	
	^ (self parseStream: stringOrStream readStream startingAt: self startingStateForMethod)
		source: stringOrStream contents! !

!SqueakParser class methodsFor: 'parsing' stamp: 'ms 11/19/2006 17:16'!
parseMethodPattern: stringOrStream 
	^ SqueakMethodPatternParser parseMethod: stringOrStream! !

!SqueakParser class methodsFor: 'generated-comments' stamp: 'ms 4/7/2007 03:32'!
parserDefinitionComment

	"%id <name> <number> <negativeNumber> <binarySymbol> <period> <colon> <rightParentheses> <rightCurlyBrackets> <rightBoxBrackets> <string> <keyword> <multikeyword> <assignment> <character>;
%start Sequence MethodPattern;

Method:
	MethodPattern Sequence						{#method:}
|	MethodPattern Pragmas Sequence			{#methodPragma:}
|	MethodPattern Pragmas Temporaries Pragmas Statements {#methodPragmaTempsPragma:}
|	MethodPattern Temporaries Pragmas Statements {#methodTempsPragma:};

MethodPattern:
	<name>										{#unaryMessage:}
|	<binarySymbol> Variable						{#messagePart:}
|	<binarySymbol> error						{#argumentNameMissing:}
|	KeywordMethodPattern						{#first:};

KeywordMethodPattern:
	<keyword> Variable							{#messagePart:}
|	<keyword> error								{#argumentNameMissing:}
|	KeywordMethodPattern <keyword> Variable	{#addMessagePart:}
|	KeywordMethodPattern <keyword> error		{#argumentNameMissing:};

Pragmas:
	""<"" PragmaMessage "">""							{#pragma:}
|	""<"" PragmaMessage error							{#pragmaEndMissing:}
|	""<"" error											{#pragmaMissing:}
|	Pragmas ""<"" PragmaMessage "">""					{#pragmas:}
|	Pragmas ""<"" PragmaMessage error				{#pragmaEndMissing:}
|	Pragmas ""<"" error								{#pragmaMissing:};

Sequence:
	Statements									{#sequence:}
|	Temporaries Statements						{#sequenceWithTemps:};

Temporaries:
	""||""											{#arrayAddToken:}
|	""|"" TemporaryVariables ""|""					{#secondAddToken:}
| 	""|"" TemporaryVariables error					{#verticalBarMissing:};

TemporaryVariables:
												{#array}
|	TemporaryVariables Variable				{#add:};

Statements:
												{#array}
|	StatementList <period>?						{#first:}
|	StatementList <period> ""^"" Expression <period>?	{#returnAdd:}
|	""^"" Expression <period>?						{#return:};

StatementList:
	Expression									{#firstIn:}
|	StatementList <period> Expression				{#add3:};

Block:
	""["" BlockArgs ""|"" Sequence <rightBoxBrackets>	{#blockWithArgs:}
|	""["" Sequence <rightBoxBrackets>				{#blockNoArgs:}
|	""["" BlockArgs <rightBoxBrackets>				{#blockArgs:}
|	""["" BlockArgs ""||"" TemporaryVariables ""|"" Statements <rightBoxBrackets> {#blockWithTemps:};

BlockArgs:
	<colon> Variable									{#secondIn:}
|	<colon>	error									{#argumentNameMissing:}
|	BlockArgs <colon> Variable						{#add3:}
|	BlockArgs <colon> error							{#argumentNameMissing:};

Expression:
	Assignment									{#first:}
|	Cascade										{#first:}
|	Primary									{#first:};

Primary:
	""("" Expression <rightParentheses>				{#secondWithParenthesis:}
|	Array										{#first:}
|	Block										{#first:}
|	Literal										{#first:}
|	Variable									{#first:};

Assignment:
	Variable <assignment> Expression				{#assignment:}
|	Variable <assignment> error					{#expressionMissing:};

Cascade:
	MessageSend								{#first:}
|	Cascade <semicolon> Message					{#cascade:}
|	Cascade <semicolon> error 					{#cascadeMMissing:};

MessageSend:
	KeywordMessageSend						{#first:}
|	BinaryMessageSend							{#first:}
|	UnaryMessageSend							{#first:};

Message:
	UnaryMessage								{#first:}
|	BinaryMessage								{#first:}
|	KeywordMessage							{#first:};

KeywordMessageSend:
	BinaryMessageSend KeywordMessage			{#messageSend:}
|	UnaryMessageSend KeywordMessage			{#messageSend:}
|	Primary KeywordMessage					{#messageSend:};

KeywordMessage:
	<keyword> KeywordArgument				{#messagePart:}
|	<keyword> error 							{#argumentMissing:}
|	KeywordMessage <keyword> KeywordArgument {#addMessagePart:}
|	KeywordMessage <keyword> error 			{#argumentMissing:};

KeywordArgument:
	BinaryMessageSend							{#first:}
|	UnaryMessageSend							{#first:}
|	Primary									{#first:};

BinaryMessageSend:
	BinaryMessageSend BinaryMessage			{#messageSend:}
|	UnaryMessageSend BinaryMessage			{#messageSend:}
|	Primary BinaryMessage						{#messageSend:};

BinaryMessage :
	<binarySymbol> BinaryArgument				{#messagePart:}
|	<binarySymbol> error 						{#argumentMissing:};
 
BinaryArgument:
	UnaryMessageSend							{#first:}
|	Primary									{#first:};

UnaryMessageSend :
	UnaryMessageSend UnaryMessage			{#messageSend:}
|	Primary UnaryMessage						{#messageSend:};

UnaryMessage :
	<name>										{#unaryMessage:};

Array:
	""{"" Statements <rightCurlyBrackets>			{#array:};

Variable:
	<name>										{#variable:};

Literal:
	""true""										{#litTrue:}
|	""false""										{#litFalse:}
|	""nil""										{#litNil:}
|	<number>									{#litNumber:}
|	<negativeNumber>							{#litNumber:} 
|	<character>									{#litChar:}
|	<string>										{#litString:}
|	""#"" <string>									{#litStringSymbol:}
|	""#"" <name>									{#litSymbol:}
|	""#"" <binarySymbol>							{#litSymbol:}
|	""#"" <keyword>								{#litSymbol:}
|	""#"" <multikeyword>							{#litSymbol:}
|	""#"" <alternateKeyword>						{#litSymbol:}
|	""#"" ""["" ByteArray <rightBoxBrackets>			{#litArray:}
|	""#"" ""("" LiteralArray <rightParentheses>		{#litArray:}
|	""#:""											{#litString:};

ByteArray:
												{#byteStream}
|	ByteArray <number>							{#byteStreamPut:};

LiteralArray:
												{#stream}
|	LiteralArray ArrayLiteral					{#streamPut:};

ArrayLiteral:
	Literal										{#value:}
|	<name>										{#valueSymbol:}
|	<binarySymbol>								{#valueSymbol:}
|	<keyword>									{#valueSymbol:}
|	<multikeyword>								{#valueSymbol:}
|	<alternateKeyword>							{#valueSymbol:}
|	""("" LiteralArray <rightParentheses>			{#contents2:}
|	""["" ByteArray <rightBoxBrackets>				{#contents2:}
|	<anyChar>									{#valueSymbol:};

PragmaMessage:
	Apicall										{#messagePragma:}
| 	Primitive 									{#messagePragma:} 
|	MessagePragma 								{#messagePragma:};

MessagePragma:
	KeyWordMessagePragma						{#pragmaMessage:}
|	BinaryMessagePragma						{#pragmaMessage:}
|	UnaryMessage 								{#pragmaUnaryMessage:};
									
BinaryMessagePragma:
	<binarySymbol> PrimaryPragma				{#messagePart:}
|	<binarySymbol> error 						{#argumentMissing:};
										
KeyWordMessagePragma:
	<keyword> PrimaryPragma					{#messagePart:}
|	<keyword> error 							{#literalMissing:}
|	KeywordMessage <keyword> PrimaryPragma	{#addMessagePart:}
|	KeywordMessage <keyword> error 			{#literalMissing:};

PrimaryPragma:
	Array										{#first:}
|	Block										{#first:}
|	Literal										{#first:}
|	Variable									{#first:};

Apicall:
	TypeCall ExternalType IndexName ""("" ParameterApicall <rightParentheses>	{#externalCall:}
|	TypeCall ExternalType IndexName ""("" ParameterApicall <rightParentheses> ""module:"" <string>	{#externalModuleCall:};

IndexName:
	<string>										{#externalFunction:}
|	<number>									{#externalIndex:};

TypeCall:
	""apicall:""									{#callConvention:}
|	""cdecl:""										{#callConvention:};

ParameterApicall:
	ExternalType 								{#parameterExtCall:}
|	ParameterApicall ExternalType 				{#parametersExtCall:};

ExternalType:
	<name>										{#externalType:}	
|	<name> ""*""									{#externalTypePointer:};

Primitive:
	""primitive:"" <string>							{#primitiveString:}
|	""primitive:"" <number>						{#primitiveNumber:}
|	""primitive:"" error 							{#primitiveArgMissing:}
|	""primitive:"" <string> ""module:"" <string>		{#primitiveModule:}
|	""primitive:"" <string> ""module:"" error 			{#moduleArgMissing:};"! !

!SqueakParser class methodsFor: 'generated-accessing' stamp: 'ms 4/7/2007 03:32'!
scannerClass
	^SqueakScanner! !

!SqueakParser class methodsFor: 'generated-starting states' stamp: 'ms 4/7/2007 03:32'!
startingStateForMethod
	^1! !

!SqueakParser class methodsFor: 'generated-starting states' stamp: 'ms 4/7/2007 03:32'!
startingStateForMethodPattern
	^3! !

!SqueakParser class methodsFor: 'generated-starting states' stamp: 'ms 4/7/2007 03:32'!
startingStateForSequence
	^2! !

!SqueakParser class methodsFor: 'tokens' stamp: 'ms 10/10/2006 22:04'!
tokenDescription: id
	
	^DicTokens at: id! !

!SqueakParser class methodsFor: 'tokens' stamp: 'ms 10/10/2006 22:24'!
tokensId
	
	^DicTokens keys! !

!SqueakParser methodsFor: 'private' stamp: 'ms 7/13/2006 10:02'!
actionForCurrentToken

	| ids action |
	ids := currentToken id.
	1 to: ids size do: [:i | 
		action := self actionFor: (ids at: i).
		(action bitAnd: self actionMask) = self errorAction ifFalse: [^ action].

		"Convert negative number to binarySymbol"
		(self isNegativeNumberId:(ids at: i)) ifTrue: [
			^self negativeNumberToBinaryString].

		"Ignore repeating periods"
		(self isEmptyStatementId: (ids at: i)) ifTrue: [
			^ self ignoreEmptyStatement].

	].
	^ self errorAction! !

!SqueakParser methodsFor: 'reduction actions' stamp: 'ajh 3/15/2003 00:01'!
add3: nodes

	^ nodes first copyWith: nodes third! !

!SqueakParser methodsFor: 'reduction actions' stamp: 'ajh 3/14/2003 23:59'!
add: nodes

	^ nodes first copyWith: nodes second! !

!SqueakParser methodsFor: 'reduction actions' stamp: 'ajh 3/14/2003 23:54'!
addMessagePart: nodes

	^ {nodes first first copyWith: nodes second.
	   nodes first second copyWith: nodes third}! !

!SqueakParser methodsFor: 'error handling' stamp: 'ms 11/10/2006 22:39'!
argumentMissing: nodes
	
	messageError := 'Argument expected'.
	^nodes! !

!SqueakParser methodsFor: 'error handling' stamp: 'ms 11/8/2007 13:52'!
argumentNameMissing: nodes
	
	messageError := 'Argument name or | expected'.
	^nodes! !

!SqueakParser methodsFor: 'reduction actions' stamp: 'ajh 3/14/2003 23:58'!
array

	^ #()! !

!SqueakParser methodsFor: 'reduction actions' stamp: 'ms 9/18/2006 18:00'!
array: nodes

	^ (RBArrayNode
		leftBrace: nodes first start
		rightBrace: nodes third stop
		statements: nodes second)
			firstToken: nodes first;
			lastToken: nodes last;
			yourself.! !

!SqueakParser methodsFor: 'reduction actions' stamp: 'ms 9/18/2006 22:47'!
arrayAddToken: nodes
	
	^OrderedCollection with: #() with: nodes first with: nodes first! !

!SqueakParser methodsFor: 'reduction actions' stamp: 'ajh 3/15/2003 00:07'!
assignment: nodes

	^ RBAssignmentNode
		variable: nodes first
		value: nodes third! !

!SqueakParser methodsFor: 'reduction actions' stamp: 'ms 9/18/2006 18:43'!
blockArgs: nodes

	^ (RBBlockNode
		arguments: nodes second
		body: (RBSequenceNode statements: #()))
		left: nodes first start;
		right: nodes third stop;
		firstToken: nodes first;
		lastToken: nodes last;
		yourself! !

!SqueakParser methodsFor: 'reduction actions' stamp: 'ms 9/18/2006 18:43'!
blockNoArgs: nodes

	^ (RBBlockNode
		body: nodes second)
		left: nodes first start;
		right: nodes third stop;
		firstToken: nodes first;
		lastToken: nodes last;
		yourself! !

!SqueakParser methodsFor: 'reduction actions' stamp: 'ms 9/18/2006 18:39'!
blockWithArgs: nodes

	^ (RBBlockNode
		arguments: nodes second
		body: nodes fourth)
		left: nodes first start;
		right: nodes fifth stop;
		firstToken: nodes first;
		lastToken: nodes last;
		yourself! !

!SqueakParser methodsFor: 'reduction actions' stamp: 'ms 9/18/2006 23:07'!
blockWithTemps: nodes

	^ (RBBlockNode
		arguments: nodes second
		body: ((RBSequenceNode
			temporaries: nodes fourth
			statements: nodes sixth) firstToken: nodes third))
		left: nodes first start;
		right: nodes seventh stop;
		firstToken: nodes first;
		lastToken: nodes last;
		yourself! !

!SqueakParser methodsFor: 'reduction actions' stamp: 'ajh 3/15/2003 00:23'!
byteStream

	^ ByteArray new writeStream! !

!SqueakParser methodsFor: 'reduction actions' stamp: 'ajh 3/15/2003 00:25'!
byteStreamPut: nodes

	^ nodes first
		nextPut: nodes second value asNumber;
		yourself! !

!SqueakParser methodsFor: 'reduction actions' stamp: 'ms 9/17/2006 01:01'!
callConvention: nodes
	| descriptorClass |
	descriptorClass := Smalltalk at: #ExternalFunction ifAbsent:[^nil].
	^OrderedCollection with:(descriptorClass callingConventionFor: nodes first value) with: nodes first.! !

!SqueakParser methodsFor: 'reduction actions' stamp: 'ajh 3/15/2003 00:12'!
cascade: nodes

	^ (nodes first isKindOf: RBMessageNode)
		ifTrue: [RBCascadeNode messages:
			{nodes first.
			 RBMessageNode new
				receiver: nodes first receiver
				selectorParts: nodes third first
				arguments: nodes third last}]
		ifFalse: [RBCascadeNode messages:
			(nodes first messages copyWith:
				(RBMessageNode new
					receiver: nodes first messages first receiver
					selectorParts: nodes third first
					arguments: nodes third last))]! !

!SqueakParser methodsFor: 'error handling' stamp: 'ms 11/10/2006 22:36'!
cascadeMMissing: nodes
	
	messageError := 'Cascade expected'.
	^nodes! !

!SqueakParser methodsFor: 'error handling' stamp: 'ms 10/6/2006 15:14'!
checkForErrors
	"If we have an error correction installed, we might have handled the errors. If we did, we don't 
	want to return the result, so we raise a final exception that can't be proceeded."

	errorToken isNil ifTrue: [^self].
	currentToken := errorToken.
	self reportErrorMessage: (messageError ifNil:['Token not expected'])
	
	! !

!SqueakParser methodsFor: 'error handling' stamp: 'ms 10/10/2006 22:23'!
collectAcceptableToken
	
	^self class tokensId select:[:each | (self actionFor: each) ~~ self errorAction]! !

!SqueakParser methodsFor: 'reduction actions' stamp: 'ajh 3/15/2003 00:27'!
contents2: nodes

	^ nodes second contents! !

!SqueakParser methodsFor: 'error handling' stamp: 'ms 10/20/2006 17:52'!
expressionMissing: nodes
	
	messageError := 'Expression expected'.
	^nodes! !

!SqueakParser methodsFor: 'reduction actions' stamp: 'ms 9/17/2006 01:40'!
externalCall: nodes

	| fn |

	Smalltalk at: #ExternalLibraryFunction ifPresent:[:xfn|
		fn := xfn name: nodes third
				module: nil 
				callType: nodes first first
				returnType: nodes second first
				argumentTypes: nodes fifth first contents.
	].
	^ OrderedCollection with: (Pragma keyword: #primitive: arguments: #(120)) with: fn with: 120  with: nodes first second with: nodes fifth second! !

!SqueakParser methodsFor: 'reduction actions' stamp: 'ms 7/25/2006 13:37'!
externalFunction: nodes
	^nodes first value withoutQuoting asSymbol.! !

!SqueakParser methodsFor: 'reduction actions' stamp: 'ms 7/25/2006 13:37'!
externalIndex: nodes
	^nodes first value.! !

!SqueakParser methodsFor: 'reduction actions' stamp: 'ms 9/17/2006 01:40'!
externalModuleCall: nodes
	| fn |
	Smalltalk at: #ExternalLibraryFunction ifPresent:[:xfn|
		fn := xfn name: nodes third 
				module: nodes last value withoutQuoting asSymbol
				callType: nodes first first
				returnType: nodes second first
				argumentTypes: nodes fifth first contents.
	].
	^ OrderedCollection with: (Pragma keyword: #primitive: arguments: #(120)) with: fn with: 120 with: nodes first second with: nodes last! !

!SqueakParser methodsFor: 'reduction actions' stamp: 'ms 9/17/2006 01:30'!
externalType: nodes
	
	^OrderedCollection with: (self externalTypeOn: nodes) with: nodes last
	! !

!SqueakParser methodsFor: 'private' stamp: 'ms 9/4/2006 00:20'!
externalTypeOn: aNode
	| xType descriptorClass |
	descriptorClass := Smalltalk at: #ExternalFunction ifAbsent:[^nil].
	xType := descriptorClass atomicTypeNamed: aNode first value.
	xType == nil ifTrue:["Look up from class scope"
		Symbol hasInterned: aNode first value ifTrue:[:sym|
			xType := descriptorClass structTypeNamed: sym]].
	xType == nil ifTrue:[
		"Raise an error if user is there"
		self interactive ifTrue:[^nil].
		"otherwise go over it silently"
		xType := descriptorClass forceTypeNamed: aNode first value].
	^xType.! !

!SqueakParser methodsFor: 'reduction actions' stamp: 'ms 9/17/2006 01:34'!
externalTypePointer: nodes

	| xType |
	xType := self externalTypeOn: nodes.
	xType ifNil:[^nodes].
	^OrderedCollection with: xType asPointerType with: nodes last! !

!SqueakParser methodsFor: 'error handling' stamp: 'ms 11/11/2006 17:21'!
findErrorHandlerIfNoneUseErrorNumber: anInteger

	| state reduceEntry items reduceIndex |
	state := self stateErrorShiftInto.
	state = 0 
		ifFalse:[reduceIndex := (self findReduceActionForState: state).
				stateStack addLast: state.
			     reduceEntry := self reduceTable at: reduceIndex.
			     items := OrderedCollection new: (reduceEntry at: 2).
			     self performReduceMethod: (reduceEntry at: 3) with: items].
	self reportError: anInteger
	! !

!SqueakParser methodsFor: 'error handling' stamp: 'ms 10/20/2006 17:33'!
findReduceActionForState: state

	1 to: self errorTokenId do: [:i |
		| action |
		action := self actionForState: state and: i.
		(action bitAnd: self actionMask) = self reduceAction 
			ifTrue: [^action bitShift: -2]].
	^0! !

!SqueakParser methodsFor: 'reduction actions' stamp: 'ajh 3/14/2003 23:53'!
first: nodes

	^ nodes first! !

!SqueakParser methodsFor: 'reduction actions' stamp: 'ajh 3/15/2003 00:01'!
firstIn: nodes

	^ {nodes first}! !

!SqueakParser methodsFor: 'error handling' stamp: 'ms 10/20/2006 18:00'!
handleError: anInteger 

	errorToken isNil ifTrue: [errorToken := currentToken].
	self hasErrorHandler not ifTrue: [self reportError: anInteger].
	self findErrorHandlerIfNoneUseErrorNumber: anInteger! !

!SqueakParser methodsFor: 'private' stamp: 'ms 7/13/2006 09:48'!
ignoreEmptyStatement
	
	currentToken _ nil.
	self getNextToken.
	^ self actionForCurrentToken! !

!SqueakParser methodsFor: 'private' stamp: 'ms 7/13/2006 09:59'!
isEmptyStatementId: id

	^ ((id = scanner periodId) and: [nodeStack isEmpty]) 
		or: [(id = scanner periodId) and: [(nodeStack last isKindOf: SmaCCToken) and: [nodeStack last id first = scanner periodId]]] ! !

!SqueakParser methodsFor: 'private' stamp: 'ms 7/13/2006 09:58'!
isNegativeNumberId: id

	^ scanner negativeNumberId = id! !

!SqueakParser methodsFor: 'reduction actions' stamp: 'ms 9/19/2006 16:25'!
litArray: nodes

	| litToken |
	litToken := (SqueakToken
			value: (String new: (nodes fourth stop - nodes second start + 1))
			start: nodes second start).
	litToken previous: nodes first previous.
	litToken next: nodes last next.
	^ (RBLiteralNode
		literalToken: litToken
		value: nodes third contents) 
			firstToken: nodes first; 
			lastToken: nodes last; 
			yourself! !

!SqueakParser methodsFor: 'reduction actions' stamp: 'ajh 3/15/2003 00:16'!
litChar: nodes

	^ RBLiteralNode
		literalToken: nodes first
		value: (nodes first value at: 2)! !

!SqueakParser methodsFor: 'reduction actions' stamp: 'ajh 3/15/2003 00:14'!
litFalse: nodes

	^ RBLiteralNode
		literalToken: nodes first
		value: false! !

!SqueakParser methodsFor: 'reduction actions' stamp: 'ajh 3/15/2003 00:14'!
litNil: nodes

	^ RBLiteralNode
		literalToken: nodes first
		value: nil! !

!SqueakParser methodsFor: 'reduction actions' stamp: 'md 10/18/2004 17:23'!
litNumber: nodes

	| str num |
	str _ nodes first value readStream.
	num _ Number readFrom: str.
	str atEnd ifFalse: [
		currentToken _ nil.
		scanner position: scanner position - (str originalContents size - str position) + 1.
		self reportErrorMessage: 'Digit out of range'].
	^ RBLiteralNode
		literalToken: nodes first
		value: num! !

!SqueakParser methodsFor: 'reduction actions' stamp: 'ajh 3/15/2003 00:18'!
litString: nodes

	| s |
	s _ nodes first value.
	^ RBLiteralNode
		literalToken: nodes first
		value: ((s copyFrom: 2 to: s size - 1)
				copyReplaceAll: '''''' with: '''')! !

!SqueakParser methodsFor: 'reduction actions' stamp: 'ms 3/31/2007 17:53'!
litStringSymbol: nodes

	| s |
	s := nodes second value.
	^ (RBLiteralNode
		literalToken: nodes second
		value: ((s copyFrom: 2 to: s size - 1)
				copyReplaceAll: '''''' with: '''') asSymbol) firstToken: nodes first; yourself! !

!SqueakParser methodsFor: 'reduction actions' stamp: 'ms 9/18/2006 19:12'!
litSymbol: nodes

	^ (RBLiteralNode
		literalToken: nodes second
		value: nodes second value asSymbol) firstToken: nodes first; yourself! !

!SqueakParser methodsFor: 'reduction actions' stamp: 'ajh 3/15/2003 00:14'!
litTrue: nodes

	^ RBLiteralNode
		literalToken: nodes first
		value: true! !

!SqueakParser methodsFor: 'error handling' stamp: 'ms 11/11/2006 12:29'!
literalMissing: nodes
	
	messageError := 'Literal constant expected'.
	^nodes! !

!SqueakParser methodsFor: 'reduction actions' stamp: 'ajh 3/14/2003 23:52'!
messagePart: nodes

	^ {{nodes first}. {nodes second}}! !

!SqueakParser methodsFor: 'reduction actions' stamp: 'ms 9/17/2006 01:28'!
messagePragma: nodes
	"self haltIf: [(nodes first first isKindOf: Pragma) not]."
	^nodes first
! !

!SqueakParser methodsFor: 'reduction actions' stamp: 'ajh 3/15/2003 00:13'!
messageSend: nodes

	^ RBMessageNode new
		receiver: nodes first
		selectorParts: nodes second first
		arguments: nodes second last! !

!SqueakParser methodsFor: 'reduction actions' stamp: 'ajh 3/14/2003 23:48'!
method: nodes

	^ RBMethodNode new
		selectorParts: nodes first first
		arguments: nodes first last;
		body: nodes second! !

!SqueakParser methodsFor: 'reduction actions' stamp: 'ms 7/15/2006 19:07'!
methodPragma: nodes
	^RBMethodNode new
		selectorParts: nodes first first
		arguments: nodes first last;
		body: nodes third;
		pragmas:nodes second! !

!SqueakParser methodsFor: 'reduction actions' stamp: 'pmm 11/11/2006 14:12'!
methodPragmaTempsPragma: nodes

	| sequence |
	sequence := (RBSequenceNode
		temporaries: nodes third first
		statements: nodes fifth) 
		firstToken: nodes third second; 
		yourself.
	nodes fifth isEmpty ifFalse: [
		sequence lastToken: nodes third third ].
	^ RBMethodNode new 
		selectorParts: nodes first first
		arguments: nodes first last;
		body: sequence;
		pragmas: (nodes second addAll: nodes fourth; yourself)! !

!SqueakParser methodsFor: 'reduction actions' stamp: 'pmm 11/11/2006 14:15'!
methodTempsPragma: nodes

	| sequence |
	sequence := (RBSequenceNode
		temporaries: nodes second first
		statements: nodes fourth)
		firstToken: nodes second second; 
		yourself.
	nodes fourth isEmpty ifFalse: [
			sequence lastToken: nodes second third ].
	^ RBMethodNode new
		selectorParts: nodes first first
		arguments: nodes first last;
		body: sequence;
		pragmas: nodes third! !

!SqueakParser methodsFor: 'error handling' stamp: 'ms 11/11/2006 12:12'!
moduleArgMissing: nodes
	
	messageError := 'Module name expected'.
	^nodes! !

!SqueakParser methodsFor: 'private' stamp: 'ms 9/17/2006 15:27'!
negativeNumberToBinaryString
	
	currentToken := (SqueakToken 
		value: '-'
		start: currentToken startPosition
		id: (Array with: scanner binarySymbolId)) substitueTo: currentToken; yourself.
	scanner position: currentToken stopPosition.
	^ self actionForCurrentToken! !

!SqueakParser methodsFor: 'private' stamp: 'ajh 3/6/2003 00:02'!
nodeStack

	^ nodeStack! !

!SqueakParser methodsFor: 'reduction actions' stamp: 'ms 9/17/2006 01:31'!
parameterExtCall: nodes

	| args |
	args := WriteStream on: Array new.
	args nextPut: nodes first first.
	^OrderedCollection with: args with: nodes first second! !

!SqueakParser methodsFor: 'reduction actions' stamp: 'ms 9/17/2006 01:34'!
parametersExtCall: nodes

	| aCol |
	aCol := nodes first.
	aCol  first nextPut: (nodes second first).
	aCol at: 2 put: nodes second second.
	^aCol! !

!SqueakParser methodsFor: 'reduction actions' stamp: 'ms 9/18/2006 17:13'!
pragma: nodes
	"self haltIf: [nodes second first isKindOf: Pragma]."
	"| pragmaNode |
	pragmaNode := RBPragmasNode withPragma: nodes second first spec: nodes second second.
	nodes second third ifNotNil: [pragmaNode primitiveNumber: nodes second third].
	^pragmaNode"
	
	| rbPragma |
	rbPragma := RBPragmaNode pragma: nodes second first 
								spec: nodes second second 
								start: nodes first start 
								stop: nodes third stop 
								firstToken: nodes first
								lastToken: nodes last.
	nodes second third ifNotNil: [rbPragma primitiveNumber: nodes second third].
	^OrderedCollection with: rbPragma! !

!SqueakParser methodsFor: 'error handling' stamp: 'ms 11/1/2006 01:34'!
pragmaEndMissing: nodes
	
	messageError := '> expected'.
	^nodes! !

!SqueakParser methodsFor: 'reduction actions' stamp: 'ms 11/11/2006 17:42'!
pragmaMessage: nodes

	| arguments keyword |
	keyword := String new.
	arguments := (nodes first second collect: [:each | each value]).
	nodes first first do: [:each | keyword := keyword, each value].
	^OrderedCollection with:(Pragma keyword: keyword asSymbol arguments: arguments)
					  with: nil
					  with: nil
					  with: nodes first first first
					  with: nodes first second last token
	
	
	! !

!SqueakParser methodsFor: 'error handling' stamp: 'ms 11/10/2006 22:32'!
pragmaMissing: nodes

	messageError := 'Pragma declaration expected'.
	^ nodes! !

!SqueakParser methodsFor: 'reduction actions' stamp: 'ms 9/17/2006 01:47'!
pragmaUnaryMessage: nodes

	^OrderedCollection with:(Pragma keyword: nodes first first first value asSymbol arguments: nodes first second)
					  with: nil
					  with: nil
					  with: nodes first first first
					  with: nodes first first first
	
	
	! !

!SqueakParser methodsFor: 'reduction actions' stamp: 'ms 9/18/2006 17:24'!
pragmas: nodes
	"nodes first addPragma: nodes third first withSpec: nodes third second.
	nodes third third ifNotNil: [nodes first primitiveNumber: nodes third third].
	^nodes first"
	
	| rbPragma |
	rbPragma := RBPragmaNode pragma: nodes third first 
								spec: nodes third second 
								start: nodes second start 
								stop: nodes fourth stop 
								firstToken: nodes second 
								lastToken: nodes last.
	nodes third third ifNotNil: [rbPragma primitiveNumber: nodes third third].
	nodes first add: rbPragma.
	^nodes first
	! !

!SqueakParser methodsFor: 'error handling' stamp: 'ms 11/11/2006 12:10'!
primitiveArgMissing: nodes
	
	messageError := 'String or number primitive expected'.
	^nodes! !

!SqueakParser methodsFor: 'reduction actions' stamp: 'ms 9/17/2006 00:54'!
primitiveModule: nodes
	^OrderedCollection with: (Pragma keyword: #primitive:module: 
									 arguments: (Array with: nodes second value withoutQuoting asSymbol
														with: nodes fourth value withoutQuoting asSymbol)) 
					  with: (Array with: nodes fourth value withoutQuoting asSymbol 
								    with: nodes second value withoutQuoting asSymbol 
								    with: 0 with: 0)
					  with: 117
					  with: nodes first
					  with: nodes last

	! !

!SqueakParser methodsFor: 'reduction actions' stamp: 'ms 9/17/2006 00:54'!
primitiveNumber: nodes

	^OrderedCollection with: (Pragma keyword: #primitive: arguments: (Array with: nodes second value asInteger)) 
					  with: nil
					  with: nodes second value asInteger
					  with: nodes first
					  with: nodes second
	! !

!SqueakParser methodsFor: 'reduction actions' stamp: 'ms 9/17/2006 00:53'!
primitiveString: nodes

	^OrderedCollection with: (Pragma keyword: #primitive: 
									 arguments: (Array with: nodes second value withoutQuoting asSymbol)) 
					   with: (Array with: nil 
									with: nodes second value withoutQuoting asSymbol 
									with: 0 with: 0)
					   with: 117
					   with: nodes first
					   with: nodes second! !

!SqueakParser methodsFor: 'generated-reduction actions' stamp: 'ms 4/7/2007 03:32'!
reduceActionForOptionalXXXperiodX1: nodes 
	^ nil! !

!SqueakParser methodsFor: 'generated-reduction actions' stamp: 'ms 4/7/2007 03:32'!
reduceActionForOptionalXXXperiodX2: nodes 
	^ nodes at: 1! !

!SqueakParser methodsFor: 'generated-tables' stamp: 'ms 4/7/2007 03:32'!
reduceTable
	^#(
#(39 1 #reduceFor:)
#(40 1 #variable:)
#(41 2 #messagePart:)
#(41 2 #argumentNameMissing:)
#(41 3 #addMessagePart:)
#(41 3 #argumentNameMissing:)
#(42 2 #method:)
#(42 3 #methodPragma:)
#(42 5 #methodPragmaTempsPragma:)
#(42 4 #methodTempsPragma:)
#(43 0 #array)
#(43 2 #add:)
#(44 1 #firstIn:)
#(44 3 #add3:)
#(45 0 #reduceActionForOptionalXXXperiodX1:)
#(45 1 #reduceActionForOptionalXXXperiodX2:)
#(46 1 #first:)
#(46 1 #first:)
#(46 1 #first:)
#(47 2 #secondIn:)
#(47 2 #argumentNameMissing:)
#(47 3 #add3:)
#(47 3 #argumentNameMissing:)
#(48 5 #blockWithArgs:)
#(48 3 #blockNoArgs:)
#(48 3 #blockArgs:)
#(48 7 #blockWithTemps:)
#(49 3 #assignment:)
#(49 3 #expressionMissing:)
#(50 1 #first:)
#(50 3 #cascade:)
#(50 3 #cascadeMMissing:)
#(51 0 #array)
#(51 2 #first:)
#(51 5 #returnAdd:)
#(51 3 #return:)
#(52 3 #array:)
#(53 1 #litTrue:)
#(53 1 #litFalse:)
#(53 1 #litNil:)
#(53 1 #litNumber:)
#(53 1 #litNumber:)
#(53 1 #litChar:)
#(53 1 #litString:)
#(53 2 #litStringSymbol:)
#(53 2 #litSymbol:)
#(53 2 #litSymbol:)
#(53 2 #litSymbol:)
#(53 2 #litSymbol:)
#(53 2 #litSymbol:)
#(53 4 #litArray:)
#(53 4 #litArray:)
#(53 1 #litString:)
#(54 1 #first:)
#(54 1 #first:)
#(54 1 #first:)
#(55 1 #arrayAddToken:)
#(55 3 #secondAddToken:)
#(55 3 #verticalBarMissing:)
#(56 1 #sequence:)
#(56 2 #sequenceWithTemps:)
#(57 2 #messageSend:)
#(57 2 #messageSend:)
#(57 2 #messageSend:)
#(58 2 #messageSend:)
#(58 2 #messageSend:)
#(58 2 #messageSend:)
#(59 2 #messageSend:)
#(59 2 #messageSend:)
#(60 1 #unaryMessage:)
#(61 2 #messagePart:)
#(61 2 #argumentMissing:)
#(62 2 #messagePart:)
#(62 2 #argumentMissing:)
#(62 3 #addMessagePart:)
#(62 3 #argumentMissing:)
#(63 1 #first:)
#(63 1 #first:)
#(63 1 #first:)
#(64 1 #first:)
#(64 1 #first:)
#(65 3 #pragma:)
#(65 3 #pragmaEndMissing:)
#(65 2 #pragmaMissing:)
#(65 4 #pragmas:)
#(65 4 #pragmaEndMissing:)
#(65 3 #pragmaMissing:)
#(66 0 #byteStream)
#(66 2 #byteStreamPut:)
#(67 0 #stream)
#(67 2 #streamPut:)
#(68 1 #value:)
#(68 1 #valueSymbol:)
#(68 1 #valueSymbol:)
#(68 1 #valueSymbol:)
#(68 1 #valueSymbol:)
#(68 1 #valueSymbol:)
#(68 3 #contents2:)
#(68 3 #contents2:)
#(68 1 #valueSymbol:)
#(69 3 #secondWithParenthesis:)
#(69 1 #first:)
#(69 1 #first:)
#(69 1 #first:)
#(69 1 #first:)
#(70 6 #externalCall:)
#(70 8 #externalModuleCall:)
#(71 2 #primitiveString:)
#(71 2 #primitiveNumber:)
#(71 2 #primitiveArgMissing:)
#(71 4 #primitiveModule:)
#(71 4 #moduleArgMissing:)
#(72 1 #pragmaMessage:)
#(72 1 #pragmaMessage:)
#(72 1 #pragmaUnaryMessage:)
#(73 2 #messagePart:)
#(73 2 #literalMissing:)
#(73 3 #addMessagePart:)
#(73 3 #literalMissing:)
#(74 2 #messagePart:)
#(74 2 #argumentMissing:)
#(75 1 #first:)
#(75 1 #first:)
#(75 1 #first:)
#(75 1 #first:)
#(76 1 #callConvention:)
#(76 1 #callConvention:)
#(77 1 #externalType:)
#(77 2 #externalTypePointer:)
#(78 1 #externalFunction:)
#(78 1 #externalIndex:)
#(79 1 #parameterExtCall:)
#(79 2 #parametersExtCall:)
#(82 1 #unaryMessage:)
#(82 2 #messagePart:)
#(82 2 #argumentNameMissing:)
#(82 1 #first:)
#(83 1 #first:)
#(83 1 #first:)
#(83 1 #first:)
#(84 1 #messagePragma:)
#(84 1 #messagePragma:)
#(84 1 #messagePragma:)
)! !

!SqueakParser methodsFor: 'error handling' stamp: 'ms 10/19/2006 22:15'!
reportError: anInteger 

	messageError ifNil:[
		| acceptedToken |
		messageError := ''.
		acceptedToken := self collectAcceptableToken asArray.
		acceptedToken 
			do: [:each | acceptedToken last == each 
							ifFalse:[messageError := messageError,  
										(self class tokenDescription: each)]
							ifTrue:[messageError := messageError, 
										(self class tokenDescription: each), ' expected']]
			separatedByNext:[:each | acceptedToken last == each 
							ifFalse:[messageError := messageError, ', ']
							ifTrue:[messageError := messageError, ' or ']].
	messageError := messageError capitalized].
	self reportErrorMessage: (anInteger = 0 
				ifTrue: [messageError]
				ifFalse: [self errorTable at: anInteger])
	
	! !

!SqueakParser methodsFor: 'reduction actions' stamp: 'ms 9/18/2006 18:50'!
return: nodes

	^ {(RBReturnNode
		return: nodes first start
		value: nodes second) firstToken: nodes first; yourself}! !

!SqueakParser methodsFor: 'reduction actions' stamp: 'ajh 3/19/2003 13:49'!
returnAdd: nodes

	^ nodes first copyWith: (RBReturnNode
		return: nodes third start
		value: nodes fourth)! !

!SqueakParser methodsFor: 'private' stamp: 'ajh 3/6/2003 00:19'!
scanner

	^ scanner! !

!SqueakParser methodsFor: 'reduction actions' stamp: 'ajh 3/14/2003 23:58'!
second: nodes

	^ nodes second! !

!SqueakParser methodsFor: 'reduction actions' stamp: 'ms 3/31/2007 20:31'!
secondAddToken: nodes
	
	^OrderedCollection with: nodes second with: nodes first with: nodes last! !

!SqueakParser methodsFor: 'reduction actions' stamp: 'ajh 3/15/2003 00:06'!
secondIn: nodes

	^ {nodes second}! !

!SqueakParser methodsFor: 'reduction actions' stamp: 'ms 9/18/2006 17:47'!
secondPutToken: nodes

	nodes second firstToken: nodes first.
	nodes second lastToken: nodes last.
	^nodes second! !

!SqueakParser methodsFor: 'reduction actions' stamp: 'ms 3/31/2007 17:51'!
secondWithParenthesis: nodes

	nodes second addParenthesis: (nodes first start to: nodes last stop).
	nodes second firstToken: nodes first.
	nodes second lastToken: nodes last.
	^nodes second! !

!SqueakParser methodsFor: 'reduction actions' stamp: 'ajh 3/14/2003 23:57'!
sequence: nodes

	^ RBSequenceNode
		statements: nodes first! !

!SqueakParser methodsFor: 'reduction actions' stamp: 'ms 9/25/2006 12:55'!
sequenceWithTemps: nodes

	nodes second ifNotEmpty: [^ (RBSequenceNode
					temporaries: nodes first first
					statements: nodes second) firstToken: nodes first second; yourself]
				ifEmpty:[^ (RBSequenceNode
					temporaries: nodes first first
					statements: nodes second) 
						firstToken: nodes first second;
						lastToken:nodes first third]! !

!SqueakParser methodsFor: 'error handling' stamp: 'ms 11/10/2006 22:31'!
stateErrorShiftInto

	stateStack size to: 1
		by: -1
		do: 
			[:i | 
			| action |
			action := self actionForState: (stateStack at: i) and: self errorTokenId.
			(action bitAnd: self actionMask) = self reduceAction 
				ifTrue:[self reduce:(action bitShift: -2).
						^self stateErrorShiftInto].
			(action bitAnd: self actionMask) = self shiftAction 
				ifTrue: [^ action bitShift: -2].
			stateStack removeLast].
	^ 0! !

!SqueakParser methodsFor: 'reduction actions' stamp: 'ajh 3/15/2003 00:23'!
stream

	^ Array new writeStream! !

!SqueakParser methodsFor: 'reduction actions' stamp: 'ajh 3/15/2003 00:26'!
streamPut: nodes

	^ nodes first
		nextPut: nodes second;
		yourself! !

!SqueakParser methodsFor: 'generated-tables' stamp: 'ms 4/7/2007 03:32'!
transitionTable
	^#(
#(3 17 22 21 23 25 25 29 41 33 42 37 82)
#(3 41 1 45 2 49 4 53 5 57 8 61 9 65 10 69 15 73 16 77 17 81 18 85 19 89 20 93 21 97 22 101 30 105 40 109 44 113 46 117 48 121 49 125 50 129 51 133 52 137 53 141 54 145 55 149 56 153 57 157 58 161 59 165 69 134 80)
#(3 17 22 21 23 25 25 29 41 169 82)
#(2 538 1 2 4 5 6 8 9 10 15 16 17 18 19 20 21 22 30 80)
#(3 97 22 173 40 177 81)
#(3 97 22 181 40 185 81)
#(3 550 1 550 2 550 4 550 5 550 6 550 8 550 9 550 10 550 15 550 16 550 17 550 18 550 19 550 20 550 21 550 22 189 23 550 30 550 80)
#(2 0 80)
#(3 41 1 45 2 49 4 53 5 193 6 57 8 61 9 65 10 69 15 73 16 77 17 81 18 85 19 89 20 93 21 97 22 101 30 105 40 109 44 113 46 117 48 121 49 125 50 129 51 133 52 137 53 141 54 197 55 201 56 153 57 157 58 161 59 205 65 165 69 134 80)
#(3 41 1 45 2 49 4 53 5 57 8 61 9 65 10 69 15 73 16 77 17 81 18 85 19 89 20 93 21 97 22 101 30 134 33 209 36 105 40 109 44 113 46 213 47 117 48 121 49 125 50 129 51 133 52 137 53 141 54 145 55 217 56 153 57 157 58 161 59 165 69)
#(3 41 1 45 2 53 5 65 10 69 15 73 16 77 17 81 18 85 19 89 20 93 21 97 22 101 30 105 40 221 46 117 48 121 49 125 50 133 52 137 53 141 54 153 57 157 58 161 59 165 69)
#(3 41 1 45 2 53 5 65 10 69 15 73 16 77 17 81 18 85 19 89 20 93 21 97 22 101 30 105 40 225 46 117 48 121 49 125 50 133 52 137 53 141 54 153 57 157 58 161 59 165 69)
#(3 41 1 45 2 49 4 53 5 65 10 69 15 73 16 77 17 81 18 85 19 89 20 93 21 97 22 101 30 134 34 105 40 109 44 113 46 117 48 121 49 125 50 229 51 133 52 137 53 141 54 153 57 157 58 161 59 165 69)
#(2 230 1 2 4 5 6 10 15 16 17 18 19 20 21 22 30 33 80)
#(3 46 9 46 22 233 43 46 81)
#(2 154 1 2 7 10 15 16 17 18 19 20 21 22 23 24 25 27 30 31 33 34 35 37 38 80 81)
#(2 158 1 2 7 10 15 16 17 18 19 20 21 22 23 24 25 27 30 31 33 34 35 37 38 80 81)
#(2 162 1 2 7 10 15 16 17 18 19 20 21 22 23 24 25 27 30 31 33 34 35 37 38 80 81)
#(3 237 1 241 2 245 21 249 22 253 23 257 24 261 25 265 27)
#(2 214 1 2 7 10 15 16 17 18 19 20 21 22 23 24 25 27 30 31 33 34 35 37 38 80 81)
#(2 166 1 2 7 10 15 16 17 18 19 20 21 22 23 24 25 27 30 31 33 34 35 37 38 80 81)
#(2 170 1 2 7 10 15 16 17 18 19 20 21 22 23 24 25 27 30 31 33 34 35 37 38 80 81)
#(2 178 1 2 7 10 15 16 17 18 19 20 21 22 23 24 25 27 30 31 33 34 35 37 38 80 81)
#(2 10 1 2 4 5 6 7 8 9 10 15 16 17 18 19 20 21 22 23 25 26 30 31 33 34 35 36 37 80 81)
#(2 174 1 2 7 10 15 16 17 18 19 20 21 22 23 24 25 27 30 31 33 34 35 37 38 80 81)
#(3 422 22 422 23 422 25 269 26 422 31 422 33 422 34 422 35 422 80)
#(3 273 31 62 33 62 34 277 45 62 80)
#(2 54 31 33 34 80)
#(2 414 22 23 25 31 33 34 35 37 80)
#(2 70 31 33 34 35 80)
#(3 74 31 74 33 74 34 74 35 281 37 74 80)
#(2 242 33 80)
#(2 410 22 23 25 31 33 34 35 37 80)
#(2 418 22 23 25 31 33 34 35 37 80)
#(2 122 31 33 34 35 37 80)
#(3 41 1 45 2 49 4 53 5 65 10 69 15 73 16 77 17 81 18 85 19 89 20 93 21 97 22 101 30 134 33 105 40 109 44 113 46 117 48 121 49 125 50 285 51 133 52 137 53 141 54 153 57 157 58 161 59 165 69 134 80)
#(2 0 80)
#(2 218 31 33 34 35 37 80)
#(3 289 23 293 25 222 31 222 33 222 34 222 35 222 37 297 61 301 62 222 80)
#(3 305 22 289 23 293 25 226 31 226 33 226 34 226 35 226 37 309 60 313 61 317 62 226 80)
#(3 305 22 289 23 293 25 78 31 78 33 78 34 78 35 321 60 325 61 329 62 78 80)
#(2 0 80)
#(2 14 1 2 4 5 6 8 9 10 15 16 17 18 19 20 21 22 23 30 80)
#(2 18 1 2 4 5 6 8 9 10 15 16 17 18 19 20 21 22 23 30 80)
#(2 542 1 2 4 5 6 8 9 10 15 16 17 18 19 20 21 22 30 80)
#(2 546 1 2 4 5 6 8 9 10 15 16 17 18 19 20 21 22 30 80)
#(3 97 22 333 40 337 81)
#(3 341 3 345 11 349 14 305 22 353 23 357 25 361 60 365 62 369 70 373 71 377 72 381 73 385 74 389 76 393 81 397 84)
#(3 41 1 45 2 49 4 53 5 193 6 65 10 69 15 73 16 77 17 81 18 85 19 89 20 93 21 97 22 101 30 105 40 109 44 113 46 117 48 121 49 125 50 285 51 133 52 137 53 141 54 153 57 157 58 161 59 401 65 165 69 134 80)
#(2 30 80)
#(3 41 1 45 2 49 4 53 5 405 6 57 8 61 9 65 10 69 15 73 16 77 17 81 18 85 19 89 20 93 21 97 22 101 30 105 40 109 44 113 46 117 48 121 49 125 50 129 51 133 52 137 53 141 54 409 55 413 56 153 57 157 58 161 59 165 69 134 80)
#(3 97 22 417 40 421 81)
#(3 425 8 429 9 433 33 437 36)
#(2 441 33)
#(2 445 35)
#(3 449 31 62 33 62 34 453 45 62 80)
#(2 457 34)
#(3 461 9 97 22 465 40 469 81)
#(3 354 19 354 33 473 66)
#(3 362 1 362 2 362 10 362 15 362 16 362 17 362 18 362 19 362 20 362 21 362 22 362 23 362 24 362 25 362 27 362 30 362 35 362 38 477 67)
#(2 182 1 2 7 10 15 16 17 18 19 20 21 22 23 24 25 27 30 31 33 34 35 37 38 80 81)
#(2 186 1 2 7 10 15 16 17 18 19 20 21 22 23 24 25 27 30 31 33 34 35 37 38 80 81)
#(2 194 1 2 7 10 15 16 17 18 19 20 21 22 23 24 25 27 30 31 33 34 35 37 38 80 81)
#(2 198 1 2 7 10 15 16 17 18 19 20 21 22 23 24 25 27 30 31 33 34 35 37 38 80 81)
#(2 190 1 2 7 10 15 16 17 18 19 20 21 22 23 24 25 27 30 31 33 34 35 37 38 80 81)
#(2 202 1 2 7 10 15 16 17 18 19 20 21 22 23 24 25 27 30 31 33 34 35 37 38 80 81)
#(3 41 1 45 2 53 5 65 10 69 15 73 16 77 17 81 18 85 19 89 20 93 21 97 22 101 30 105 40 481 46 117 48 121 49 125 50 133 52 137 53 141 54 153 57 157 58 161 59 165 69 485 81)
#(3 41 1 45 2 489 4 53 5 65 10 69 15 73 16 77 17 81 18 85 19 89 20 93 21 97 22 101 30 66 33 66 34 105 40 493 46 117 48 121 49 125 50 133 52 137 53 141 54 153 57 157 58 161 59 165 69 66 80)
#(2 138 33 34 80)
#(3 305 22 289 23 293 25 497 60 501 61 505 62 509 81 513 83)
#(2 246 33 80)
#(3 41 1 45 2 53 5 65 10 69 15 73 16 77 17 81 18 85 19 89 20 93 21 97 22 101 30 517 40 117 48 133 52 137 53 521 58 525 59 529 63 533 69 537 81)
#(3 41 1 45 2 53 5 65 10 69 15 73 16 77 17 81 18 85 19 89 20 93 21 97 22 101 30 517 40 117 48 133 52 137 53 541 59 545 64 549 69 553 81)
#(2 262 23 25 31 33 34 35 37 80)
#(3 557 23 250 31 250 33 250 34 250 35 250 37 250 80)
#(2 282 7 22 23 25 31 33 34 35 37 80 81)
#(2 274 22 23 25 31 33 34 35 37 80)
#(2 266 23 25 31 33 34 35 37 80)
#(3 557 23 254 31 254 33 254 34 254 35 254 37 254 80)
#(2 278 22 23 25 31 33 34 35 37 80)
#(2 270 23 25 31 33 34 35 37 80)
#(3 557 23 258 31 258 33 258 34 258 35 258 37 258 80)
#(2 22 1 2 4 5 6 8 9 10 15 16 17 18 19 20 21 22 23 30 80)
#(2 26 1 2 4 5 6 8 9 10 15 16 17 18 19 20 21 22 23 30 80)
#(3 561 19 565 21 569 81)
#(2 510 22)
#(2 506 22)
#(3 41 1 45 2 53 5 65 10 69 15 73 16 77 17 81 18 85 19 89 20 93 21 97 22 101 30 573 40 577 48 581 52 585 53 521 58 525 59 529 63 533 69 589 75 593 81)
#(3 41 1 53 5 65 10 69 15 73 16 77 17 81 18 85 19 89 20 93 21 97 22 101 30 597 40 601 48 605 52 609 53 613 75 617 81)
#(2 462 7 81)
#(2 621 23)
#(2 566 7 81)
#(2 570 7 81)
#(2 574 7 81)
#(2 454 7 81)
#(2 458 7 81)
#(3 625 22 629 77)
#(2 338 1 2 4 5 6 8 9 10 15 16 17 18 19 20 21 22 30 80)
#(3 633 7 637 81)
#(3 41 1 45 2 49 4 53 5 405 6 65 10 69 15 73 16 77 17 81 18 85 19 89 20 93 21 97 22 101 30 105 40 109 44 113 46 117 48 121 49 125 50 641 51 133 52 137 53 141 54 153 57 157 58 161 59 165 69 134 80)
#(3 341 3 345 11 349 14 305 22 353 23 357 25 361 60 365 62 369 70 373 71 377 72 381 73 385 74 389 76 645 81 649 84)
#(3 41 1 45 2 49 4 53 5 193 6 65 10 69 15 73 16 77 17 81 18 85 19 89 20 93 21 97 22 101 30 105 40 109 44 113 46 117 48 121 49 125 50 285 51 133 52 137 53 141 54 153 57 157 58 161 59 653 65 165 69 134 80)
#(2 34 80)
#(2 82 8 9 33 36)
#(2 86 8 9 33 36)
#(3 46 9 46 22 657 43)
#(3 41 1 45 2 49 4 53 5 57 8 61 9 65 10 69 15 73 16 77 17 81 18 85 19 89 20 93 21 97 22 101 30 134 33 105 40 109 44 113 46 117 48 121 49 125 50 129 51 133 52 137 53 141 54 145 55 661 56 153 57 157 58 161 59 165 69)
#(2 106 7 22 23 25 31 33 34 35 37 80 81)
#(3 97 22 665 40 669 81)
#(2 102 7 22 23 25 31 33 34 35 37 80 81)
#(2 406 22 23 25 31 33 34 35 37 80)
#(2 66 33 34 80)
#(2 146 33 34 80)
#(2 150 7 22 23 25 31 33 34 35 37 80 81)
#(2 234 1 2 4 5 6 10 15 16 17 18 19 20 21 22 30 33 80)
#(2 50 9 22 81)
#(2 238 1 2 4 5 6 10 15 16 17 18 19 20 21 22 30 33 80)
#(3 673 19 677 33)
#(3 681 1 685 2 65 10 69 15 73 16 77 17 81 18 85 19 89 20 93 21 689 22 693 23 697 24 701 25 705 27 101 30 709 35 713 38 717 53 721 68)
#(2 114 31 33 34 35 80)
#(2 118 31 33 34 35 80)
#(3 41 1 45 2 53 5 65 10 69 15 73 16 77 17 81 18 85 19 89 20 93 21 97 22 101 30 105 40 725 46 117 48 121 49 125 50 133 52 137 53 141 54 153 57 157 58 161 59 165 69)
#(2 58 31 33 34 80)
#(2 554 31 33 34 35 37 80)
#(2 558 31 33 34 35 37 80)
#(3 557 23 562 31 562 33 562 34 562 35 562 37 562 80)
#(2 130 31 33 34 35 37 80)
#(2 126 31 33 34 35 37 80)
#(2 422 22 23 25 31 33 34 35 37 80)
#(3 310 23 293 25 310 31 310 33 310 34 310 35 310 37 297 61 310 80)
#(3 305 22 314 23 293 25 314 31 314 33 314 34 314 35 314 37 309 60 313 61 314 80)
#(2 294 23 31 33 34 35 37 80)
#(3 305 22 318 23 293 25 318 31 318 33 318 34 318 35 318 37 321 60 325 61 318 80)
#(2 298 23 31 33 34 35 37 80)
#(3 305 22 322 23 322 25 322 31 322 33 322 34 322 35 322 37 309 60 322 80)
#(2 286 23 25 31 33 34 35 37 80)
#(3 305 22 326 23 326 25 326 31 326 33 326 34 326 35 326 37 321 60 326 80)
#(2 290 23 25 31 33 34 35 37 80)
#(3 41 1 45 2 53 5 65 10 69 15 73 16 77 17 81 18 85 19 89 20 93 21 97 22 101 30 517 40 117 48 133 52 137 53 521 58 525 59 729 63 533 69 733 81)
#(2 438 7 81)
#(3 434 7 737 13 434 81)
#(2 442 7 81)
#(3 502 7 422 22 422 23 422 25 502 81)
#(3 494 7 414 22 414 23 414 25 494 81)
#(3 490 7 410 22 410 23 410 25 490 81)
#(3 498 7 418 22 418 23 418 25 498 81)
#(2 466 7 81)
#(3 470 7 298 23 470 81)
#(2 502 7 81)
#(2 494 7 81)
#(2 490 7 81)
#(2 498 7 81)
#(2 482 7 81)
#(2 486 7 81)
#(3 41 1 45 2 53 5 65 10 69 15 73 16 77 17 81 18 85 19 89 20 93 21 97 22 101 30 573 40 577 48 581 52 585 53 521 58 525 59 729 63 533 69 741 75 745 81)
#(3 749 12 514 19 514 21 514 22 514 35)
#(3 753 19 757 21 761 78)
#(2 330 1 2 4 5 6 8 9 10 15 16 17 18 19 20 21 22 30 80)
#(2 334 1 2 4 5 6 8 9 10 15 16 17 18 19 20 21 22 30 80)
#(2 42 80)
#(2 350 1 2 4 5 6 8 9 10 15 16 17 18 19 20 21 22 30 80)
#(3 765 7 769 81)
#(3 41 1 45 2 49 4 53 5 405 6 65 10 69 15 73 16 77 17 81 18 85 19 89 20 93 21 97 22 101 30 105 40 109 44 113 46 117 48 121 49 125 50 773 51 133 52 137 53 141 54 153 57 157 58 161 59 165 69 134 80)
#(3 777 9 97 22 465 40)
#(2 781 33)
#(2 90 8 9 33 36)
#(2 94 8 9 33 36)
#(2 358 19 33)
#(2 206 1 2 7 10 15 16 17 18 19 20 21 22 23 24 25 27 30 31 33 34 35 37 38 80 81)
#(3 354 19 354 33 785 66)
#(3 362 1 362 2 362 10 362 15 362 16 362 17 362 18 362 19 362 20 362 21 362 22 362 23 362 24 362 25 362 27 362 30 362 35 362 38 789 67)
#(2 374 1 2 10 15 16 17 18 19 20 21 22 23 24 25 27 30 35 38)
#(2 382 1 2 10 15 16 17 18 19 20 21 22 23 24 25 27 30 35 38)
#(2 386 1 2 10 15 16 17 18 19 20 21 22 23 24 25 27 30 35 38)
#(2 378 1 2 10 15 16 17 18 19 20 21 22 23 24 25 27 30 35 38)
#(2 390 1 2 10 15 16 17 18 19 20 21 22 23 24 25 27 30 35 38)
#(2 210 1 2 7 10 15 16 17 18 19 20 21 22 23 24 25 27 30 31 33 34 35 37 38 80 81)
#(2 402 1 2 10 15 16 17 18 19 20 21 22 23 24 25 27 30 35 38)
#(2 370 1 2 10 15 16 17 18 19 20 21 22 23 24 25 27 30 35 38)
#(2 366 1 2 10 15 16 17 18 19 20 21 22 23 24 25 27 30 35 38)
#(3 449 31 62 33 62 34 793 45 62 80)
#(2 302 23 31 33 34 35 37 80)
#(2 306 23 31 33 34 35 37 80)
#(3 797 21 801 81)
#(2 474 7 81)
#(3 478 7 306 23 478 81)
#(2 518 19 21 22 35)
#(2 526 2)
#(2 522 2)
#(2 805 2)
#(2 342 1 2 4 5 6 8 9 10 15 16 17 18 19 20 21 22 30 80)
#(2 346 1 2 4 5 6 8 9 10 15 16 17 18 19 20 21 22 30 80)
#(2 38 80)
#(3 41 1 45 2 49 4 53 5 65 10 69 15 73 16 77 17 81 18 85 19 89 20 93 21 97 22 101 30 134 33 105 40 109 44 113 46 117 48 121 49 125 50 809 51 133 52 137 53 141 54 153 57 157 58 161 59 165 69)
#(2 98 7 22 23 25 31 33 34 35 37 80 81)
#(3 673 19 813 33)
#(3 681 1 685 2 65 10 69 15 73 16 77 17 81 18 85 19 89 20 93 21 689 22 693 23 697 24 701 25 705 27 101 30 817 35 713 38 717 53 721 68)
#(2 142 33 34 80)
#(2 446 7 81)
#(2 450 7 81)
#(3 625 22 821 77 825 79)
#(2 829 33)
#(2 398 1 2 10 15 16 17 18 19 20 21 22 23 24 25 27 30 35 38)
#(2 394 1 2 10 15 16 17 18 19 20 21 22 23 24 25 27 30 35 38)
#(2 530 22 35)
#(3 625 22 833 35 837 77)
#(2 110 7 22 23 25 31 33 34 35 37 80 81)
#(3 426 7 841 13 426 81)
#(2 534 22 35)
#(2 845 21)
#(2 430 7 81)
)! !

!SqueakParser methodsFor: 'reduction actions' stamp: 'ajh 3/14/2003 23:52'!
unaryMessage: nodes

	^ {{nodes first}. #()}! !

!SqueakParser methodsFor: 'reduction actions' stamp: 'ajh 3/15/2003 00:27'!
value: nodes

	^ nodes first value! !

!SqueakParser methodsFor: 'reduction actions' stamp: 'ajh 3/15/2003 00:27'!
valueSymbol: nodes

	^ nodes first value asSymbol! !

!SqueakParser methodsFor: 'reduction actions' stamp: 'ajh 3/15/2003 00:13'!
variable: nodes

	^ RBVariableNode new
		identifierToken: nodes first! !

!SqueakParser methodsFor: 'error handling' stamp: 'ms 10/20/2006 17:44'!
verticalBarMissing: nodes
	
	messageError := 'Vertical bar expected'.
	^nodes! !

SmaCCToken subclass: #SqueakToken
	instanceVariableNames: 'next previous eat'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Coral'!

!SqueakToken class methodsFor: 'instance creation' stamp: 'ms 9/17/2006 14:43'!
value: aString start: anInteger

	^(self new)
		value: aString;
			start: anInteger;	
		yourself! !

!SqueakToken class methodsFor: 'instance creation' stamp: 'ms 9/17/2006 15:25'!
value: aString start: anInteger id: anObject
	^(self new)
		value: aString
			start: anInteger
			id: anObject;
		yourself! !

!SqueakToken class methodsFor: 'instance creation' stamp: 'ms 9/16/2006 17:26'!
value: aString start: anInteger id: anObject prevToken: aToken

	^(self new)
		value: aString
			start: anInteger
			id: anObject;
		previous: aToken;	
		yourself! !

!SqueakToken class methodsFor: 'instance creation' stamp: 'ms 9/17/2006 14:33'!
value: aString start: anInteger prevToken: aToken

	^(self new)
		value: aString;
			start: anInteger;
		previous: aToken;	
		yourself! !

!SqueakToken methodsFor: 'accessing' stamp: 'ms 9/19/2006 13:19'!
eatToken
	
	eat := true.
	^self! !

!SqueakToken methodsFor: 'accessing' stamp: 'ms 9/17/2006 19:57'!
eatValue
	
	eat := true.
	^self value! !

!SqueakToken methodsFor: 'initialize' stamp: 'ms 9/17/2006 19:56'!
initialize
	
	eat := false! !

!SqueakToken methodsFor: 'add' stamp: 'ms 9/17/2006 14:47'!
insertAfterMe: aToken
	
	self next previous: aToken.
	aToken previous: self! !

!SqueakToken methodsFor: 'add' stamp: 'ms 9/17/2006 14:41'!
insertBeforMe: aToken
	
	aToken previous: self previous.
	self previous: aToken! !

!SqueakToken methodsFor: 'testing' stamp: 'ms 5/2/2007 11:48'!
isComment

	^id == #comment! !

!SqueakToken methodsFor: 'testing' stamp: 'ms 9/17/2006 19:59'!
isEaten
	
	^eat! !

!SqueakToken methodsFor: 'testing' stamp: 'ms 9/19/2006 15:32'!
isInsignificant
	
	^false! !

!SqueakToken methodsFor: 'testing' stamp: 'ms 5/2/2007 11:51'!
isNewLine
	
	^self isWhitespace and:[(self value indexOf: Character cr) > 0 or: [(self value indexOf: Character lf) > 0]]! !

!SqueakToken methodsFor: 'testing' stamp: 'ms 3/31/2007 21:16'!
isRBToken
	^false! !

!SqueakToken methodsFor: 'testing' stamp: 'ms 4/1/2007 18:39'!
isSignificant
	^(self isComment or:[self isWhitespace] or: [self value = '|'] or: [self value = '.'] or: [self isWhitespace]) not! !

!SqueakToken methodsFor: 'testing' stamp: 'ms 5/2/2007 11:49'!
isWhitespace

	^id == #whitespace! !

!SqueakToken methodsFor: 'accessing' stamp: 'ms 4/1/2007 13:43'!
length

	^(self stop - self start) + 1! !

!SqueakToken methodsFor: 'accessing' stamp: 'ms 9/16/2006 17:18'!
next
	
	^next! !

!SqueakToken methodsFor: 'accessing' stamp: 'ms 9/16/2006 23:24'!
next: aToken
	
	next := aToken! !

!SqueakToken methodsFor: 'accessing' stamp: 'ms 9/17/2006 18:41'!
nextSignificant

	| nextSign |
	nextSign := self next.
	[nextSign isInsignificant] 
		whileTrue: [nextSign := nextSign next.
					nextSign ifNil:[^nil]].
	^nextSign! !

!SqueakToken methodsFor: 'testing' stamp: 'ms 9/17/2006 19:59'!
notEaten
	
	^eat not! !

!SqueakToken methodsFor: 'accessing' stamp: 'ms 9/16/2006 17:19'!
previous

	^previous! !

!SqueakToken methodsFor: 'accessing' stamp: 'ms 9/16/2006 17:29'!
previous: aToken

	aToken ifNotNil:[aToken next: self].
	previous := aToken! !

!SqueakToken methodsFor: 'accessing' stamp: 'ms 3/31/2007 22:01'!
start

	^self startPosition! !

!SqueakToken methodsFor: 'accessing' stamp: 'ms 3/31/2007 21:18'!
start: aSmallInteger 
	start := aSmallInteger! !

!SqueakToken methodsFor: 'accessing' stamp: 'ms 3/31/2007 22:02'!
stop

	^self stopPosition! !

!SqueakToken methodsFor: 'replace' stamp: 'ms 11/11/2006 19:13'!
substitueTo: aToken
	
	self previous: aToken previous.
	aToken next ifNotNilDo:[:nextToken | nextToken previous: self]! !

!SqueakToken methodsFor: 'accessing' stamp: 'ms 3/31/2007 21:17'!
value: aValue 
	value := aValue! !

!Pragma class methodsFor: '*coral' stamp: 'ms 1/24/2008 21:13'!
default
	
	^self keyword: #category: arguments: #('saphir')
	
		! !

SmaCCScanner subclass: #SaphirScanner
	instanceVariableNames: 'comments previousToken'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Coral'!

!SaphirScanner class methodsFor: 'generated-initialization' stamp: 'ms 11/17/2007 10:44'!
initializeKeywordMap
	keywordMap := Dictionary new.
	#(
		#(#binarySymbol '||' 6 )
		#(28 'class' 5 )
		#(28 'false' 24 )
		#(28 'nil' 23 )
		#(28 'true' 22 )
		#(29 'apicall:' 15 )
		#(29 'cdecl:' 16 )
		#(29 'module:' 14 )
		#(29 'primitive:' 1 )
	) do: 
				[:each | 
				(keywordMap at: each first ifAbsentPut: [Dictionary new]) at: (each at: 2)
					put: each last].
	^ keywordMap! !

!SaphirScanner class methodsFor: 'generated-comments' stamp: 'ms 11/17/2007 10:44'!
scannerDefinitionComment

	"<decimalNumber>:	[0-9]+ (\. [0-9]+)? ;
<radixNumber>:		[0-9]+ r [0-9A-Z]+ (\. [0-9A-Z]+)? ;
<scaledNumber>:		<decimalNumber> s [0-9]+ ;
<exponentNumber>:	(<decimalNumber> | <radixNumber>) e \-? [0-9]+ ;
<number>:			<decimalNumber> | <radixNumber> | <exponentNumber> | <scaledNumber> ;
<negativeNumber>:	\- <number> ;
<string>:				\'  [^\']* \' (\' [^\']* \')* ;
<name>:				[a-zA-Z] [a-zA-Z0-9]* ;
<keyword>:			<name> \: ;
<multikeyword>:		<name> \: (<name> \: )+ ;
<binarySymbol>:		[\~\!!\@\%\&\*\-\+\=\\\|\?\/\>\<\,] [\~\!!\@\%\&\*\-\+\=\\\|\?\/\>\<\,]* ;
<assignment>:		\: \= | \_ ;
<alternateKeyword>:	\: <name> \: (<name> \:)* ;
<whitespace>:		\s+ ;
<comment>:			\"" [^\""]* \"" ;
<character>:			\$ . ;
<period>:				\. ;
<variableAssignment>:	<name> \: \= ;

<anyChar>:			. ; # For VW literal arrays that handle #(;) -> #(#';');"! !

!SaphirScanner methodsFor: 'token handling' stamp: 'ms 8/23/2006 11:20'!
binarySymbol
	"Negative number takes precedence over binary symbol, so for example, '0@-1' means '0 @ -1', rather than '0 @- 1', which is how the scanner reads it. If the symbol is just $- and the next char is a digit, then the negative number token takes precedence and SqueakParser>>actionForCurrentToken converts it to a binary symbol. If there is space between $- and the digit, then it reaches here and we convert it to a negativeNumber token (and let SqueakParser>>actionForCurrentToken deal with it)."

	| string negPos prevReturnMatchBlock |
	string _ outputStream contents.
	string last = $- ifFalse: [
		matchActions _ {self binarySymbolId}.
		^ self createTokenFor: outputStream contents].

	stream peek ifNil: [
		matchActions _ {self binarySymbolId}.
		^ self createTokenFor: outputStream contents].

	stream peek isDigit ifTrue: [
		"Back up one and let scanner find negativeNumber token"
		outputStream skip: -1.
		stream skip: -1.
		matchActions _ {self binarySymbolId}.
		^ self createTokenFor: outputStream contents].

	(stream peek = $  and: [string size = 1]) ifFalse: [
		matchActions _ {self binarySymbolId}.
		^ self createTokenFor: outputStream contents].

	"Allow space between negative sign and number (wierd, but allowed in Smalltalk ANSI standard)"
	negPos _ stream position.
	[stream peek = $ ] whileTrue: [stream next].

	stream peek isDigit ifFalse: [
		stream position: negPos.
		matchActions _ {self binarySymbolId}.
		^ self createTokenFor: outputStream contents].

	"scan number but catch return and convert it to a negative number"
	prevReturnMatchBlock _ returnMatchBlock.
	returnMatchBlock _ [:token | 
		returnMatchBlock _ prevReturnMatchBlock.
		token id first = self numberId ifFalse: [self error: 'unexpected token'].
		token value: '-', token value
			start: token start - 1
			id: {self negativeNumberId}.
		returnMatchBlock value: token].
	self whitespace.  "eats whitespace and scans next token"! !

!SaphirScanner methodsFor: 'generated-tokens' stamp: 'ms 11/17/2007 10:44'!
binarySymbolId
	^31! !

!SaphirScanner methodsFor: 'token handling' stamp: 'ms 8/23/2006 11:20'!
comment

	comments add: outputStream contents.
	super comment.
! !

!SaphirScanner methodsFor: 'private' stamp: 'ms 8/23/2006 11:20'!
comments

	^ comments! !

!SaphirScanner methodsFor: 'private' stamp: 'ms 11/17/2007 10:23'!
createTokenFor: string
	
	| token |
	token := SqueakToken 
				value: string
				start: start + 1
				id: matchActions
				prevToken: previousToken.
	previousToken := token.
	outputStream reset.
	matchActions := nil.
	returnMatchBlock value: token! !

!SaphirScanner methodsFor: 'generated-tokens' stamp: 'ms 11/17/2007 10:44'!
emptySymbolTokenId
	^86! !

!SaphirScanner methodsFor: 'generated-tokens' stamp: 'ms 11/17/2007 10:44'!
errorTokenId
	^87! !

!SaphirScanner methodsFor: 'private' stamp: 'ms 8/23/2006 11:20'!
initialize

	super initialize.
	comments _ OrderedCollection new.
! !

!SaphirScanner methodsFor: 'generated-tokens' stamp: 'ms 11/17/2007 10:44'!
nameId
	^28! !

!SaphirScanner methodsFor: 'generated-tokens' stamp: 'ms 11/17/2007 10:44'!
negativeNumberId
	^26! !

!SaphirScanner methodsFor: 'generated-tokens' stamp: 'ms 11/17/2007 10:44'!
numberId
	^25! !

!SaphirScanner methodsFor: 'generated-tokens' stamp: 'ms 11/17/2007 10:44'!
periodId
	^37! !

!SaphirScanner methodsFor: 'generated-scanner' stamp: 'ms 11/17/2007 10:44'!
scan1
	
	[self step.
	currentCharacter ~= $'] whileTrue.
	currentCharacter = $' ifTrue: [^ self scan2].
	^ self reportLastMatch! !

!SaphirScanner methodsFor: 'generated-scanner' stamp: 'ms 11/17/2007 10:44'!
scan10
	self step.
	(currentCharacter between: $0 and: $9) 
		ifTrue: 
			[
			[self recordMatch: #(26 ).
			self step.
			currentCharacter between: $0 and: $9] 
					whileTrue.
			^ self reportLastMatch].
	currentCharacter = $- ifTrue: [^ self scan11].
	^ self reportLastMatch! !

!SaphirScanner methodsFor: 'generated-scanner' stamp: 'ms 11/17/2007 10:44'!
scan11
	self step.
	(currentCharacter between: $0 and: $9) 
		ifTrue: 
			[
			[self recordMatch: #(26 ).
			self step.
			currentCharacter between: $0 and: $9] 
					whileTrue.
			^ self reportLastMatch].
	^ self reportLastMatch! !

!SaphirScanner methodsFor: 'generated-scanner' stamp: 'ms 11/17/2007 10:44'!
scan2
	self recordMatch: #(27 ).
	self step.
	currentCharacter = $' ifTrue: [^ self scan1].
	^ self reportLastMatch! !

!SaphirScanner methodsFor: 'generated-scanner' stamp: 'ms 11/17/2007 10:44'!
scan3
	self step.
	(currentCharacter between: $0 and: $9) 
		ifTrue: 
			[
			[self recordMatch: #(25 ).
			self step.
			currentCharacter between: $0 and: $9] 
					whileTrue.
			currentCharacter = $e ifTrue: [^ self scan4].
			currentCharacter = $s ifTrue: [^ self scan5].
			^ self reportLastMatch].
	^ self reportLastMatch! !

!SaphirScanner methodsFor: 'generated-scanner' stamp: 'ms 11/17/2007 10:44'!
scan4
	self step.
	(currentCharacter between: $0 and: $9) 
		ifTrue: 
			[
			[self recordMatch: #(25 ).
			self step.
			currentCharacter between: $0 and: $9] 
					whileTrue.
			^ self reportLastMatch].
	currentCharacter = $- ifTrue: [^ self scan5].
	^ self reportLastMatch! !

!SaphirScanner methodsFor: 'generated-scanner' stamp: 'ms 11/17/2007 10:44'!
scan5
	self step.
	(currentCharacter between: $0 and: $9) 
		ifTrue: 
			[
			[self recordMatch: #(25 ).
			self step.
			currentCharacter between: $0 and: $9] 
					whileTrue.
			^ self reportLastMatch].
	^ self reportLastMatch! !

!SaphirScanner methodsFor: 'generated-scanner' stamp: 'ms 11/17/2007 10:44'!
scan6
	self step.
	((currentCharacter between: $0 and: $9) 
		or: [currentCharacter between: $A and: $Z]) 
			ifTrue: 
				[
				[self recordMatch: #(25 ).
				self step.
				(currentCharacter between: $0 and: $9) 
					or: [currentCharacter between: $A and: $Z]] 
						whileTrue.
				currentCharacter = $. 
					ifTrue: 
						[self step.
						((currentCharacter between: $0 and: $9) 
							or: [currentCharacter between: $A and: $Z]) 
								ifTrue: 
									[
									[self recordMatch: #(25 ).
									self step.
									(currentCharacter between: $0 and: $9) 
										or: [currentCharacter between: $A and: $Z]] 
											whileTrue.
									currentCharacter = $e ifTrue: [^ self scan4].
									^ self reportLastMatch].
						^ self reportLastMatch].
				currentCharacter = $e ifTrue: [^ self scan4].
				^ self reportLastMatch].
	^ self reportLastMatch! !

!SaphirScanner methodsFor: 'generated-scanner' stamp: 'ms 11/17/2007 10:44'!
scan7
	
	[self step.
	(currentCharacter between: $0 and: $9) or: 
			[(currentCharacter between: $A and: $Z) 
				or: [currentCharacter between: $a and: $z]]] 
			whileTrue.
	currentCharacter = $: 
		ifTrue: 
			[self recordMatch: #(33 ).
			self step.
			((currentCharacter between: $A and: $Z) 
				or: [currentCharacter between: $a and: $z]) ifTrue: [^ self scan7].
			^ self reportLastMatch].
	^ self reportLastMatch! !

!SaphirScanner methodsFor: 'generated-scanner' stamp: 'ms 11/17/2007 10:44'!
scan8
	self recordMatch: #(29 ).
	self step.
	((currentCharacter between: $A and: $Z) 
		or: [currentCharacter between: $a and: $z]) ifTrue: [^ self scan9].
	currentCharacter = $= 
		ifTrue: [^ self recordAndReportMatch: #variableAssignment].
	^ self reportLastMatch! !

!SaphirScanner methodsFor: 'generated-scanner' stamp: 'ms 11/17/2007 10:44'!
scan9
	
	[self step.
	(currentCharacter between: $0 and: $9) or: 
			[(currentCharacter between: $A and: $Z) 
				or: [currentCharacter between: $a and: $z]]] 
			whileTrue.
	currentCharacter = $: 
		ifTrue: 
			[self recordMatch: #(30 ).
			self step.
			((currentCharacter between: $A and: $Z) 
				or: [currentCharacter between: $a and: $z]) ifTrue: [^ self scan9].
			^ self reportLastMatch].
	^ self reportLastMatch! !

!SaphirScanner methodsFor: 'generated-scanner' stamp: 'ms 11/17/2007 10:44'!
scanForToken
	self step.
	(currentCharacter <= Character backspace or: 
			[(currentCharacter between: (Character value: 14) and: (Character value: 31)) 
				or: [currentCharacter = $` or: [currentCharacter >= $]]]) 
		ifTrue: [^ self recordAndReportMatch: #(39 )].
	((currentCharacter between: $A and: $Z) 
		or: [currentCharacter between: $a and: $z]) 
			ifTrue: 
				[self recordMatch: #(28 39 ).
				self step.
				((currentCharacter between: $0 and: $9) or: 
						[(currentCharacter between: $A and: $Z) 
							or: [currentCharacter between: $a and: $z]]) 
					ifTrue: 
						[
						[self recordMatch: #(28 ).
						self step.
						(currentCharacter between: $0 and: $9) or: 
								[(currentCharacter between: $A and: $Z) 
									or: [currentCharacter between: $a and: $z]]] 
								whileTrue.
						currentCharacter = $: ifTrue: [^ self scan8].
						^ self reportLastMatch].
				currentCharacter = $: ifTrue: [^ self scan8].
				^ self reportLastMatch].
	(currentCharacter = $!! or: 
			[(currentCharacter between: $% and: $&) or: 
					[(currentCharacter between: $+ and: $,) or: 
							[currentCharacter = $/ or: 
									[currentCharacter = $= or: 
											[(currentCharacter between: $? and: $@) 
												or: [currentCharacter = $\ or: [currentCharacter = $~]]]]]]]) 
		ifTrue: 
			[self recordMatch: #binarySymbol.
			self step.
			(currentCharacter = $!! or: 
					[(currentCharacter between: $% and: $&) or: 
							[(currentCharacter between: $* and: $-) or: 
									[currentCharacter = $/ or: 
											[(currentCharacter between: $< and: $@) or: 
													[currentCharacter = $\ 
														or: [currentCharacter = $| or: [currentCharacter = $~]]]]]]]) 
				ifTrue: 
					[
					[self recordMatch: #binarySymbol.
					self step.
					currentCharacter = $!! or: 
							[(currentCharacter between: $% and: $&) or: 
									[(currentCharacter between: $* and: $-) or: 
											[currentCharacter = $/ or: 
													[(currentCharacter between: $< and: $@) or: 
															[currentCharacter = $\ 
																or: [currentCharacter = $| or: [currentCharacter = $~]]]]]]]] 
							whileTrue.
					^ self reportLastMatch].
			^ self reportLastMatch].
	(currentCharacter between: $0 and: $9) 
		ifTrue: 
			[self recordMatch: #(25 39 ).
			self step.
			(currentCharacter between: $0 and: $9) 
				ifTrue: 
					[
					[self recordMatch: #(25 ).
					self step.
					currentCharacter between: $0 and: $9] 
							whileTrue.
					currentCharacter = $. ifTrue: [^ self scan3].
					currentCharacter = $e ifTrue: [^ self scan4].
					currentCharacter = $r ifTrue: [^ self scan6].
					currentCharacter = $s ifTrue: [^ self scan5].
					^ self reportLastMatch].
			currentCharacter = $. ifTrue: [^ self scan3].
			currentCharacter = $e ifTrue: [^ self scan4].
			currentCharacter = $r ifTrue: [^ self scan6].
			currentCharacter = $s ifTrue: [^ self scan5].
			^ self reportLastMatch].
	((currentCharacter between: Character tab and: Character cr) 
		or: [currentCharacter = Character space]) 
			ifTrue: 
				[self recordMatch: #whitespace.
				self step.
				((currentCharacter between: Character tab and: Character cr) 
					or: [currentCharacter = Character space]) 
						ifTrue: 
							[
							[self recordMatch: #whitespace.
							self step.
							(currentCharacter between: Character tab and: Character cr) 
								or: [currentCharacter = Character space]] 
									whileTrue.
							^ self reportLastMatch].
				^ self reportLastMatch].
	currentCharacter = $" 
		ifTrue: 
			[self recordMatch: #(39 ).
			self step.
			currentCharacter ~= $" 
				ifTrue: 
					[
					[self step.
					currentCharacter ~= $"] whileTrue.
					currentCharacter = $" ifTrue: [^ self recordAndReportMatch: #comment].
					^ self reportLastMatch].
			currentCharacter = $" ifTrue: [^ self recordAndReportMatch: #comment].
			^ self reportLastMatch].
	currentCharacter = $# 
		ifTrue: 
			[self recordMatch: #(21 39 ).
			self step.
			currentCharacter = $: ifTrue: [^ self recordAndReportMatch: #(19 )].
			^ self reportLastMatch].
	currentCharacter = $$ 
		ifTrue: 
			[self recordMatch: #(39 ).
			self step.
			currentCharacter <= $ ifTrue: [^ self recordAndReportMatch: #(36 )].
			^ self reportLastMatch].
	currentCharacter = $' 
		ifTrue: 
			[self recordMatch: #(39 ).
			self step.
			currentCharacter ~= $' ifTrue: [^ self scan1].
			currentCharacter = $' ifTrue: [^ self scan2].
			^ self reportLastMatch].
	currentCharacter = $( ifTrue: [^ self recordAndReportMatch: #(4 39 )].
	currentCharacter = $) ifTrue: [^ self recordAndReportMatch: #(11 39 )].
	currentCharacter = $* 
		ifTrue: 
			[self recordMatch: #(18 31 39 ).
			self step.
			(currentCharacter = $!! or: 
					[(currentCharacter between: $% and: $&) or: 
							[(currentCharacter between: $* and: $-) or: 
									[currentCharacter = $/ or: 
											[(currentCharacter between: $< and: $@) or: 
													[currentCharacter = $\ 
														or: [currentCharacter = $| or: [currentCharacter = $~]]]]]]]) 
				ifTrue: 
					[
					[self recordMatch: #binarySymbol.
					self step.
					currentCharacter = $!! or: 
							[(currentCharacter between: $% and: $&) or: 
									[(currentCharacter between: $* and: $-) or: 
											[currentCharacter = $/ or: 
													[(currentCharacter between: $< and: $@) or: 
															[currentCharacter = $\ 
																or: [currentCharacter = $| or: [currentCharacter = $~]]]]]]]] 
							whileTrue.
					^ self reportLastMatch].
			^ self reportLastMatch].
	currentCharacter = $- 
		ifTrue: 
			[self recordMatch: #binarySymbol.
			self step.
			(currentCharacter = $!! or: 
					[(currentCharacter between: $% and: $&) or: 
							[(currentCharacter between: $* and: $-) or: 
									[currentCharacter = $/ or: 
											[(currentCharacter between: $< and: $@) or: 
													[currentCharacter = $\ 
														or: [currentCharacter = $| or: [currentCharacter = $~]]]]]]]) 
				ifTrue: 
					[
					[self recordMatch: #binarySymbol.
					self step.
					currentCharacter = $!! or: 
							[(currentCharacter between: $% and: $&) or: 
									[(currentCharacter between: $* and: $-) or: 
											[currentCharacter = $/ or: 
													[(currentCharacter between: $< and: $@) or: 
															[currentCharacter = $\ 
																or: [currentCharacter = $| or: [currentCharacter = $~]]]]]]]] 
							whileTrue.
					^ self reportLastMatch].
			(currentCharacter between: $0 and: $9) 
				ifTrue: 
					[
					[self recordMatch: #(26 ).
					self step.
					currentCharacter between: $0 and: $9] 
							whileTrue.
					currentCharacter = $. 
						ifTrue: 
							[self step.
							(currentCharacter between: $0 and: $9) 
								ifTrue: 
									[
									[self recordMatch: #(26 ).
									self step.
									currentCharacter between: $0 and: $9] 
											whileTrue.
									currentCharacter = $e ifTrue: [^ self scan10].
									currentCharacter = $s ifTrue: [^ self scan11].
									^ self reportLastMatch].
							^ self reportLastMatch].
					currentCharacter = $e ifTrue: [^ self scan10].
					currentCharacter = $r 
						ifTrue: 
							[self step.
							((currentCharacter between: $0 and: $9) 
								or: [currentCharacter between: $A and: $Z]) 
									ifTrue: 
										[
										[self recordMatch: #(26 ).
										self step.
										(currentCharacter between: $0 and: $9) 
											or: [currentCharacter between: $A and: $Z]] 
												whileTrue.
										currentCharacter = $. 
											ifTrue: 
												[self step.
												((currentCharacter between: $0 and: $9) 
													or: [currentCharacter between: $A and: $Z]) 
														ifTrue: 
															[
															[self recordMatch: #(26 ).
															self step.
															(currentCharacter between: $0 and: $9) 
																or: [currentCharacter between: $A and: $Z]] 
																	whileTrue.
															currentCharacter = $e ifTrue: [^ self scan10].
															^ self reportLastMatch].
												^ self reportLastMatch].
										currentCharacter = $e ifTrue: [^ self scan10].
										^ self reportLastMatch].
							^ self reportLastMatch].
					currentCharacter = $s ifTrue: [^ self scan11].
					^ self reportLastMatch].
			^ self reportLastMatch].
	currentCharacter = $. ifTrue: [^ self recordAndReportMatch: #(37 39 )].
	currentCharacter = $: 
		ifTrue: 
			[self recordMatch: #(3 39 ).
			self step.
			((currentCharacter between: $A and: $Z) 
				or: [currentCharacter between: $a and: $z]) ifTrue: [^ self scan7].
			currentCharacter = $= ifTrue: [^ self recordAndReportMatch: #(32 )].
			^ self reportLastMatch].
	currentCharacter = $; ifTrue: [^ self recordAndReportMatch: #(13 39 )].
	currentCharacter = $< 
		ifTrue: 
			[self recordMatch: #(7 31 39 ).
			self step.
			(currentCharacter = $!! or: 
					[(currentCharacter between: $% and: $&) or: 
							[(currentCharacter between: $* and: $-) or: 
									[currentCharacter = $/ or: 
											[(currentCharacter between: $< and: $@) or: 
													[currentCharacter = $\ 
														or: [currentCharacter = $| or: [currentCharacter = $~]]]]]]]) 
				ifTrue: 
					[
					[self recordMatch: #binarySymbol.
					self step.
					currentCharacter = $!! or: 
							[(currentCharacter between: $% and: $&) or: 
									[(currentCharacter between: $* and: $-) or: 
											[currentCharacter = $/ or: 
													[(currentCharacter between: $< and: $@) or: 
															[currentCharacter = $\ 
																or: [currentCharacter = $| or: [currentCharacter = $~]]]]]]]] 
							whileTrue.
					^ self reportLastMatch].
			^ self reportLastMatch].
	currentCharacter = $> 
		ifTrue: 
			[self recordMatch: #(8 31 39 ).
			self step.
			(currentCharacter = $!! or: 
					[(currentCharacter between: $% and: $&) or: 
							[(currentCharacter between: $* and: $-) or: 
									[currentCharacter = $/ or: 
											[(currentCharacter between: $< and: $@) or: 
													[currentCharacter = $\ 
														or: [currentCharacter = $| or: [currentCharacter = $~]]]]]]]) 
				ifTrue: 
					[
					[self recordMatch: #binarySymbol.
					self step.
					currentCharacter = $!! or: 
							[(currentCharacter between: $% and: $&) or: 
									[(currentCharacter between: $* and: $-) or: 
											[currentCharacter = $/ or: 
													[(currentCharacter between: $< and: $@) or: 
															[currentCharacter = $\ 
																or: [currentCharacter = $| or: [currentCharacter = $~]]]]]]]] 
							whileTrue.
					^ self reportLastMatch].
			^ self reportLastMatch].
	currentCharacter = $[ ifTrue: [^ self recordAndReportMatch: #(9 39 )].
	currentCharacter = $] ifTrue: [^ self recordAndReportMatch: #(10 39 )].
	currentCharacter = $^ ifTrue: [^ self recordAndReportMatch: #(2 39 )].
	currentCharacter = $_ ifTrue: [^ self recordAndReportMatch: #(32 39 )].
	currentCharacter = ${ ifTrue: [^ self recordAndReportMatch: #(17 39 )].
	currentCharacter = $| 
		ifTrue: 
			[self recordMatch: #(12 31 39 ).
			self step.
			(currentCharacter = $!! or: 
					[(currentCharacter between: $% and: $&) or: 
							[(currentCharacter between: $* and: $-) or: 
									[currentCharacter = $/ or: 
											[(currentCharacter between: $< and: $@) or: 
													[currentCharacter = $\ 
														or: [currentCharacter = $| or: [currentCharacter = $~]]]]]]]) 
				ifTrue: 
					[
					[self recordMatch: #binarySymbol.
					self step.
					currentCharacter = $!! or: 
							[(currentCharacter between: $% and: $&) or: 
									[(currentCharacter between: $* and: $-) or: 
											[currentCharacter = $/ or: 
													[(currentCharacter between: $< and: $@) or: 
															[currentCharacter = $\ 
																or: [currentCharacter = $| or: [currentCharacter = $~]]]]]]]] 
							whileTrue.
					^ self reportLastMatch].
			^ self reportLastMatch].
	currentCharacter = $} ifTrue: [^ self recordAndReportMatch: #(20 39 )].
	^ self reportLastMatch! !

!SaphirScanner methodsFor: 'accessing' stamp: 'ms 8/28/2006 17:06'!
sourceText
	^stream contents! !

!SaphirScanner methodsFor: 'token handling' stamp: 'ms 8/23/2006 11:20'!
variableAssignment

	outputStream skip: -2.
	stream skip: -2.
	matchActions _ {self nameId}.
	self createTokenFor: outputStream contents.
! !

SmaCCScanner subclass: #SqueakScanner
	instanceVariableNames: 'previousToken comments'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Coral-DeadCode'!

!SqueakScanner commentStamp: 'ajh 3/24/2003 21:31' prior: 0!
I parse Smalltalk text into tokens which are used by the SqueakParser.  Methods under 'generated-*' categories were automatically generated using SmaCC.!

SqueakScanner subclass: #SaphirScanner2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Coral-DeadCode'!

!SaphirScanner2 class methodsFor: 'generated-initialization' stamp: 'ms 1/24/2008 16:52'!
initializeKeywordMap
	keywordMap := Dictionary new.
	#(
		#(25 'class' 7 )
		#(25 'false' 20 )
		#(25 'nil' 21 )
		#(25 'true' 19 )
		#(26 'apicall:' 12 )
		#(26 'cdecl:' 13 )
		#(26 'module:' 15 )
		#(26 'primitive:' 3 )
		#(#binarySymbol '>>' 8 )
		#(#binarySymbol '||' 1 )
	) do: 
				[:each | 
				(keywordMap at: each first ifAbsentPut: [Dictionary new]) at: (each at: 2)
					put: each last].
	^ keywordMap! !

!SaphirScanner2 class methodsFor: 'generated-comments' stamp: 'ms 1/24/2008 16:52'!
scannerDefinitionComment

	"<decimalNumber>:	[0-9]+ (\. [0-9]+)? ;
<radixNumber>:		[0-9]+ r [0-9A-Z]+ (\. [0-9A-Z]+)? ;
<scaledNumber>:		<decimalNumber> s [0-9]+ ;
<exponentNumber>:	(<decimalNumber> | <radixNumber>) e \-? [0-9]+ ;
<number>:			<decimalNumber> | <radixNumber> | <exponentNumber> | <scaledNumber> ;
<negativeNumber>:	\- <number> ;
<string>:				\'  [^\']* \' (\' [^\']* \')* ;
<name>:				[a-zA-Z] [a-zA-Z0-9]* ;
<keyword>:			<name> \: ;
<multikeyword>:		<name> \: (<name> \: )+ ;
<binarySymbol>:		[\~\!!\@\%\&\*\-\+\=\\\|\?\/\>\<\,] [\~\!!\@\%\&\*\-\+\=\\\|\?\/\>\<\,]* ;
<assignment>:		\: \= | \_ ;
<alternateKeyword>:	\: <name> \: (<name> \:)* ;
<whitespace>:		\s+ ;
<comment>:			\"" [^\""]* \"" ;
<character>:			\$ . ;
<period>:				\. ;
<variableAssignment>:	<name> \: \= ;
<rightBoxBrackets>:	];
<rightCurlyBrackets>:	};
<rightParentheses>:	\);
<colon>:				\:;
<semicolon>:			\;;
<anyChar>:			. ; # For VW literal arrays that handle #(;) -> #(#';');"! !

!SaphirScanner2 methodsFor: 'generated-tokens' stamp: 'ms 1/24/2008 16:52'!
assignmentId
	^29! !

!SaphirScanner2 methodsFor: 'generated-tokens' stamp: 'ms 1/24/2008 16:52'!
binarySymbolId
	^28! !

!SaphirScanner2 methodsFor: 'generated-tokens' stamp: 'ms 1/24/2008 16:52'!
characterId
	^33! !

!SaphirScanner2 methodsFor: 'generated-tokens' stamp: 'ms 1/24/2008 16:52'!
colonId
	^39! !

!SaphirScanner2 methodsFor: 'generated-tokens' stamp: 'ms 1/24/2008 16:52'!
emptySymbolTokenId
	^88! !

!SaphirScanner2 methodsFor: 'generated-tokens' stamp: 'ms 1/24/2008 16:52'!
errorTokenId
	^89! !

!SaphirScanner2 methodsFor: 'generated-tokens' stamp: 'ms 1/24/2008 16:52'!
keywordId
	^26! !

!SaphirScanner2 methodsFor: 'generated-tokens' stamp: 'ms 1/24/2008 16:52'!
multikeywordId
	^27! !

!SaphirScanner2 methodsFor: 'generated-tokens' stamp: 'ms 1/24/2008 16:52'!
nameId
	^25! !

!SaphirScanner2 methodsFor: 'generated-tokens' stamp: 'ms 1/24/2008 16:52'!
negativeNumberId
	^23! !

!SaphirScanner2 methodsFor: 'generated-tokens' stamp: 'ms 1/24/2008 16:52'!
numberId
	^22! !

!SaphirScanner2 methodsFor: 'generated-tokens' stamp: 'ms 1/24/2008 16:52'!
periodId
	^34! !

!SaphirScanner2 methodsFor: 'generated-tokens' stamp: 'ms 1/24/2008 16:52'!
rightBoxBracketsId
	^36! !

!SaphirScanner2 methodsFor: 'generated-tokens' stamp: 'ms 1/24/2008 16:52'!
rightCurlyBracketsId
	^37! !

!SaphirScanner2 methodsFor: 'generated-tokens' stamp: 'ms 1/24/2008 16:52'!
rightParenthesesId
	^38! !

!SaphirScanner2 methodsFor: 'generated-scanner' stamp: 'ms 1/24/2008 16:52'!
scan1
	
	[self step.
	currentCharacter ~= $'] whileTrue.
	currentCharacter = $' ifTrue: [^ self scan2].
	^ self reportLastMatch! !

!SaphirScanner2 methodsFor: 'generated-scanner' stamp: 'ms 1/24/2008 16:52'!
scan10
	self step.
	(currentCharacter between: $0 and: $9) 
		ifTrue: 
			[
			[self recordMatch: #(23 ).
			self step.
			currentCharacter between: $0 and: $9] 
					whileTrue.
			^ self reportLastMatch].
	currentCharacter = $- ifTrue: [^ self scan11].
	^ self reportLastMatch! !

!SaphirScanner2 methodsFor: 'generated-scanner' stamp: 'ms 1/24/2008 16:52'!
scan11
	self step.
	(currentCharacter between: $0 and: $9) 
		ifTrue: 
			[
			[self recordMatch: #(23 ).
			self step.
			currentCharacter between: $0 and: $9] 
					whileTrue.
			^ self reportLastMatch].
	^ self reportLastMatch! !

!SaphirScanner2 methodsFor: 'generated-scanner' stamp: 'ms 1/24/2008 16:52'!
scan2
	self recordMatch: #(24 ).
	self step.
	currentCharacter = $' ifTrue: [^ self scan1].
	^ self reportLastMatch! !

!SaphirScanner2 methodsFor: 'generated-scanner' stamp: 'ms 1/24/2008 16:52'!
scan3
	self step.
	(currentCharacter between: $0 and: $9) 
		ifTrue: 
			[
			[self recordMatch: #(22 ).
			self step.
			currentCharacter between: $0 and: $9] 
					whileTrue.
			currentCharacter = $e ifTrue: [^ self scan4].
			currentCharacter = $s ifTrue: [^ self scan5].
			^ self reportLastMatch].
	^ self reportLastMatch! !

!SaphirScanner2 methodsFor: 'generated-scanner' stamp: 'ms 1/24/2008 16:52'!
scan4
	self step.
	(currentCharacter between: $0 and: $9) 
		ifTrue: 
			[
			[self recordMatch: #(22 ).
			self step.
			currentCharacter between: $0 and: $9] 
					whileTrue.
			^ self reportLastMatch].
	currentCharacter = $- ifTrue: [^ self scan5].
	^ self reportLastMatch! !

!SaphirScanner2 methodsFor: 'generated-scanner' stamp: 'ms 1/24/2008 16:52'!
scan5
	self step.
	(currentCharacter between: $0 and: $9) 
		ifTrue: 
			[
			[self recordMatch: #(22 ).
			self step.
			currentCharacter between: $0 and: $9] 
					whileTrue.
			^ self reportLastMatch].
	^ self reportLastMatch! !

!SaphirScanner2 methodsFor: 'generated-scanner' stamp: 'ms 1/24/2008 16:52'!
scan6
	self step.
	((currentCharacter between: $0 and: $9) 
		or: [currentCharacter between: $A and: $Z]) 
			ifTrue: 
				[
				[self recordMatch: #(22 ).
				self step.
				(currentCharacter between: $0 and: $9) 
					or: [currentCharacter between: $A and: $Z]] 
						whileTrue.
				currentCharacter = $. 
					ifTrue: 
						[self step.
						((currentCharacter between: $0 and: $9) 
							or: [currentCharacter between: $A and: $Z]) 
								ifTrue: 
									[
									[self recordMatch: #(22 ).
									self step.
									(currentCharacter between: $0 and: $9) 
										or: [currentCharacter between: $A and: $Z]] 
											whileTrue.
									currentCharacter = $e ifTrue: [^ self scan4].
									^ self reportLastMatch].
						^ self reportLastMatch].
				currentCharacter = $e ifTrue: [^ self scan4].
				^ self reportLastMatch].
	^ self reportLastMatch! !

!SaphirScanner2 methodsFor: 'generated-scanner' stamp: 'ms 1/24/2008 16:52'!
scan7
	
	[self step.
	(currentCharacter between: $0 and: $9) or: 
			[(currentCharacter between: $A and: $Z) 
				or: [currentCharacter between: $a and: $z]]] 
			whileTrue.
	currentCharacter = $: 
		ifTrue: 
			[self recordMatch: #(30 ).
			self step.
			((currentCharacter between: $A and: $Z) 
				or: [currentCharacter between: $a and: $z]) ifTrue: [^ self scan7].
			^ self reportLastMatch].
	^ self reportLastMatch! !

!SaphirScanner2 methodsFor: 'generated-scanner' stamp: 'ms 1/24/2008 16:52'!
scan8
	self recordMatch: #(26 ).
	self step.
	((currentCharacter between: $A and: $Z) 
		or: [currentCharacter between: $a and: $z]) ifTrue: [^ self scan9].
	currentCharacter = $= 
		ifTrue: [^ self recordAndReportMatch: #variableAssignment].
	^ self reportLastMatch! !

!SaphirScanner2 methodsFor: 'generated-scanner' stamp: 'ms 1/24/2008 16:52'!
scan9
	
	[self step.
	(currentCharacter between: $0 and: $9) or: 
			[(currentCharacter between: $A and: $Z) 
				or: [currentCharacter between: $a and: $z]]] 
			whileTrue.
	currentCharacter = $: 
		ifTrue: 
			[self recordMatch: #(27 ).
			self step.
			((currentCharacter between: $A and: $Z) 
				or: [currentCharacter between: $a and: $z]) ifTrue: [^ self scan9].
			^ self reportLastMatch].
	^ self reportLastMatch! !

!SaphirScanner2 methodsFor: 'generated-scanner' stamp: 'ms 1/24/2008 16:52'!
scanForToken
	self step.
	(currentCharacter <= Character backspace or: 
			[(currentCharacter between: (Character value: 14) and: (Character value: 31)) 
				or: [currentCharacter = $` or: [currentCharacter >= $]]]) 
		ifTrue: [^ self recordAndReportMatch: #(41 )].
	((currentCharacter between: $A and: $Z) 
		or: [currentCharacter between: $a and: $z]) 
			ifTrue: 
				[self recordMatch: #(25 41 ).
				self step.
				((currentCharacter between: $0 and: $9) or: 
						[(currentCharacter between: $A and: $Z) 
							or: [currentCharacter between: $a and: $z]]) 
					ifTrue: 
						[
						[self recordMatch: #(25 ).
						self step.
						(currentCharacter between: $0 and: $9) or: 
								[(currentCharacter between: $A and: $Z) 
									or: [currentCharacter between: $a and: $z]]] 
								whileTrue.
						currentCharacter = $: ifTrue: [^ self scan8].
						^ self reportLastMatch].
				currentCharacter = $: ifTrue: [^ self scan8].
				^ self reportLastMatch].
	(currentCharacter = $!! or: 
			[(currentCharacter between: $% and: $&) or: 
					[(currentCharacter between: $+ and: $,) or: 
							[currentCharacter = $/ or: 
									[currentCharacter = $= or: 
											[(currentCharacter between: $? and: $@) 
												or: [currentCharacter = $\ or: [currentCharacter = $~]]]]]]]) 
		ifTrue: 
			[self recordMatch: #binarySymbol.
			self step.
			(currentCharacter = $!! or: 
					[(currentCharacter between: $% and: $&) or: 
							[(currentCharacter between: $* and: $-) or: 
									[currentCharacter = $/ or: 
											[(currentCharacter between: $< and: $@) or: 
													[currentCharacter = $\ 
														or: [currentCharacter = $| or: [currentCharacter = $~]]]]]]]) 
				ifTrue: 
					[
					[self recordMatch: #binarySymbol.
					self step.
					currentCharacter = $!! or: 
							[(currentCharacter between: $% and: $&) or: 
									[(currentCharacter between: $* and: $-) or: 
											[currentCharacter = $/ or: 
													[(currentCharacter between: $< and: $@) or: 
															[currentCharacter = $\ 
																or: [currentCharacter = $| or: [currentCharacter = $~]]]]]]]] 
							whileTrue.
					^ self reportLastMatch].
			^ self reportLastMatch].
	(currentCharacter between: $0 and: $9) 
		ifTrue: 
			[self recordMatch: #(22 41 ).
			self step.
			(currentCharacter between: $0 and: $9) 
				ifTrue: 
					[
					[self recordMatch: #(22 ).
					self step.
					currentCharacter between: $0 and: $9] 
							whileTrue.
					currentCharacter = $. ifTrue: [^ self scan3].
					currentCharacter = $e ifTrue: [^ self scan4].
					currentCharacter = $r ifTrue: [^ self scan6].
					currentCharacter = $s ifTrue: [^ self scan5].
					^ self reportLastMatch].
			currentCharacter = $. ifTrue: [^ self scan3].
			currentCharacter = $e ifTrue: [^ self scan4].
			currentCharacter = $r ifTrue: [^ self scan6].
			currentCharacter = $s ifTrue: [^ self scan5].
			^ self reportLastMatch].
	((currentCharacter between: Character tab and: Character cr) 
		or: [currentCharacter = Character space]) 
			ifTrue: 
				[self recordMatch: #whitespace.
				self step.
				((currentCharacter between: Character tab and: Character cr) 
					or: [currentCharacter = Character space]) 
						ifTrue: 
							[
							[self recordMatch: #whitespace.
							self step.
							(currentCharacter between: Character tab and: Character cr) 
								or: [currentCharacter = Character space]] 
									whileTrue.
							^ self reportLastMatch].
				^ self reportLastMatch].
	currentCharacter = $" 
		ifTrue: 
			[self recordMatch: #(41 ).
			self step.
			currentCharacter ~= $" 
				ifTrue: 
					[
					[self step.
					currentCharacter ~= $"] whileTrue.
					currentCharacter = $" ifTrue: [^ self recordAndReportMatch: #comment].
					^ self reportLastMatch].
			currentCharacter = $" ifTrue: [^ self recordAndReportMatch: #comment].
			^ self reportLastMatch].
	currentCharacter = $# 
		ifTrue: 
			[self recordMatch: #(18 41 ).
			self step.
			currentCharacter = $: ifTrue: [^ self recordAndReportMatch: #(17 )].
			^ self reportLastMatch].
	currentCharacter = $$ 
		ifTrue: 
			[self recordMatch: #(41 ).
			self step.
			currentCharacter <= $ ifTrue: [^ self recordAndReportMatch: #(33 )].
			^ self reportLastMatch].
	currentCharacter = $' 
		ifTrue: 
			[self recordMatch: #(41 ).
			self step.
			currentCharacter ~= $' ifTrue: [^ self scan1].
			currentCharacter = $' ifTrue: [^ self scan2].
			^ self reportLastMatch].
	currentCharacter = $( ifTrue: [^ self recordAndReportMatch: #(6 41 )].
	currentCharacter = $) ifTrue: [^ self recordAndReportMatch: #(38 41 )].
	currentCharacter = $* 
		ifTrue: 
			[self recordMatch: #(16 28 41 ).
			self step.
			(currentCharacter = $!! or: 
					[(currentCharacter between: $% and: $&) or: 
							[(currentCharacter between: $* and: $-) or: 
									[currentCharacter = $/ or: 
											[(currentCharacter between: $< and: $@) or: 
													[currentCharacter = $\ 
														or: [currentCharacter = $| or: [currentCharacter = $~]]]]]]]) 
				ifTrue: 
					[
					[self recordMatch: #binarySymbol.
					self step.
					currentCharacter = $!! or: 
							[(currentCharacter between: $% and: $&) or: 
									[(currentCharacter between: $* and: $-) or: 
											[currentCharacter = $/ or: 
													[(currentCharacter between: $< and: $@) or: 
															[currentCharacter = $\ 
																or: [currentCharacter = $| or: [currentCharacter = $~]]]]]]]] 
							whileTrue.
					^ self reportLastMatch].
			^ self reportLastMatch].
	currentCharacter = $- 
		ifTrue: 
			[self recordMatch: #binarySymbol.
			self step.
			(currentCharacter = $!! or: 
					[(currentCharacter between: $% and: $&) or: 
							[(currentCharacter between: $* and: $-) or: 
									[currentCharacter = $/ or: 
											[(currentCharacter between: $< and: $@) or: 
													[currentCharacter = $\ 
														or: [currentCharacter = $| or: [currentCharacter = $~]]]]]]]) 
				ifTrue: 
					[
					[self recordMatch: #binarySymbol.
					self step.
					currentCharacter = $!! or: 
							[(currentCharacter between: $% and: $&) or: 
									[(currentCharacter between: $* and: $-) or: 
											[currentCharacter = $/ or: 
													[(currentCharacter between: $< and: $@) or: 
															[currentCharacter = $\ 
																or: [currentCharacter = $| or: [currentCharacter = $~]]]]]]]] 
							whileTrue.
					^ self reportLastMatch].
			(currentCharacter between: $0 and: $9) 
				ifTrue: 
					[
					[self recordMatch: #(23 ).
					self step.
					currentCharacter between: $0 and: $9] 
							whileTrue.
					currentCharacter = $. 
						ifTrue: 
							[self step.
							(currentCharacter between: $0 and: $9) 
								ifTrue: 
									[
									[self recordMatch: #(23 ).
									self step.
									currentCharacter between: $0 and: $9] 
											whileTrue.
									currentCharacter = $e ifTrue: [^ self scan10].
									currentCharacter = $s ifTrue: [^ self scan11].
									^ self reportLastMatch].
							^ self reportLastMatch].
					currentCharacter = $e ifTrue: [^ self scan10].
					currentCharacter = $r 
						ifTrue: 
							[self step.
							((currentCharacter between: $0 and: $9) 
								or: [currentCharacter between: $A and: $Z]) 
									ifTrue: 
										[
										[self recordMatch: #(23 ).
										self step.
										(currentCharacter between: $0 and: $9) 
											or: [currentCharacter between: $A and: $Z]] 
												whileTrue.
										currentCharacter = $. 
											ifTrue: 
												[self step.
												((currentCharacter between: $0 and: $9) 
													or: [currentCharacter between: $A and: $Z]) 
														ifTrue: 
															[
															[self recordMatch: #(23 ).
															self step.
															(currentCharacter between: $0 and: $9) 
																or: [currentCharacter between: $A and: $Z]] 
																	whileTrue.
															currentCharacter = $e ifTrue: [^ self scan10].
															^ self reportLastMatch].
												^ self reportLastMatch].
										currentCharacter = $e ifTrue: [^ self scan10].
										^ self reportLastMatch].
							^ self reportLastMatch].
					currentCharacter = $s ifTrue: [^ self scan11].
					^ self reportLastMatch].
			^ self reportLastMatch].
	currentCharacter = $. ifTrue: [^ self recordAndReportMatch: #(34 41 )].
	currentCharacter = $: 
		ifTrue: 
			[self recordMatch: #(39 41 ).
			self step.
			((currentCharacter between: $A and: $Z) 
				or: [currentCharacter between: $a and: $z]) ifTrue: [^ self scan7].
			currentCharacter = $= ifTrue: [^ self recordAndReportMatch: #(29 )].
			^ self reportLastMatch].
	currentCharacter = $; ifTrue: [^ self recordAndReportMatch: #(40 41 )].
	currentCharacter = $< 
		ifTrue: 
			[self recordMatch: #(4 28 41 ).
			self step.
			(currentCharacter = $!! or: 
					[(currentCharacter between: $% and: $&) or: 
							[(currentCharacter between: $* and: $-) or: 
									[currentCharacter = $/ or: 
											[(currentCharacter between: $< and: $@) or: 
													[currentCharacter = $\ 
														or: [currentCharacter = $| or: [currentCharacter = $~]]]]]]]) 
				ifTrue: 
					[
					[self recordMatch: #binarySymbol.
					self step.
					currentCharacter = $!! or: 
							[(currentCharacter between: $% and: $&) or: 
									[(currentCharacter between: $* and: $-) or: 
											[currentCharacter = $/ or: 
													[(currentCharacter between: $< and: $@) or: 
															[currentCharacter = $\ 
																or: [currentCharacter = $| or: [currentCharacter = $~]]]]]]]] 
							whileTrue.
					^ self reportLastMatch].
			^ self reportLastMatch].
	currentCharacter = $> 
		ifTrue: 
			[self recordMatch: #(9 28 41 ).
			self step.
			(currentCharacter = $!! or: 
					[(currentCharacter between: $% and: $&) or: 
							[(currentCharacter between: $* and: $-) or: 
									[currentCharacter = $/ or: 
											[(currentCharacter between: $< and: $@) or: 
													[currentCharacter = $\ 
														or: [currentCharacter = $| or: [currentCharacter = $~]]]]]]]) 
				ifTrue: 
					[
					[self recordMatch: #binarySymbol.
					self step.
					currentCharacter = $!! or: 
							[(currentCharacter between: $% and: $&) or: 
									[(currentCharacter between: $* and: $-) or: 
											[currentCharacter = $/ or: 
													[(currentCharacter between: $< and: $@) or: 
															[currentCharacter = $\ 
																or: [currentCharacter = $| or: [currentCharacter = $~]]]]]]]] 
							whileTrue.
					^ self reportLastMatch].
			^ self reportLastMatch].
	currentCharacter = $[ ifTrue: [^ self recordAndReportMatch: #(11 41 )].
	currentCharacter = $] ifTrue: [^ self recordAndReportMatch: #(10 36 41 )].
	currentCharacter = $^ ifTrue: [^ self recordAndReportMatch: #(5 41 )].
	currentCharacter = $_ ifTrue: [^ self recordAndReportMatch: #(29 41 )].
	currentCharacter = ${ ifTrue: [^ self recordAndReportMatch: #(14 41 )].
	currentCharacter = $| 
		ifTrue: 
			[self recordMatch: #(2 28 41 ).
			self step.
			(currentCharacter = $!! or: 
					[(currentCharacter between: $% and: $&) or: 
							[(currentCharacter between: $* and: $-) or: 
									[currentCharacter = $/ or: 
											[(currentCharacter between: $< and: $@) or: 
													[currentCharacter = $\ 
														or: [currentCharacter = $| or: [currentCharacter = $~]]]]]]]) 
				ifTrue: 
					[
					[self recordMatch: #binarySymbol.
					self step.
					currentCharacter = $!! or: 
							[(currentCharacter between: $% and: $&) or: 
									[(currentCharacter between: $* and: $-) or: 
											[currentCharacter = $/ or: 
													[(currentCharacter between: $< and: $@) or: 
															[currentCharacter = $\ 
																or: [currentCharacter = $| or: [currentCharacter = $~]]]]]]]] 
							whileTrue.
					^ self reportLastMatch].
			^ self reportLastMatch].
	currentCharacter = $} ifTrue: [^ self recordAndReportMatch: #(37 41 )].
	^ self reportLastMatch! !

!SaphirScanner2 methodsFor: 'generated-tokens' stamp: 'ms 1/24/2008 16:52'!
stringId
	^24! !

SqueakScanner subclass: #SqueakMethodPatternScanner
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Coral'!

!SqueakMethodPatternScanner class methodsFor: 'generated-comments' stamp: 'ms 11/19/2006 17:05'!
scannerDefinitionComment

	"<decimalNumber>:	[0-9]+ (\. [0-9]+)? ;
<radixNumber>:		[0-9]+ r [0-9A-Z]+ (\. [0-9A-Z]+)? ;
<scaledNumber>:		<decimalNumber> s [0-9]+ ;
<exponentNumber>:	(<decimalNumber> | <radixNumber>) e \-? [0-9]+ ;
<number>:			<decimalNumber> | <radixNumber> | <exponentNumber> | <scaledNumber> ;
<negativeNumber>:	\- <number> ;
<string>:				\'  [^\']* \' (\' [^\']* \')* ;
<name>:				[a-zA-Z] [a-zA-Z0-9]* ;
<keyword>:			<name> \: ;
<multikeyword>:		<name> \: (<name> \: )+ ;
<binarySymbol>:		[\~\!!\@\%\&\*\-\+\=\\\|\?\/\>\<\,] [\~\!!\@\%\&\*\-\+\=\\\|\?\/\>\<\,]* ;
<assignment>:		\: \= | \_ ;
<alternateKeyword>:	\: <name> \: (<name> \:)* ;
<whitespace>:		\s+ ;
<comment>:			\"" [^\""]* \"" ;
<character>:			\$ . ;
<period>:				\. ;
<variableAssignment>:	<name> \: \= ;
<rightBoxBrackets>:	];
<rightCurlyBrackets>:	};
<rightParentheses>:	\);
<colon>:				\:;
<semicolon>:			\;;
<anyChar>:			. ; # For VW literal arrays that handle #(;) -> #(#';');"! !

!SqueakMethodPatternScanner methodsFor: 'generated-tokens' stamp: 'ms 11/19/2006 17:05'!
assignmentId
	^16! !

!SqueakMethodPatternScanner methodsFor: 'token hanling' stamp: 'ms 11/25/2006 10:00'!
binarySymbol
	matchActions := {self binarySymbolId}.
	^ self createTokenFor: outputStream contents! !

!SqueakMethodPatternScanner methodsFor: 'generated-tokens' stamp: 'ms 11/19/2006 17:05'!
binarySymbolId
	^15! !

!SqueakMethodPatternScanner methodsFor: 'generated-tokens' stamp: 'ms 11/19/2006 17:05'!
characterId
	^20! !

!SqueakMethodPatternScanner methodsFor: 'generated-tokens' stamp: 'ms 11/19/2006 17:05'!
colonId
	^26! !

!SqueakMethodPatternScanner methodsFor: 'generated-tokens' stamp: 'ms 11/19/2006 17:05'!
emptySymbolTokenId
	^35! !

!SqueakMethodPatternScanner methodsFor: 'generated-tokens' stamp: 'ms 11/19/2006 17:05'!
errorTokenId
	^36! !

!SqueakMethodPatternScanner methodsFor: 'generated-tokens' stamp: 'ms 11/19/2006 17:05'!
keywordId
	^13! !

!SqueakMethodPatternScanner methodsFor: 'generated-tokens' stamp: 'ms 11/19/2006 17:05'!
multikeywordId
	^14! !

!SqueakMethodPatternScanner methodsFor: 'generated-tokens' stamp: 'ms 11/19/2006 17:05'!
nameId
	^12! !

!SqueakMethodPatternScanner methodsFor: 'generated-tokens' stamp: 'ms 11/19/2006 17:05'!
negativeNumberId
	^10! !

!SqueakMethodPatternScanner methodsFor: 'generated-tokens' stamp: 'ms 11/19/2006 17:05'!
numberId
	^9! !

!SqueakMethodPatternScanner methodsFor: 'generated-tokens' stamp: 'ms 11/19/2006 17:05'!
periodId
	^21! !

!SqueakMethodPatternScanner methodsFor: 'generated-tokens' stamp: 'ms 11/19/2006 17:05'!
rightBoxBracketsId
	^23! !

!SqueakMethodPatternScanner methodsFor: 'generated-tokens' stamp: 'ms 11/19/2006 17:05'!
rightCurlyBracketsId
	^24! !

!SqueakMethodPatternScanner methodsFor: 'generated-tokens' stamp: 'ms 11/19/2006 17:05'!
rightParenthesesId
	^25! !

!SqueakMethodPatternScanner methodsFor: 'generated-scanner' stamp: 'ms 11/19/2006 17:05'!
scan1
	self step.
	currentCharacter isDigit 
		ifTrue: 
			[
			[self recordMatch: #(10 ).
			self step.
			currentCharacter isDigit] 
					whileTrue.
			^ self reportLastMatch].
	currentCharacter == $- ifTrue: [^ self scan2].
	^ self reportLastMatch! !

!SqueakMethodPatternScanner methodsFor: 'generated-scanner' stamp: 'ms 11/19/2006 17:05'!
scan10
	self step.
	currentCharacter isDigit 
		ifTrue: 
			[
			[self recordMatch: #(7 9 ).
			self step.
			currentCharacter isDigit] 
					whileTrue.
			^ self reportLastMatch].
	^ self reportLastMatch! !

!SqueakMethodPatternScanner methodsFor: 'generated-scanner' stamp: 'ms 11/19/2006 17:05'!
scan11
	self recordMatch: #(13 ).
	self step.
	((currentCharacter between: $A and: $Z) 
		or: [currentCharacter between: $a and: $z]) ifTrue: [^ self scan5].
	currentCharacter == $= 
		ifTrue: [^ self recordAndReportMatch: #variableAssignment].
	^ self reportLastMatch! !

!SqueakMethodPatternScanner methodsFor: 'generated-scanner' stamp: 'ms 11/19/2006 17:05'!
scan2
	self step.
	currentCharacter isDigit 
		ifTrue: 
			[
			[self recordMatch: #(10 ).
			self step.
			currentCharacter isDigit] 
					whileTrue.
			^ self reportLastMatch].
	^ self reportLastMatch! !

!SqueakMethodPatternScanner methodsFor: 'generated-scanner' stamp: 'ms 11/19/2006 17:05'!
scan3
	
	[self step.
	currentCharacter ~~ $'] whileTrue.
	^ self scan4! !

!SqueakMethodPatternScanner methodsFor: 'generated-scanner' stamp: 'ms 11/19/2006 17:05'!
scan4
	self recordMatch: #(11 ).
	self step.
	currentCharacter == $' ifTrue: [^ self scan3].
	^ self reportLastMatch! !

!SqueakMethodPatternScanner methodsFor: 'generated-scanner' stamp: 'ms 11/19/2006 17:05'!
scan5
	
	[self step.
	(currentCharacter between: $0 and: $9) or: 
			[(currentCharacter between: $A and: $Z) 
				or: [currentCharacter between: $a and: $z]]] 
			whileTrue.
	currentCharacter == $: 
		ifTrue: 
			[self recordMatch: #(14 ).
			self step.
			((currentCharacter between: $A and: $Z) 
				or: [currentCharacter between: $a and: $z]) ifTrue: [^ self scan5].
			^ self reportLastMatch].
	^ self reportLastMatch! !

!SqueakMethodPatternScanner methodsFor: 'generated-scanner' stamp: 'ms 11/19/2006 17:05'!
scan6
	
	[self step.
	(currentCharacter between: $0 and: $9) or: 
			[(currentCharacter between: $A and: $Z) 
				or: [currentCharacter between: $a and: $z]]] 
			whileTrue.
	currentCharacter == $: 
		ifTrue: 
			[self recordMatch: #(17 ).
			self step.
			((currentCharacter between: $A and: $Z) 
				or: [currentCharacter between: $a and: $z]) ifTrue: [^ self scan6].
			^ self reportLastMatch].
	^ self reportLastMatch! !

!SqueakMethodPatternScanner methodsFor: 'generated-scanner' stamp: 'ms 11/19/2006 17:05'!
scan7
	self step.
	(currentCharacter isDigit or: [currentCharacter between: $A and: $Z]) 
		ifTrue: 
			[
			[self recordMatch: #(6 9 ).
			self step.
			currentCharacter isDigit or: [currentCharacter between: $A and: $Z]] 
					whileTrue.
			currentCharacter == $. 
				ifTrue: 
					[self step.
					(currentCharacter isDigit or: [currentCharacter between: $A and: $Z]) 
						ifTrue: 
							[
							[self recordMatch: #(6 9 ).
							self step.
							currentCharacter isDigit or: [currentCharacter between: $A and: $Z]] 
									whileTrue.
							currentCharacter == $e ifTrue: [^ self scan8].
							^ self reportLastMatch].
					^ self reportLastMatch].
			currentCharacter == $e ifTrue: [^ self scan8].
			^ self reportLastMatch].
	^ self reportLastMatch! !

!SqueakMethodPatternScanner methodsFor: 'generated-scanner' stamp: 'ms 11/19/2006 17:05'!
scan8
	self step.
	currentCharacter isDigit 
		ifTrue: 
			[
			[self recordMatch: #(8 9 ).
			self step.
			currentCharacter isDigit] 
					whileTrue.
			^ self reportLastMatch].
	currentCharacter == $- 
		ifTrue: 
			[self step.
			currentCharacter isDigit 
				ifTrue: 
					[
					[self recordMatch: #(8 9 ).
					self step.
					currentCharacter isDigit] 
							whileTrue.
					^ self reportLastMatch].
			^ self reportLastMatch].
	^ self reportLastMatch! !

!SqueakMethodPatternScanner methodsFor: 'generated-scanner' stamp: 'ms 11/19/2006 17:05'!
scan9
	self step.
	currentCharacter isDigit 
		ifTrue: 
			[
			[self recordMatch: #(5 9 ).
			self step.
			currentCharacter isDigit] 
					whileTrue.
			currentCharacter == $e ifTrue: [^ self scan8].
			currentCharacter == $s ifTrue: [^ self scan10].
			^ self reportLastMatch].
	^ self reportLastMatch! !

!SqueakMethodPatternScanner methodsFor: 'generated-scanner' stamp: 'ms 11/19/2006 17:05'!
scanForToken
	self step.
	(currentCharacter <= Character backspace or: 
			[(currentCharacter between: (Character value: 14) and: (Character value: 31)) 
				or: 
					[currentCharacter == $# or: 
							[currentCharacter == $^ 
								or: [currentCharacter == $` or: [currentCharacter >= $]]]]]) 
		ifTrue: [^ self recordAndReportMatch: #(28 )].
	((currentCharacter between: $A and: $Z) 
		or: [currentCharacter between: $a and: $z]) 
			ifTrue: 
				[self recordMatch: #(12 28 ).
				self step.
				((currentCharacter between: $0 and: $9) or: 
						[(currentCharacter between: $A and: $Z) 
							or: [currentCharacter between: $a and: $z]]) 
					ifTrue: 
						[
						[self recordMatch: #(12 ).
						self step.
						(currentCharacter between: $0 and: $9) or: 
								[(currentCharacter between: $A and: $Z) 
									or: [currentCharacter between: $a and: $z]]] 
								whileTrue.
						currentCharacter == $: ifTrue: [^ self scan11].
						^ self reportLastMatch].
				currentCharacter == $: ifTrue: [^ self scan11].
				^ self reportLastMatch].
	(currentCharacter == $!! or: 
			[(currentCharacter between: $% and: $&) or: 
					[(currentCharacter between: $* and: $,) or: 
							[currentCharacter == $/ or: 
									[(currentCharacter between: $< and: $@) 
										or: [currentCharacter == $\ or: [currentCharacter == $~]]]]]]) 
		ifTrue: 
			[self recordMatch: #binarySymbol.
			self step.
			currentCharacter isSpecial 
				ifTrue: 
					[
					[self recordMatch: #binarySymbol.
					self step.
					currentCharacter isSpecial] 
							whileTrue.
					^ self reportLastMatch].
			^ self reportLastMatch].
	currentCharacter isDigit 
		ifTrue: 
			[self recordMatch: #(5 9 28 ).
			self step.
			currentCharacter isDigit 
				ifTrue: 
					[
					[self recordMatch: #(5 9 ).
					self step.
					currentCharacter isDigit] 
							whileTrue.
					currentCharacter == $. ifTrue: [^ self scan9].
					currentCharacter == $e ifTrue: [^ self scan8].
					currentCharacter == $r ifTrue: [^ self scan7].
					currentCharacter == $s ifTrue: [^ self scan10].
					^ self reportLastMatch].
			currentCharacter == $. ifTrue: [^ self scan9].
			currentCharacter == $e ifTrue: [^ self scan8].
			currentCharacter == $r ifTrue: [^ self scan7].
			currentCharacter == $s ifTrue: [^ self scan10].
			^ self reportLastMatch].
	(currentCharacter isSeparator 
		or: [currentCharacter == (Character value: 11)]) 
			ifTrue: 
				[self recordMatch: #whitespace.
				self step.
				(currentCharacter isSeparator 
					or: [currentCharacter == (Character value: 11)]) 
						ifTrue: 
							[
							[self recordMatch: #whitespace.
							self step.
							currentCharacter isSeparator 
								or: [currentCharacter == (Character value: 11)]] 
									whileTrue.
							^ self reportLastMatch].
				^ self reportLastMatch].
	currentCharacter == $" 
		ifTrue: 
			[self recordMatch: #(28 ).
			self step.
			currentCharacter ~~ $" 
				ifTrue: 
					[
					[self step.
					currentCharacter ~~ $"] whileTrue.
					^ self recordAndReportMatch: #comment].
			currentCharacter == $" ifTrue: [^ self recordAndReportMatch: #comment].
			^ self reportLastMatch].
	currentCharacter == $$ 
		ifTrue: 
			[self recordMatch: #(28 ).
			self step.
			^ self recordAndReportMatch: #(20 )].
	currentCharacter == $' 
		ifTrue: 
			[self recordMatch: #(28 ).
			self step.
			currentCharacter ~~ $' ifTrue: [^ self scan3].
			currentCharacter == $' ifTrue: [^ self scan4].
			^ self reportLastMatch].
	currentCharacter == $( ifTrue: [^ self recordAndReportMatch: #(4 28 )].
	currentCharacter == $) ifTrue: [^ self recordAndReportMatch: #(25 28 )].
	currentCharacter == $- 
		ifTrue: 
			[self recordMatch: #binarySymbol.
			self step.
			currentCharacter isSpecial 
				ifTrue: 
					[
					[self recordMatch: #binarySymbol.
					self step.
					currentCharacter isSpecial] 
							whileTrue.
					^ self reportLastMatch].
			currentCharacter isDigit 
				ifTrue: 
					[
					[self recordMatch: #(10 ).
					self step.
					currentCharacter isDigit] 
							whileTrue.
					currentCharacter == $. 
						ifTrue: 
							[self step.
							currentCharacter isDigit 
								ifTrue: 
									[
									[self recordMatch: #(10 ).
									self step.
									currentCharacter isDigit] 
											whileTrue.
									currentCharacter == $e ifTrue: [^ self scan1].
									currentCharacter == $s ifTrue: [^ self scan2].
									^ self reportLastMatch].
							^ self reportLastMatch].
					currentCharacter == $e ifTrue: [^ self scan1].
					currentCharacter == $r 
						ifTrue: 
							[self step.
							(currentCharacter isDigit or: [currentCharacter between: $A and: $Z]) 
								ifTrue: 
									[
									[self recordMatch: #(10 ).
									self step.
									currentCharacter isDigit or: [currentCharacter between: $A and: $Z]] 
											whileTrue.
									currentCharacter == $. 
										ifTrue: 
											[self step.
											(currentCharacter isDigit or: [currentCharacter between: $A and: $Z]) 
												ifTrue: 
													[
													[self recordMatch: #(10 ).
													self step.
													currentCharacter isDigit or: [currentCharacter between: $A and: $Z]] 
															whileTrue.
													currentCharacter == $e ifTrue: [^ self scan1].
													^ self reportLastMatch].
											^ self reportLastMatch].
									currentCharacter == $e ifTrue: [^ self scan1].
									^ self reportLastMatch].
							^ self reportLastMatch].
					currentCharacter == $s ifTrue: [^ self scan2].
					^ self reportLastMatch].
			^ self reportLastMatch].
	currentCharacter == $. ifTrue: [^ self recordAndReportMatch: #(21 28 )].
	currentCharacter == $: 
		ifTrue: 
			[self recordMatch: #(26 28 ).
			self step.
			((currentCharacter between: $A and: $Z) 
				or: [currentCharacter between: $a and: $z]) ifTrue: [^ self scan6].
			currentCharacter == $= ifTrue: [^ self recordAndReportMatch: #(16 )].
			^ self reportLastMatch].
	currentCharacter == $; ifTrue: [^ self recordAndReportMatch: #(27 28 )].
	currentCharacter == $[ ifTrue: [^ self recordAndReportMatch: #(1 28 )].
	currentCharacter == $] ifTrue: [^ self recordAndReportMatch: #(23 28 )].
	currentCharacter == $_ ifTrue: [^ self recordAndReportMatch: #(16 28 )].
	currentCharacter == ${ ifTrue: [^ self recordAndReportMatch: #(2 28 )].
	currentCharacter == $| 
		ifTrue: 
			[self recordMatch: #(3 15 28 ).
			self step.
			currentCharacter isSpecial 
				ifTrue: 
					[
					[self recordMatch: #binarySymbol.
					self step.
					currentCharacter isSpecial] 
							whileTrue.
					^ self reportLastMatch].
			^ self reportLastMatch].
	currentCharacter == $} ifTrue: [^ self recordAndReportMatch: #(24 28 )].
	^ self reportLastMatch! !

!SqueakMethodPatternScanner methodsFor: 'generated-tokens' stamp: 'ms 11/19/2006 17:05'!
stringId
	^11! !

!SqueakScanner class methodsFor: 'generated-initialization' stamp: 'ms 4/7/2007 03:32'!
initializeKeywordMap
	keywordMap := Dictionary new.
	#(
		#(#binarySymbol '||' 8 )
		#(22 'false' 15 )
		#(22 'nil' 16 )
		#(22 'true' 10 )
		#(23 'apicall:' 14 )
		#(23 'cdecl:' 11 )
		#(23 'module:' 13 )
		#(23 'primitive:' 3 )
	) do: 
				[:each | 
				(keywordMap at: each first ifAbsentPut: [Dictionary new]) at: (each at: 2)
					put: each last].
	^ keywordMap! !

!SqueakScanner class methodsFor: 'generated-comments' stamp: 'ms 4/7/2007 03:32'!
scannerDefinitionComment

	"<decimalNumber>:	[0-9]+ (\. [0-9]+)? ;
<radixNumber>:		[0-9]+ r [0-9A-Z]+ (\. [0-9A-Z]+)? ;
<scaledNumber>:		<decimalNumber> s [0-9]+ ;
<exponentNumber>:	(<decimalNumber> | <radixNumber>) e \-? [0-9]+ ;
<number>:			<decimalNumber> | <radixNumber> | <exponentNumber> | <scaledNumber> ;
<negativeNumber>:	\- <number> ;
<string>:				\'  [^\']* \' (\' [^\']* \')* ;
<name>:				[a-zA-Z] [a-zA-Z0-9]* ;
<keyword>:			<name> \: ;
<multikeyword>:		<name> \: (<name> \: )+ ;
<binarySymbol>:		[\~\!!\@\%\&\*\-\+\=\\\|\?\/\>\<\,] [\~\!!\@\%\&\*\-\+\=\\\|\?\/\>\<\,]* ;
<assignment>:		\: \= | \_ ;
<alternateKeyword>:	\: <name> \: (<name> \:)* ;
<whitespace>:		\s+ ;
<comment>:			\"" [^\""]* \"" ;
<character>:			\$ . ;
<period>:				\. ;
<variableAssignment>:	<name> \: \= ;
<rightBoxBrackets>:	];
<rightCurlyBrackets>:	};
<rightParentheses>:	\);
<colon>:				\:;
<semicolon>:			\;;
<anyChar>:			. ; # For VW literal arrays that handle #(;) -> #(#';');"! !

!SqueakScanner methodsFor: 'generated-tokens' stamp: 'ms 4/7/2007 03:32'!
assignmentId
	^26! !

!SqueakScanner methodsFor: 'token handling' stamp: 'ms 3/31/2007 21:31'!
binarySymbol
	"Negative number takes precedence over binary symbol, so for example, '0@-1' means '0 @ -1', rather than '0 @- 1', which is how the scanner reads it. If the symbol is just $- and the next char is a digit, then the negative number token takes precedence and SqueakParser>>actionForCurrentToken converts it to a binary symbol. If there is space between $- and the digit, then it reaches here and we convert it to a negativeNumber token (and let SqueakParser>>actionForCurrentToken deal with it)."

	| string negPos prevReturnMatchBlock |
	string _ outputStream contents.
	string last = $- ifFalse: [
		matchActions _ {self binarySymbolId}.
		^ self createTokenFor: outputStream contents].

	stream peek ifNil: [
		matchActions _ {self binarySymbolId}.
		^ self createTokenFor: outputStream contents].

	stream peek isDigit ifTrue: [
		"Back up one and let scanner find negativeNumber token"
		outputStream skip: -1.
		stream skip: -1.
		matchActions _ {self binarySymbolId}.
		^ self createTokenFor: outputStream contents].

	(stream peek = $  and: [string size = 1]) ifFalse: [
		matchActions _ {self binarySymbolId}.
		^ self createTokenFor: outputStream contents].

	"Allow space between negative sign and number (wierd, but allowed in Smalltalk ANSI standard)"
	negPos _ stream position.
	[stream peek = $ ] whileTrue: [stream next].

	stream peek isDigit ifFalse: [
		stream position: negPos.
		matchActions _ {self binarySymbolId}.
		^ self createTokenFor: outputStream contents].

	"scan number but catch return and convert it to a negative number"
	prevReturnMatchBlock _ returnMatchBlock.
	returnMatchBlock _ [:token | 
		returnMatchBlock _ prevReturnMatchBlock.
		token id first = self numberId ifFalse: [self error: 'unexpected token'].
		token value: '-', token value
			start: token start - 1
			id: {self negativeNumberId}.
		returnMatchBlock value: token].
	self whitespace.  "eats whitespace and scans next token"! !

!SqueakScanner methodsFor: 'generated-tokens' stamp: 'ms 4/7/2007 03:32'!
binarySymbolId
	^25! !

!SqueakScanner methodsFor: 'generated-tokens' stamp: 'ms 4/7/2007 03:32'!
characterId
	^30! !

!SqueakScanner methodsFor: 'generated-tokens' stamp: 'ms 4/7/2007 03:32'!
colonId
	^36! !

!SqueakScanner methodsFor: 'token handling' stamp: 'ms 5/10/2007 20:07'!
comment
	| value |
	value := outputStream contents.
	comments add: {value. start}.
	previousToken :=  SqueakToken 
		value: value 
		start: start 
		id: #comment 
		prevToken: previousToken.
	self resetScanner.
	stream atEnd ifFalse: [^self scanForToken]
		ifTrue:[^self scannerError]
! !

!SqueakScanner methodsFor: 'private' stamp: 'ajh 3/6/2003 00:16'!
comments

	^ comments! !

!SqueakScanner methodsFor: 'private' stamp: 'ms 4/7/2007 03:31'!
createTokenFor: string
	
	| token |
	token := SqueakToken 
				value: string
				start: start + 1
				id: matchActions
				prevToken: previousToken.
	previousToken := token.
	outputStream reset.
	matchActions := nil.
	returnMatchBlock value: token! !

!SqueakScanner methodsFor: 'generated-tokens' stamp: 'ms 4/7/2007 03:32'!
emptySymbolTokenId
	^80! !

!SqueakScanner methodsFor: 'generated-tokens' stamp: 'ms 4/7/2007 03:32'!
errorTokenId
	^81! !

!SqueakScanner methodsFor: 'private' stamp: 'ajh 3/6/2003 00:13'!
initialize

	super initialize.
	comments _ OrderedCollection new.
! !

!SqueakScanner methodsFor: 'generated-tokens' stamp: 'ms 4/7/2007 03:32'!
keywordId
	^23! !

!SqueakScanner methodsFor: 'generated-tokens' stamp: 'ms 4/7/2007 03:32'!
multikeywordId
	^24! !

!SqueakScanner methodsFor: 'generated-tokens' stamp: 'ms 4/7/2007 03:32'!
nameId
	^22! !

!SqueakScanner methodsFor: 'generated-tokens' stamp: 'ms 4/7/2007 03:32'!
negativeNumberId
	^20! !

!SqueakScanner methodsFor: 'generated-tokens' stamp: 'ms 4/7/2007 03:32'!
numberId
	^19! !

!SqueakScanner methodsFor: 'generated-tokens' stamp: 'ms 4/7/2007 03:32'!
periodId
	^31! !

!SqueakScanner methodsFor: 'generated-tokens' stamp: 'ms 4/7/2007 03:32'!
rightBoxBracketsId
	^33! !

!SqueakScanner methodsFor: 'generated-tokens' stamp: 'ms 4/7/2007 03:32'!
rightCurlyBracketsId
	^34! !

!SqueakScanner methodsFor: 'generated-tokens' stamp: 'ms 4/7/2007 03:32'!
rightParenthesesId
	^35! !

!SqueakScanner methodsFor: 'generated-scanner' stamp: 'ms 4/7/2007 03:32'!
scan1
	
	[self step.
	currentCharacter ~= $'] whileTrue.
	currentCharacter = $' ifTrue: [^ self scan2].
	^ self reportLastMatch! !

!SqueakScanner methodsFor: 'generated-scanner' stamp: 'ms 4/7/2007 03:32'!
scan10
	self step.
	(currentCharacter between: $0 and: $9) 
		ifTrue: 
			[
			[self recordMatch: #(20 ).
			self step.
			currentCharacter between: $0 and: $9] 
					whileTrue.
			^ self reportLastMatch].
	currentCharacter = $- ifTrue: [^ self scan11].
	^ self reportLastMatch! !

!SqueakScanner methodsFor: 'generated-scanner' stamp: 'ms 4/7/2007 03:32'!
scan11
	self step.
	(currentCharacter between: $0 and: $9) 
		ifTrue: 
			[
			[self recordMatch: #(20 ).
			self step.
			currentCharacter between: $0 and: $9] 
					whileTrue.
			^ self reportLastMatch].
	^ self reportLastMatch! !

!SqueakScanner methodsFor: 'generated-scanner' stamp: 'ms 4/7/2007 03:32'!
scan2
	self recordMatch: #(21 ).
	self step.
	currentCharacter = $' ifTrue: [^ self scan1].
	^ self reportLastMatch! !

!SqueakScanner methodsFor: 'generated-scanner' stamp: 'ms 4/7/2007 03:32'!
scan3
	self step.
	(currentCharacter between: $0 and: $9) 
		ifTrue: 
			[
			[self recordMatch: #(19 ).
			self step.
			currentCharacter between: $0 and: $9] 
					whileTrue.
			currentCharacter = $e ifTrue: [^ self scan4].
			currentCharacter = $s ifTrue: [^ self scan5].
			^ self reportLastMatch].
	^ self reportLastMatch! !

!SqueakScanner methodsFor: 'generated-scanner' stamp: 'ms 4/7/2007 03:32'!
scan4
	self step.
	(currentCharacter between: $0 and: $9) 
		ifTrue: 
			[
			[self recordMatch: #(19 ).
			self step.
			currentCharacter between: $0 and: $9] 
					whileTrue.
			^ self reportLastMatch].
	currentCharacter = $- ifTrue: [^ self scan5].
	^ self reportLastMatch! !

!SqueakScanner methodsFor: 'generated-scanner' stamp: 'ms 4/7/2007 03:32'!
scan5
	self step.
	(currentCharacter between: $0 and: $9) 
		ifTrue: 
			[
			[self recordMatch: #(19 ).
			self step.
			currentCharacter between: $0 and: $9] 
					whileTrue.
			^ self reportLastMatch].
	^ self reportLastMatch! !

!SqueakScanner methodsFor: 'generated-scanner' stamp: 'ms 4/7/2007 03:32'!
scan6
	self step.
	((currentCharacter between: $0 and: $9) 
		or: [currentCharacter between: $A and: $Z]) 
			ifTrue: 
				[
				[self recordMatch: #(19 ).
				self step.
				(currentCharacter between: $0 and: $9) 
					or: [currentCharacter between: $A and: $Z]] 
						whileTrue.
				currentCharacter = $. 
					ifTrue: 
						[self step.
						((currentCharacter between: $0 and: $9) 
							or: [currentCharacter between: $A and: $Z]) 
								ifTrue: 
									[
									[self recordMatch: #(19 ).
									self step.
									(currentCharacter between: $0 and: $9) 
										or: [currentCharacter between: $A and: $Z]] 
											whileTrue.
									currentCharacter = $e ifTrue: [^ self scan4].
									^ self reportLastMatch].
						^ self reportLastMatch].
				currentCharacter = $e ifTrue: [^ self scan4].
				^ self reportLastMatch].
	^ self reportLastMatch! !

!SqueakScanner methodsFor: 'generated-scanner' stamp: 'ms 4/7/2007 03:32'!
scan7
	
	[self step.
	(currentCharacter between: $0 and: $9) or: 
			[(currentCharacter between: $A and: $Z) 
				or: [currentCharacter between: $a and: $z]]] 
			whileTrue.
	currentCharacter = $: 
		ifTrue: 
			[self recordMatch: #(27 ).
			self step.
			((currentCharacter between: $A and: $Z) 
				or: [currentCharacter between: $a and: $z]) ifTrue: [^ self scan7].
			^ self reportLastMatch].
	^ self reportLastMatch! !

!SqueakScanner methodsFor: 'generated-scanner' stamp: 'ms 4/7/2007 03:32'!
scan8
	self recordMatch: #(23 ).
	self step.
	((currentCharacter between: $A and: $Z) 
		or: [currentCharacter between: $a and: $z]) ifTrue: [^ self scan9].
	currentCharacter = $= 
		ifTrue: [^ self recordAndReportMatch: #variableAssignment].
	^ self reportLastMatch! !

!SqueakScanner methodsFor: 'generated-scanner' stamp: 'ms 4/7/2007 03:32'!
scan9
	
	[self step.
	(currentCharacter between: $0 and: $9) or: 
			[(currentCharacter between: $A and: $Z) 
				or: [currentCharacter between: $a and: $z]]] 
			whileTrue.
	currentCharacter = $: 
		ifTrue: 
			[self recordMatch: #(24 ).
			self step.
			((currentCharacter between: $A and: $Z) 
				or: [currentCharacter between: $a and: $z]) ifTrue: [^ self scan9].
			^ self reportLastMatch].
	^ self reportLastMatch! !

!SqueakScanner methodsFor: 'generated-scanner' stamp: 'ms 4/7/2007 03:32'!
scanForToken
	self step.
	(currentCharacter <= Character backspace or: 
			[(currentCharacter between: (Character value: 14) and: (Character value: 31)) 
				or: [currentCharacter = $` or: [currentCharacter >= $]]]) 
		ifTrue: [^ self recordAndReportMatch: #(38 )].
	((currentCharacter between: $A and: $Z) 
		or: [currentCharacter between: $a and: $z]) 
			ifTrue: 
				[self recordMatch: #(22 38 ).
				self step.
				((currentCharacter between: $0 and: $9) or: 
						[(currentCharacter between: $A and: $Z) 
							or: [currentCharacter between: $a and: $z]]) 
					ifTrue: 
						[
						[self recordMatch: #(22 ).
						self step.
						(currentCharacter between: $0 and: $9) or: 
								[(currentCharacter between: $A and: $Z) 
									or: [currentCharacter between: $a and: $z]]] 
								whileTrue.
						currentCharacter = $: ifTrue: [^ self scan8].
						^ self reportLastMatch].
				currentCharacter = $: ifTrue: [^ self scan8].
				^ self reportLastMatch].
	(currentCharacter = $!! or: 
			[(currentCharacter between: $% and: $&) or: 
					[(currentCharacter between: $+ and: $,) or: 
							[currentCharacter = $/ or: 
									[currentCharacter = $= or: 
											[(currentCharacter between: $? and: $@) 
												or: [currentCharacter = $\ or: [currentCharacter = $~]]]]]]]) 
		ifTrue: 
			[self recordMatch: #binarySymbol.
			self step.
			(currentCharacter = $!! or: 
					[(currentCharacter between: $% and: $&) or: 
							[(currentCharacter between: $* and: $-) or: 
									[currentCharacter = $/ or: 
											[(currentCharacter between: $< and: $@) or: 
													[currentCharacter = $\ 
														or: [currentCharacter = $| or: [currentCharacter = $~]]]]]]]) 
				ifTrue: 
					[
					[self recordMatch: #binarySymbol.
					self step.
					currentCharacter = $!! or: 
							[(currentCharacter between: $% and: $&) or: 
									[(currentCharacter between: $* and: $-) or: 
											[currentCharacter = $/ or: 
													[(currentCharacter between: $< and: $@) or: 
															[currentCharacter = $\ 
																or: [currentCharacter = $| or: [currentCharacter = $~]]]]]]]] 
							whileTrue.
					^ self reportLastMatch].
			^ self reportLastMatch].
	(currentCharacter between: $0 and: $9) 
		ifTrue: 
			[self recordMatch: #(19 38 ).
			self step.
			(currentCharacter between: $0 and: $9) 
				ifTrue: 
					[
					[self recordMatch: #(19 ).
					self step.
					currentCharacter between: $0 and: $9] 
							whileTrue.
					currentCharacter = $. ifTrue: [^ self scan3].
					currentCharacter = $e ifTrue: [^ self scan4].
					currentCharacter = $r ifTrue: [^ self scan6].
					currentCharacter = $s ifTrue: [^ self scan5].
					^ self reportLastMatch].
			currentCharacter = $. ifTrue: [^ self scan3].
			currentCharacter = $e ifTrue: [^ self scan4].
			currentCharacter = $r ifTrue: [^ self scan6].
			currentCharacter = $s ifTrue: [^ self scan5].
			^ self reportLastMatch].
	((currentCharacter between: Character tab and: Character cr) 
		or: [currentCharacter = Character space]) 
			ifTrue: 
				[self recordMatch: #whitespace.
				self step.
				((currentCharacter between: Character tab and: Character cr) 
					or: [currentCharacter = Character space]) 
						ifTrue: 
							[
							[self recordMatch: #whitespace.
							self step.
							(currentCharacter between: Character tab and: Character cr) 
								or: [currentCharacter = Character space]] 
									whileTrue.
							^ self reportLastMatch].
				^ self reportLastMatch].
	currentCharacter = $" 
		ifTrue: 
			[self recordMatch: #(38 ).
			self step.
			currentCharacter ~= $" 
				ifTrue: 
					[
					[self step.
					currentCharacter ~= $"] whileTrue.
					currentCharacter = $" ifTrue: [^ self recordAndReportMatch: #comment].
					^ self reportLastMatch].
			currentCharacter = $" ifTrue: [^ self recordAndReportMatch: #comment].
			^ self reportLastMatch].
	currentCharacter = $# 
		ifTrue: 
			[self recordMatch: #(17 38 ).
			self step.
			currentCharacter = $: ifTrue: [^ self recordAndReportMatch: #(18 )].
			^ self reportLastMatch].
	currentCharacter = $$ 
		ifTrue: 
			[self recordMatch: #(38 ).
			self step.
			currentCharacter <= $ ifTrue: [^ self recordAndReportMatch: #(30 )].
			^ self reportLastMatch].
	currentCharacter = $' 
		ifTrue: 
			[self recordMatch: #(38 ).
			self step.
			currentCharacter ~= $' ifTrue: [^ self scan1].
			currentCharacter = $' ifTrue: [^ self scan2].
			^ self reportLastMatch].
	currentCharacter = $( ifTrue: [^ self recordAndReportMatch: #(2 38 )].
	currentCharacter = $) ifTrue: [^ self recordAndReportMatch: #(35 38 )].
	currentCharacter = $* 
		ifTrue: 
			[self recordMatch: #(12 25 38 ).
			self step.
			(currentCharacter = $!! or: 
					[(currentCharacter between: $% and: $&) or: 
							[(currentCharacter between: $* and: $-) or: 
									[currentCharacter = $/ or: 
											[(currentCharacter between: $< and: $@) or: 
													[currentCharacter = $\ 
														or: [currentCharacter = $| or: [currentCharacter = $~]]]]]]]) 
				ifTrue: 
					[
					[self recordMatch: #binarySymbol.
					self step.
					currentCharacter = $!! or: 
							[(currentCharacter between: $% and: $&) or: 
									[(currentCharacter between: $* and: $-) or: 
											[currentCharacter = $/ or: 
													[(currentCharacter between: $< and: $@) or: 
															[currentCharacter = $\ 
																or: [currentCharacter = $| or: [currentCharacter = $~]]]]]]]] 
							whileTrue.
					^ self reportLastMatch].
			^ self reportLastMatch].
	currentCharacter = $- 
		ifTrue: 
			[self recordMatch: #binarySymbol.
			self step.
			(currentCharacter = $!! or: 
					[(currentCharacter between: $% and: $&) or: 
							[(currentCharacter between: $* and: $-) or: 
									[currentCharacter = $/ or: 
											[(currentCharacter between: $< and: $@) or: 
													[currentCharacter = $\ 
														or: [currentCharacter = $| or: [currentCharacter = $~]]]]]]]) 
				ifTrue: 
					[
					[self recordMatch: #binarySymbol.
					self step.
					currentCharacter = $!! or: 
							[(currentCharacter between: $% and: $&) or: 
									[(currentCharacter between: $* and: $-) or: 
											[currentCharacter = $/ or: 
													[(currentCharacter between: $< and: $@) or: 
															[currentCharacter = $\ 
																or: [currentCharacter = $| or: [currentCharacter = $~]]]]]]]] 
							whileTrue.
					^ self reportLastMatch].
			(currentCharacter between: $0 and: $9) 
				ifTrue: 
					[
					[self recordMatch: #(20 ).
					self step.
					currentCharacter between: $0 and: $9] 
							whileTrue.
					currentCharacter = $. 
						ifTrue: 
							[self step.
							(currentCharacter between: $0 and: $9) 
								ifTrue: 
									[
									[self recordMatch: #(20 ).
									self step.
									currentCharacter between: $0 and: $9] 
											whileTrue.
									currentCharacter = $e ifTrue: [^ self scan10].
									currentCharacter = $s ifTrue: [^ self scan11].
									^ self reportLastMatch].
							^ self reportLastMatch].
					currentCharacter = $e ifTrue: [^ self scan10].
					currentCharacter = $r 
						ifTrue: 
							[self step.
							((currentCharacter between: $0 and: $9) 
								or: [currentCharacter between: $A and: $Z]) 
									ifTrue: 
										[
										[self recordMatch: #(20 ).
										self step.
										(currentCharacter between: $0 and: $9) 
											or: [currentCharacter between: $A and: $Z]] 
												whileTrue.
										currentCharacter = $. 
											ifTrue: 
												[self step.
												((currentCharacter between: $0 and: $9) 
													or: [currentCharacter between: $A and: $Z]) 
														ifTrue: 
															[
															[self recordMatch: #(20 ).
															self step.
															(currentCharacter between: $0 and: $9) 
																or: [currentCharacter between: $A and: $Z]] 
																	whileTrue.
															currentCharacter = $e ifTrue: [^ self scan10].
															^ self reportLastMatch].
												^ self reportLastMatch].
										currentCharacter = $e ifTrue: [^ self scan10].
										^ self reportLastMatch].
							^ self reportLastMatch].
					currentCharacter = $s ifTrue: [^ self scan11].
					^ self reportLastMatch].
			^ self reportLastMatch].
	currentCharacter = $. ifTrue: [^ self recordAndReportMatch: #(31 38 )].
	currentCharacter = $: 
		ifTrue: 
			[self recordMatch: #(36 38 ).
			self step.
			((currentCharacter between: $A and: $Z) 
				or: [currentCharacter between: $a and: $z]) ifTrue: [^ self scan7].
			currentCharacter = $= ifTrue: [^ self recordAndReportMatch: #(26 )].
			^ self reportLastMatch].
	currentCharacter = $; ifTrue: [^ self recordAndReportMatch: #(37 38 )].
	currentCharacter = $< 
		ifTrue: 
			[self recordMatch: #(6 25 38 ).
			self step.
			(currentCharacter = $!! or: 
					[(currentCharacter between: $% and: $&) or: 
							[(currentCharacter between: $* and: $-) or: 
									[currentCharacter = $/ or: 
											[(currentCharacter between: $< and: $@) or: 
													[currentCharacter = $\ 
														or: [currentCharacter = $| or: [currentCharacter = $~]]]]]]]) 
				ifTrue: 
					[
					[self recordMatch: #binarySymbol.
					self step.
					currentCharacter = $!! or: 
							[(currentCharacter between: $% and: $&) or: 
									[(currentCharacter between: $* and: $-) or: 
											[currentCharacter = $/ or: 
													[(currentCharacter between: $< and: $@) or: 
															[currentCharacter = $\ 
																or: [currentCharacter = $| or: [currentCharacter = $~]]]]]]]] 
							whileTrue.
					^ self reportLastMatch].
			^ self reportLastMatch].
	currentCharacter = $> 
		ifTrue: 
			[self recordMatch: #(7 25 38 ).
			self step.
			(currentCharacter = $!! or: 
					[(currentCharacter between: $% and: $&) or: 
							[(currentCharacter between: $* and: $-) or: 
									[currentCharacter = $/ or: 
											[(currentCharacter between: $< and: $@) or: 
													[currentCharacter = $\ 
														or: [currentCharacter = $| or: [currentCharacter = $~]]]]]]]) 
				ifTrue: 
					[
					[self recordMatch: #binarySymbol.
					self step.
					currentCharacter = $!! or: 
							[(currentCharacter between: $% and: $&) or: 
									[(currentCharacter between: $* and: $-) or: 
											[currentCharacter = $/ or: 
													[(currentCharacter between: $< and: $@) or: 
															[currentCharacter = $\ 
																or: [currentCharacter = $| or: [currentCharacter = $~]]]]]]]] 
							whileTrue.
					^ self reportLastMatch].
			^ self reportLastMatch].
	currentCharacter = $[ ifTrue: [^ self recordAndReportMatch: #(1 38 )].
	currentCharacter = $] ifTrue: [^ self recordAndReportMatch: #(33 38 )].
	currentCharacter = $^ ifTrue: [^ self recordAndReportMatch: #(4 38 )].
	currentCharacter = $_ ifTrue: [^ self recordAndReportMatch: #(26 38 )].
	currentCharacter = ${ ifTrue: [^ self recordAndReportMatch: #(5 38 )].
	currentCharacter = $| 
		ifTrue: 
			[self recordMatch: #(9 25 38 ).
			self step.
			(currentCharacter = $!! or: 
					[(currentCharacter between: $% and: $&) or: 
							[(currentCharacter between: $* and: $-) or: 
									[currentCharacter = $/ or: 
											[(currentCharacter between: $< and: $@) or: 
													[currentCharacter = $\ 
														or: [currentCharacter = $| or: [currentCharacter = $~]]]]]]]) 
				ifTrue: 
					[
					[self recordMatch: #binarySymbol.
					self step.
					currentCharacter = $!! or: 
							[(currentCharacter between: $% and: $&) or: 
									[(currentCharacter between: $* and: $-) or: 
											[currentCharacter = $/ or: 
													[(currentCharacter between: $< and: $@) or: 
															[currentCharacter = $\ 
																or: [currentCharacter = $| or: [currentCharacter = $~]]]]]]]] 
							whileTrue.
					^ self reportLastMatch].
			^ self reportLastMatch].
	currentCharacter = $} ifTrue: [^ self recordAndReportMatch: #(34 38 )].
	^ self reportLastMatch! !

!SqueakScanner methodsFor: 'generated-tokens' stamp: 'ms 4/7/2007 03:32'!
stringId
	^21! !

!SqueakScanner methodsFor: 'token handling' stamp: 'ajh 7/16/2004 10:57'!
variableAssignment

	outputStream skip: -2.
	stream skip: -2.
	matchActions _ {self nameId}.
	self createTokenFor: outputStream contents.
! !

!SqueakScanner methodsFor: 'token handling' stamp: 'ms 5/10/2007 20:07'!
whitespace
	| value  |
	value := outputStream contents.
	previousToken := (SqueakToken 
		value: value 
		start: start 
		id: #whitespace 
		prevToken: previousToken).
	^super whitespace. "eats the whitespace"
! !

!AttachableFileStream methodsFor: '*coral' stamp: 'ms 10/1/2006 18:32'!
readUpToNewLine
	
	"Answer a subcollection from the current access position through the last element
	of the receiver. This is slower than the method in StandardFileStream, but it
	works with pipes which always answer true to #atEnd."

	| newStream c |
	newStream := WriteStream on: (buffer1 species new: 100).
	[self atEnd not 
			and: [(c := self next).
				   c ~= Character cr and: [c ~= Character lf]]] 
		whileTrue: [newStream nextPut: c].
	^ newStream contents
	
	! !

!WindowsProcess methodsFor: '*coral' stamp: 'ms 10/5/2006 14:16'!
newLineInConsole
	
	^String cr, String lf! !

Parser2 subclass: #ParserCorrection
	instanceVariableNames: 'comments'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Coral'!

!ParserCorrection class methodsFor: 'instance creation' stamp: 'ms 8/28/2006 14:07'!
scope: aScope
	
	^self new scope: aScope; yourself! !

!ParserCorrection methodsFor: 'accessing' stamp: 'ms 8/28/2006 14:36'!
scope: aScope

	scope := aScope.
	doitFlag := false! !

!RiscOSProcess methodsFor: '*coral' stamp: 'ms 10/5/2006 14:15'!
newLineInConsole
	
	^String lf! !

!OS2Process methodsFor: '*coral' stamp: 'ms 10/5/2006 14:14'!
newLineInConsole
	
	^String cr, String lf! !
CoralREADME initialize!
FmFileEntry initialize!
ScriptInterpreter initialize!
SqueakParser initialize!
